/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include "buttonbar.h"

updatezm (int z)
{
  Arg args[1];
  char label[10];
  sprintf (label, "%d%%", z);
  XtSetArg (args[0], XtNstring, label);
  XtSetValues (zm, args, 1);
  cb_setzm (z);
}

setzmlabel (int z)
{
  Arg args[1];
  char label[10];
  sprintf (label, "%d%%", z);
  XtSetArg (args[0], XtNstring, label);
  XtSetValues (zm, args, 1);
}

void
z200 ()
{
  updatezm (200);
}
void
z150 ()
{
  updatezm (150);
}
void
z120 ()
{
  updatezm (120);
}
void
z110 ()
{
  updatezm (110);
}
void
z100 ()
{
  updatezm (100);
}
void
z90 ()
{
  updatezm (90);
}
void
z80 ()
{
  updatezm (80);
}
void
z75 ()
{
  updatezm (75);
}
void
z60 ()
{
  updatezm (60);
}

void
z50 ()
{
  updatezm (50);
}
void
z25 ()
{
  updatezm (25);
}

static struct buttonEntry ButtonLineEntries[] =
{
  "newFile", "folder2", m_nfile,
  "openFile", "folder2", X11m_ofile,
  "saveFile", "folder2", X11m_sfile,
  "printFile", "folder2", X11m_print,
  "cut", "folder2", mcut,
  "copy", "folder2", mcpy,
  "paste", "folder2", mpst,
  "brush", "folder2", mbrsh,
  "plot", "folder2", m_creaplt,
  "sum", "folder2", m_sum,
  "sorta", "folder2", m_sorta,
  "sortd", "folder2", m_sortd,

};

Buttonbar *
newbuttonbar (buttonbar)
     Widget buttonbar;
{
  int i;
  char **bits[20];
  Arg args[20];
  register int n;
  Buttonbar *bb_obj;
  bb_obj = (Buttonbar *) absmalloc (sizeof (Buttonbar), "newbuttonbar:bb_obj ");

  bits[0] = newfile_xpm;
  bits[1] = openfile_xpm;
  bits[2] = savefile_xpm;
  bits[3] = printfile_xpm;
  bits[4] = cut_xpm;
  bits[5] = copy_xpm;
  bits[6] = paste_xpm;
  bits[7] = brush_xpm;
  bits[8] = plot_xpm;
  bits[9] = sum_xpm;
  bits[10] = sorta_xpm;
  bits[11] = sortd_xpm;

  for (i = 0; i < XtNumber (ButtonLineEntries); i++)
    make_button_pixmap (buttonbar,
			ButtonLineEntries[i].name,
			bits[i],
			ButtonLineEntries[i].function, NULL);

  n = 0;
  XtSetArg (args[n], XtNstring, "100%");
  n++;
  XtSetArg (args[n], XtNwidth, 50);
  n++;
  XtSetArg (args[n], XtNeditType, XawtextEdit);
  n++;
  XtSetArg (args[n], XtNbackground, 1);
  n++;
  XtSetArg (args[n], XtNforeground, 0);
  n++;
  zm = XtCreateManagedWidget ("zm", asciiTextWidgetClass, buttonbar, args, n);
  XawTextDisplayCaret (zm, False);
  XtAddEventHandler (zm, KeyReleaseMask, False, cb_ZoomChange, zm);

  make_zm_btn (buttonbar);

  return bb_obj;
}

make_zm_btn (bar)
     Widget bar;
{
  Widget btn, menu_popup;
  btn = (Widget) make_bar_button_pixmap (bar, "zmbtn", list_xpm);

  menu_popup = (Widget) make_popup (btn,
			 "Z", "Z", zmMenuEntries, XtNumber (zmMenuEntries));

}
