/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#include "callback.h"

#define AW ActivWks

int
cb_changesht (sht)
     int sht;
{

  if (applic_changesht (sht))
    return -1;
  flag2 = 0;
  flag3 = 0;
  rstsel (0, 0, 0);
  xrepnt ();

}

int
selectingto0 ()
{
  flag2 = 0;
  flag3 = 0;
}

void
a_update ()

{
  if (flag4 && flag5)
    {
      set_form (ty, tx, getstring (Letxt));
    }
  if (flag4)
    {
      xdrwcl (ty, tx, 0);
      setstring (Letxt, "");
      XtSetSensitive (Letxt, False);
      XtSetKeyboardFocus (toplevel, drw);
      XawTextDisplayCaret (Letxt, False);
      flag4 = 0;
      flag5 = 0;
      rstsel (0, 0, 0);
    }
  return;

}

void
echfct (char *buf)
{
  char *label;
  insstr (Letxt, buf);
  mvinspt (Letxt, -1);
}

void
cbtup (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  a_update ();
  flechi--;
  if (flechi < 1)
    flechi = 1;
  flechmove = 1;
  cbdb1up (drw, event, params, num_params);
}

void
cbtdown (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  a_update ();
  flechi++;
  if (flechj > AW->nlin)
    flechj = AW->nlin;
  flechmove = 1;
  cbdb1up (drw, event, params, num_params);
}

void
cbtleft (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  long p;

  p = XawTextGetInsertionPoint (Letxt);
  if (p > 0)
    {
      p--;
      XawTextSetInsertionPoint (Letxt, p);
      return;
    }

  left = 1;
  a_update ();
  flechj--;
  if (flechj < 1)
    flechj = 1;
  flechmove = 1;
  cbdb1up (drw, event, params, num_params);
}

void
cbtright (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  long p;
  int l;

  l = strlen (getstring (Letxt));
  p = XawTextGetInsertionPoint (Letxt);
  if (p < l)
    {
      p++;
      XawTextSetInsertionPoint (Letxt, p);
      return;
    }

  a_update ();
  flechj++;
  if (flechj > AW->ncol)
    flechj = AW->ncol;
  flechmove = 1;
  cbdb1up (drw, event, params, num_params);
}

void
cbdel (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  long p;
  int l, i;
  char *str;
  char tmp[256];
  Widget t;

  if (flag4)
    t = Letxt;
  else
    t = w;

  str = getstring (t);
  if (str == NULL)
    return;
  strcpy (tmp, str);

  l = strlen (str);
  p = XawTextGetInsertionPoint (t);
  if (p == l)
    return;

  for (i = p; i < l - 1; i++)
    tmp[i] = tmp[i + 1];
  tmp[l - 1] = '\0';

  setstring (t, tmp);
  XawTextSetInsertionPoint (t, p);
  return;
}

void
cbbak (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  long p;
  int l, i;
  char *str;
  char tmp[256];
  Widget t;

  if (flag4)
    t = Letxt;
  else
    t = w;

  str = getstring (t);
  if (str == NULL)
    return;
  strcpy (tmp, str);

  l = strlen (str);
  p = XawTextGetInsertionPoint (t);
  if (p == 0)
    return;

  for (i = p - 1; i < l - 1; i++)
    tmp[i] = tmp[i + 1];

  tmp[l - 1] = '\0';
  setstring (t, tmp);
  XawTextSetInsertionPoint (t, p - 1);
  return;
}

void
cbdmv (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{

  char *label;
  Drwing *dr;
  int x, y;
  int xmin, xmax, ymin, ymax;
  int i1, i2, j1, j2, k;

  if (FLAG1 != VAL36)
    return;
  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  if (drwingmode)
    {

      mvx = x;
      mvy = y;
      absmvx = mvx + AW->cw[AW->cc];
      absmvy = mvy + AW->lh[AW->ll];

      if (drwingmode == VAL41)
	{
	  for (k = 0; k < getndr (); k++)
	    {
	      dr = (Drwing *) getdr (k);
	      if (drwing_pnt (dr, absmvx, absmvy, 5, 5) && ActivDrwing != dr)
		{
		  ActivateDrwing (dr);
		  clearnflush ();
		  drwselect ();
		}
	    }
	}
      return;
    }

  if (is_selecting ())
    {
      get_select (&i1, &j1, &i2, &j2);

      ijtoxy (i1, j1, &xmin, &ymin);
      ijtoxy (i2 + 1, j2 + 1, &xmax, &ymax);
      if (xmin < x && x < xmax && ymin - 10 < y && y < ymin + 10)
	{
	  if (VAL1 != VAL3 && VAL1 != VAL35)
	    {
	      tohand (drw);
	      VAL1 = VAL3;
	    }
	}
      else if (xmax - 5 < x && x < xmax + 5 && ymax - 5 < y && y < ymax + 5)
	{
	  if (VAL1 != VAL21 && VAL1 != VAL35)
	    {
	      tobotrig (drw);
	      VAL1 = VAL21;
	    }
	}
      else if (VAL1 == VAL3 || VAL1 == VAL21)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
    }

  if (flag2)
    {
      if (xa - 4 <= x && x <= xa + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL4)
	    TurnOnBottomLeft (drw);
	  VAL1 = VAL4;
	}
      else if (VAL1 == VAL4)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL5)
	    tobotrig (drw);
	  VAL1 = VAL5;
	}
      else if (VAL1 == VAL5)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if (xa - 4 <= x && x <= xa + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL15)
	    totopleft (drw);
	  VAL1 = VAL15;
	}
      else if (VAL1 == VAL15)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL7)
	    totrig (drw);
	  VAL1 = VAL7;
	}
      else if (VAL1 == VAL7)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if ((xa + xb) / 2 - 4 <= x && x <= (xa + xb) / 2 + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL6)
	    tobsd (drw);
	  VAL1 = VAL6;
	}
      else if (VAL1 == VAL6)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && (yb + ya) / 2 - 4 <= y && y <= (yb + ya) / 2 + 4)
	{
	  if (VAL1 != VAL17)
	    TurnOnRightSide (drw);
	  VAL1 = VAL17;
	}
      else if (VAL1 == VAL17)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if ((xa + xb) / 2 - 4 <= x && x <= (xa + xb) / 2 + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL18)
	    TurnOnTopSide (drw);
	  VAL1 = VAL18;
	}
      else if (VAL1 == VAL18)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
      if (xa - 4 <= x && x <= xa + 4 && (yb + ya) / 2 - 4 <= y && y <= (yb + ya) / 2 + 4)
	{
	  if (VAL1 != VAL16)
	    TurnOnLeftSide (drw);
	  VAL1 = VAL16;
	}
      else if (VAL1 == VAL16)
	{
	  toffcur (drw);
	  VAL1 = VAL2;
	}
    }
  if (w == colind)
    {
      tohand (colind);
    }
  if (w == linind)
    {
      tohand (linind);
    }
}

void
cbdn2down (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  dwnx = event->xbutton.x * 100 / zm;
  dwny = event->xbutton.y * 100 / zm;

}

void
cb_DocBtn2Motion (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i0, j0, i1, j1;

  mvx = event->xbutton.x * 100 / zm;
  mvy = event->xbutton.y * 100 / zm;

  if (mvx != dwnx || mvy != dwny)
    {
      xytoij (dwnx, dwny, &i0, &j0);
      xytoij (mvx, mvy, &i1, &j1);
      i0 = AW->ll - (i1 - i0);
      j0 = AW->cc - (j1 - j0);
      if (i0 < 1)
	i0 = 1;
      if (j0 < 1)
	j0 = 1;
      cbrepnt (i0, j0, Width, Height);
    }

  dwnx = mvx;
  dwny = mvy;

}

void
cbdb2up (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i0, j0, i1, j1;

  upx = event->xbutton.x * 100 / zm;
  upy = event->xbutton.y * 100 / zm;

  if (upx != dwnx || upy != dwny)
    {
      xytoij (dwnx, dwny, &i0, &j0);
      xytoij (upx, upy, &i1, &j1);
      i0 = AW->ll - (i1 - i0);
      j0 = AW->cc - (j1 - j0);

      if (i0 < 1)
	i0 = 1;
      if (j0 < 1)
	j0 = 1;
      cbrepnt (i0, j0, Width, Height);
    }

}

void
cb_PageHome (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{

  cbrepnt (1, 1, Width, Height);
}

void
cbpgup (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cls (&i1, &j1, &i2, &j2);
  h = i2 - i1;
  i1 -= h + 2;
  if (i1 < 1)
    i1 = 1;
  cbrepnt (i1, -1, Width, Height);
}

void
cbpgdwn (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cls (&i1, &j1, &i2, &j2);
  cbrepnt (i2 - 2, -1, Width, Height);
}

void
cbpgleft (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cls (&i1, &j1, &i2, &j2);
  h = j2 - j1;
  j1 -= h + 2;
  if (j1 < 1)
    j1 = 1;

  cbrepnt (-1, j1, Width, Height);
}

void
cbpgrig (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cls (&i1, &j1, &i2, &j2);

  cbrepnt (-1, j2 - 2, Width, Height);
}

void
cbdb1up (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  Arg args[5];
  register int n;
  char *label;
  char buf[16];
  char buf1[16];
  int x, y;
  int i, j;
  Chrt *gr;
  Drwing *dr;

  if (!flechmove)
    {
      x = event->xbutton.x * 100 / zm;
      y = event->xbutton.y * 100 / zm;
      upx = x;
      upy = y;
      aupx = upx + AW->cw[AW->cc];
      aupy = upy + AW->lh[AW->ll];

      xytoij (x, y, &i, &j);
      upi = i;
      upj = j;
    }

  if (drwingmode)
    {
      if (drwingmode == VAL42)
	{
	  drwingmode = VAL41;
	  TurnOnPencil (drw);
	  FLAG1 = VAL36;
	  xrepnt ();
	  return;
	}

      if (drwingmode == VAL39)
	{
	  drwingmode = 0;
	  FLAG1 = VAL36;
	  drplt ();
	  return;
	}
      drwingmode = VAL41;
      TurnOnPencil (drw);
      FLAG1 = VAL36;
      return;
    }

  switch (FLAG2)
    {
    case VAL30:
      {
	VAL1 = VAL2;
	toffcur (drw);
	FLAG1 = VAL36;
	drplt ();
	break;
      }
    case VAL10:
      {
	if (VAL1 == VAL14)
	  {
	    VAL1 = VAL2;
	    toffcur (drw);
	    gr = (Chrt *) getlastgra ();
	    gr->x = grx;
	    gr->y = gry;
	    gr->h = grh;
	    gr->w = grw;
	    plot ();
	    xrepnt ();
	  }
	if (VAL1 == VAL4 ||
	    VAL1 == VAL5 ||
	    VAL1 == VAL7 ||
	    VAL1 == VAL18 ||
	    VAL1 == VAL17 ||
	    VAL1 == VAL6 ||
	    VAL1 == VAL16 ||
	    VAL1 == VAL15)
	  {
	    VAL1 = VAL2;
	    toffcur (drw);
	    gr = (Chrt *) getlastgra ();
	    gr->x = grx;
	    gr->y = gry;
	    gr->h = grh;
	    gr->w = grw;
	    resizegra ();
	    plot ();
	    xrepnt ();
	  }
	break;
      }
    case VAL11X:
      {
	if (FLAG1 == VAL20)
	  {
	    selectlin (i);
	    li = 0;
	    cj = 0;
	    break;
	  }
	else
	  {
	    xrepnt ();
	    cj = 0;
	    li = 0;
	    break;
	  }
      }
    case VAL12:
      {
	if (FLAG1 == VAL20)
	  {
	    selectcol (j);
	    li = 0;
	    cj = 0;
	    break;
	  }
	else
	  {
	    xrepnt ();
	    cj = 0;
	    li = 0;
	    break;
	  }
      }
    case VAL13:
      {
	n2a (buf, dwni, dwnj);
	if (TEXT_WIDGET == Letxt)
	  insstr (Letxt, buf);
	else
	  {
	    if (DIALOG_WIDGET != NULL)
	      XtManageChild (DIALOG_WIDGET);
	    setstring (TEXT_WIDGET, buf);
	  }

	if (dwni != i || dwnj != j)
	  {
	    n2a (buf1, i, j);

	    if (TEXT_WIDGET != Letxt)
	      {
		sprintf (buf, "%s:%s", buf, buf1);
		setstring (TEXT_WIDGET, buf);
	      }
	    else
	      {
		sprintf (buf, ":%s", buf1);
		insstr (Letxt, buf);
	      }
	  }
	TEXT_WIDGET = Letxt;
	rstsel (dwni, dwnj, 1);
	FLAG2 = VAL22;
	FLAG1 = VAL36;

	break;
      }
    case VAL19:
      {
	TurnOffMove (drw);
	VAL1 = VAL2;
	if (dwni - i || dwnj - j)
	  {
	    mvsel (dwni, dwnj, i, j, 1);

	    upi += i - dwni;
	    upj += j - dwnj;
	    dwni = i;
	    dwnj = j;
	    break;
	  }
	else
	  {
	    rstsel (dwni, dwnj, 1);
	    FLAG2 = VAL22;
	  }

      }
    default:
      {

	if (flechmove)
	  {
	    i = flechi;
	    j = flechj;

	  }
	if (!flechmove)
	  {
	    flechi = i;
	    flechj = j;
	  }
	ijtoxy (i, j, &x, &y);
	if (is_selecting ())
	  {
	    makebrush ();
	    toffcur (drw);
	    VAL1 = VAL2;
	    break;
	  }
	if (w == drw)
	  {
	    n = 0;
	    XtSetArg (args[n], XtNx, x);
	    n++;
	    XtSetArg (args[n], XtNy, y);
	    n++;
	    label = (char *) get_form (i, j);
	    if (label != NULL)
	      setstring (Letxt, label);
	    else
	      setstring (Letxt, "");

	    left = 0;
	    setvisi (i, j);
	    if (is_selecting () || flag2 || flag3)
	      {
		rstsel (0, 0, 0);
		flag2 = 0;
		flag3 = 0;
		xrepnt ();
	      }
	    xdrwcl (i, j, 2);
	    ActivCl = (Cl *) appliccl (i, j, 1);
	    tx = j;
	    ty = i;
	    XtSetSensitive (Letxt, True);
	    XtSetKeyboardFocus (toplevel, Letxt);
	    XawTextDisplayCaret (Letxt, True);
	    flag4 = 1;
	    flag5 = 0;
	  }
      }
    }
  FLAG1 = VAL36;
  FLAG2 = 0;
  FLAG4 = 0;

}

void
cb_TextChange ()

{
  if (flag4 && !flechmove)
    {
      flag5 = 1;
      xdrwcl (ty, tx, 3);
    }
  flechmove = 0;
}

void
cb_TextReturn (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  a_update ();
}

void
cb_BtnOk ()
{

  a_update ();
}

void
cb_BtnCancel ()
{
  if (flag4)
    {
      xdrwcl (ty, tx, 0);
      setstring (Letxt, "");
      XtSetSensitive (Letxt, False);
      XawTextDisplayCaret (Letxt, False);
      flag4 = 0;
      rstsel (0, 0, 0);
      return;
    }
}

void
cb_DocBtn1Motion (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i, j, k;
  int x, y;
  int dx, dy;
  Chrt *gr;
  Drwing *dr;

  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  mvx = x;
  mvy = y;
  absmvx = mvx + AW->cw[AW->cc];
  absmvy = mvy + AW->lh[AW->ll];
  xytoij (x, y, &i, &j);
  movei = i;
  movej = j;

  if (drwingmode)
    {
      if (drwingmode == VAL38)
	drwingmode = VAL39;

      if (drwingmode == VAL39)
	{
	  setvisi (i, j);
	  drplt ();
	  return;
	}

      if (drwingmode == VAL42)
	{
	  setvisi (i, j);
	  dx = x - lx;
	  dy = y - ly;

	  if (VAL1 == VAL14)
	    {
	      dr = ActivDrwing;
	      dr->x1 += dx;
	      dr->y1 += dy;
	      dr->x2 += dx;
	      dr->y2 += dy;
	    }
	  else if (VAL1 == VAL5)
	    {
	      dr = ActivDrwing;
	      dr->x2 += dx;
	      dr->y2 += dy;
	    }
	  else if (VAL1 == VAL15)
	    {
	      dr = ActivDrwing;
	      dr->x1 += dx;
	      dr->y1 += dy;
	    }
	  lx = x;
	  ly = y;
	  drplt ();
	  cpypix ();
	}
      return;
    }

  switch (FLAG2)
    {
    case VAL30:
      {
	setvisi (i, j);
	drplt ();
	break;
      }
    case VAL10:
      {
	setvisi (i, j);
	dx = x - lx;
	dy = y - ly;

	if (VAL1 == VAL2)
	  {
	    tomv (drw);
	    VAL1 = VAL14;
	  }
	if (VAL1 == VAL14)
	  {
	    grx += dx;
	    gry += dy;
	    lx = x;
	    ly = y;

	    cpypix ();
	    break;
	  }
	if (VAL1 == VAL4)
	  {
	    grx += dx;
	    grw -= dx;
	    grh += dy;
	  }
	if (VAL1 == VAL5)
	  {
	    grw += dx;
	    grh += dy;
	  }
	if (VAL1 == VAL15)
	  {
	    grx += dx;
	    gry += dy;
	    grw -= dx;
	    grh -= dy;
	  }
	if (VAL1 == VAL7)
	  {
	    gry += dy;
	    grw += dx;
	    grh -= dy;
	  }
	if (VAL1 == VAL16)
	  {
	    grx += dx;
	    grw -= dx;
	  }
	if (VAL1 == VAL17)
	  {
	    grw += dx;
	  }
	if (VAL1 == VAL18)
	  {
	    gry += dy;
	    grh -= dy;
	  }
	if (VAL1 == VAL6)
	  {
	    grh += dy;
	  }
	if (grw < 50)
	  grw = 50;
	if (grh < 40)
	  grh = 40;
	lx = x;
	ly = y;
	cpypix ();

	break;
      }
    case VAL11X:
      {
	if ((ly - y) * (ly - y) < 9)
	  break;
	dy = y - ly;
	ly = y;

	if (dy < 0 && AW->lh[li] + dy - AW->lh[li - 1] < 10)
	  break;
	for (i = li; i <= AW->nlin; i++)
	  AW->lh[i] += dy;
	bdrepnt (VAL11X);
	break;
      }

    case VAL12:
      {
	if ((lx - x) * (lx - x) < 9)
	  break;
	dx = x - lx;
	lx = x;

	if (dx < 0 && AW->cw[cj] + dx - AW->cw[cj - 1] < 10)
	  break;
	for (j = cj; j <= AW->ncol; j++)
	  AW->cw[j] += dx;
	bdrepnt (VAL12);
	break;
      }
    case VAL19:
      {
	if (!(lsti - i) && !(lstj - j))
	  break;
	tomv (drw);
	mvsel (dwni, dwnj, i, j, 0);
	setvisi (i, j);
	break;
      }
    case VAL13:
      {
	if (FLAG1 == VAL20)
	  selection (dwni, dwnj);
	else
	  {
	    xytoij (x, y, &i, &j);
	    if (i != 0 && j != 0)
	      selection (i, j);
	    setvisi (i, j);
	  }
      }
    case VAL22:
      {

	flag2 = 0;
	flag3 = 0;
	if (FLAG1 == VAL20)
	  selection (dwni, dwnj);
	else
	  {
	    xytoij (x, y, &i, &j);
	    if (i != 0 && j != 0)
	      selection (i, j);
	    setvisi (i, j);
	  }
      }
    }

  FLAG1 = VAL37;
  lsti = i;
  lstj = j;

}

void
cbdb1down (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  int i, j, k;
  int x, y;
  Chrt *gr;
  Drwing *dr;

  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  dwnx = x;
  dwny = y;
  absdwnx = dwnx + AW->cw[AW->cc];
  absdwny = dwny + AW->lh[AW->ll];

  xytoij (dwnx, dwny, &i, &j);

  dwni = i;
  dwnj = j;
  lsti = i;
  lstj = j;

  FLAG1 = VAL20;

  if (drwingmode)
    {
      if (flag4)
	a_update ();
      if (drwingmode == VAL41 && ActivDrwing != NULL)
	{
	  drwingmode = VAL42;
	  lx = x;
	  ly = y;
	  if (abs (ActivDrwing->x1 - absdwnx) <= 5 && abs (ActivDrwing->y1 - absdwny) <= 5)
	    {
	      totopleft (drw);
	      VAL1 = VAL15;
	    }
	  else if (abs (ActivDrwing->x2 - absdwnx) <= 5 && abs (ActivDrwing->y2 - absdwny) <= 5)
	    {
	      tobotrig (drw);
	      VAL1 = VAL5;
	    }
	  else
	    {
	      tomv (drw);
	      VAL1 = VAL14;
	    }
	}
      return;
    }

  if (FLAG2 == VAL30)
    return;

  if (FLAG2 == VAL13)
    {
      return;
    }
  if (VAL1 == VAL3)
    {
      FLAG2 = VAL19;
      flag2 = 0;
      flag3 = 0;
      return;
    }
  if (VAL1 == VAL21)
    {
      FLAG2 = VAL22;
      return;
    }
  if (VAL1 == VAL4 ||
      VAL1 == VAL5 ||
      VAL1 == VAL7 ||
      VAL1 == VAL18 ||
      VAL1 == VAL17 ||
      VAL1 == VAL6 ||
      VAL1 == VAL16 ||
      VAL1 == VAL15)
    {
      lx = dwnx;
      ly = dwny;
      if (flag2)
	FLAG2 = VAL10;
      if (flag3)
	FLAG2 = VAL9ING;
      return;
    }
  if (w == colind)
    {
      FLAG2 = VAL12;
      xytocloij (dwnx, dwny, &i, &j);
      cj = j;
      lx = dwnx;
      flag2 = 0;
      flag3 = 0;
      return;
    }
  if (w == linind)
    {
      FLAG2 = VAL11X;
      xytocloij (dwnx, dwny, &i, &j);
      li = i;
      ly = dwny;
      flag2 = 0;
      flag3 = 0;
      return;
    }
  if (flag4 && flag5)
    {

      FLAG2 = VAL13;
      rstsel (i, j, 0);
      flag2 = 0;
      flag3 = 0;
      return;
    }
  if (flag4 && !flag5)
    {
      a_update ();
    }
  for (k = 0; k < getngr (); k++)
    {
      gr = (Chrt *) getgr (k);
      grx = gr->x;
      gry = gr->y;
      grw = gr->w;
      grh = gr->h;
      if (dwnx > grx - AW->cw[AW->cc] && dwny > gry - AW->lh[AW->ll] &&
	  dwnx < (grx - AW->cw[AW->cc]) + (grw) && dwny < (gry - AW->lh[AW->ll]) + (grh))
	{
	  lx = dwnx;
	  ly = dwny;
	  rstsel (i, j, 1);
	  if (flag3)
	    {
	      flag3 = 0;
	      xrepnt ();
	    };
	  if (flag2 != k + 1)
	    {
	      flag2 = k + 1;
	      drwselect ();
	    }
	  setactivgra (k);
	  FLAG2 = VAL10;
	  return;
	}
    }
  flag3 = 0;
  if (flag2)
    {
      flag2 = 0;
      xrepnt ();
    };

  rstsel (0, 0, 1);
  FLAG2 = VAL22;
}

void
mpst (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  if (VAL24 == VAL22)
    paste ();
  if (VAL24 == VAL10)
    {
      pastegra ();
      xrepnt ();
    }
  if (VAL24 == VAL9ING)
    {
      pastedra ();
      xrepnt ();
    }
}

void
mbrsh (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  setbrsh (appliccl (dwni, dwnj));
  tospray (drw);
  VAL1 = VAL35;

}

void
m_sum (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  char buf[128];
  char buf2[8];
  int col, startr, endr;
  char *txt;

  if (!flag4)
    return;
  if (ActivCl->r < 2)
    return;

  col = ActivCl->c;
  endr = ActivCl->r - 1;
  startr = endr;

  txt = (char *) get_text (startr, col);
  if (txt == NULL)
    return;

  while (startr > 1 && txt != NULL)
    {
      startr--;
      txt = (char *) get_text (startr, col);

    }
  startr++;

  sprintf (buf, "+sum (");
  n2a (buf2, startr, col);
  strcat (buf, buf2);
  strcat (buf, ":");
  n2a (buf2, endr, col);
  strcat (buf, buf2);
  strcat (buf, ")");

  insstr (Letxt, buf);

}

void
m_sorta (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  makesorta ();
}

void
m_sortd (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  makesortd ();
}

void
mcpy (w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int *num_params;
{
  if (flag2 == 1)
    {
      cpygr (getactivgra ());
      VAL24 = VAL10;
    }
  else if (drwingmode)
    {
      cpydr (getactivdra ());
      VAL24 = VAL9ING;
    }
  else
    {
      copy ();
      VAL24 = VAL22;
    }

}

void
mcut ()
{
  if (flag2 == 1)
    {
      cutgra (getactivgra ());
      flag2 = 0;
      xrepnt ();
      VAL24 = VAL10;
    }
  else if (drwingmode)
    {
      cutdra (getactivdra ());
      flag3 = 0;
      xrepnt ();
      VAL24 = VAL9ING;
    }
  else
    {
      cut ();
      VAL24 = VAL22;
    }
}

void
cb_DocDelete ()
{
  mcut ();
}

void
m_border ()
{
  border ();
}

void
m_incr ()
{
  incr ();
}

void
m_color ()
{
  color ();
}

void
m_fit ()
{
  fit ();
  xrepnt ();
}

void
m_ofac (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
}

void
m_ofile (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char *buf;
  openfl (buf);
}

void
m_nfile (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  newdoc (NULL);
}

void
m_as (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  wkb_as (ActivWkb, NULL);
}

void
m_ds (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{

}

void
m_changewin (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  rstsel (0, 0, 0);
  Actwkb2 (XtName (w));

}

void
m_sfile (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  savefl ();
}

void
m_sasfile (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char *buf;
  saveasfile (buf);
}

void
m_printfl (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char *buf;
  printfl (buf);
}
void
m_insertfl (w, client_data, call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char *buf;
  insertfl (buf);
}

void
m_exportfile (w, client_data,

	      call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char *buf;
  exportfile (buf);
}

void
m_update ()
{
  update (1);
}

void
mcpyd ()
{

  cpyd ();
}
void
mcpyr ()
{

  cpyr ();
}

void
m_creaplt ()
{
  FLAG4 = VAL30;
  FLAG2 = VAL30;
  drwingmode = 0;
  flag2 = 0;
  tocross (drw);
  return;
}

void
m_plotline ()
{

  FLAG4 = VAL31;
  tocross (drw);
  drwingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotrect ()
{
  FLAG4 = VAL32;
  tocross (drw);
  drwingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotarc ()
{
  FLAG4 = VAL33;
  tocross (drw);
  drwingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotcircle ()
{
  FLAG4 = VAL34;
  tocross (drw);
  drwingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}

void
m_editdrw ()
{
  drwingmode = VAL41;
  VAL1 = VAL23;
  TurnOnPencil (drw);
  flag2 = 0;
  rstsel (0, 0, 0);
}

void
m_exitdrw ()
{
  VAL1 = VAL2;
  toffcur (drw);
  drwingmode = 0;
}

drplt ()
{
  Chrt *gr;
  Drwing *dr;
  int centerx, centery, width, height, a1, a2;
  int pi = 90 * 64;

  if (FLAG1 == VAL36 || drwingmode == VAL40)
    {
      plotx = absdwnx;
      ploty = absdwny;
      ploth = aupy - absdwny;
      if (ploth < 0)
	{
	  ploth = -ploth;
	  ploty = aupy;
	}
      plotw = aupx - absdwnx;
      if (plotw < 0)
	{
	  plotw = -plotw;
	  plotx = aupx;
	}
      switch (FLAG4)
	{
	case VAL30:
	  {
	    gr = (Chrt *) newgra ();
	    if (plotw < 50)
	      plotw = 50;
	    if (ploth < 40)
	      ploth = 40;
	    if (plotx < 0)
	      plotx = 0;
	    if (ploty < 0)
	      ploty = 0;

	    gr->x = plotx;
	    gr->y = ploty;
	    gr->w = plotw;
	    gr->h = ploth;
	    gr->pixmap = createpixmap (drw, plotw, ploth);
	    fillrectangle (dpy, gr->pixmap, 0, 0, 0, plotw, ploth, 0);
	    plot ();
	    cpypix ();
	    break;
	  }
	case VAL31:
	  {
	    dr = (Drwing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL31;
	    drwline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], upx, upy, 0, 0);
	    break;
	  }
	case VAL32:
	  {
	    dr = (Drwing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL32;
	    drwline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], upx, absdwny - AW->lh[AW->ll], 0, 0);
	    drwline (dpy, pixmap, 1, upx, absdwny, upx, upy, 0, 0);
	    drwline (dpy, pixmap, 1, upx, upy, absdwnx - AW->cw[AW->cc], upy, 0, 0);
	    drwline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], upy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], 0, 0);
	    break;
	  }
	case VAL33:
	  {
	    dr = (Drwing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL33;
	    centerx = absdwnx;
	    centery = absdwny;
	    width = 2 * abs (absdwnx - aupx);
	    height = 2 * abs (absdwny - aupy);

	    if (absdwnx <= aupx && absdwny <= aupy)
	      {
		a1 = 0;
		a2 = pi;
		centery += height / 2;
	      }
	    if (absdwnx >= aupx && absdwny <= aupy)
	      {
		a1 = -pi;
		a2 = pi;
		centerx -= width / 2;
	      }
	    if (absdwnx >= aupx && absdwny >= aupy)
	      {
		a1 = 2 * pi;
		a2 = pi;
		centery -= height / 2;
	      }
	    if (absdwnx <= aupx && absdwny >= aupy)
	      {
		a1 = pi;
		a2 = pi;
		centerx += width / 2;
	      }
	    drwarc
	      (dpy, pixmap, 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, a1, a2, 0, 0);
	    break;
	  }
	case VAL34:
	  {
	    dr = (Drwing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL34;
	    centerx = (absdwnx + aupx) / 2;
	    centery = (absdwny + aupy) / 2;
	    width = abs (absdwnx - aupx);
	    height = abs (absdwny - aupy);
	    drwarc
	      (dpy, pixmap, 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, 0, 360 * 64, 0, 0);
	    break;
	  }
	}
      FLAG4 = -1;
      TurnOffCross (drw);
      return;
    }
  else
    {
      clearnflush ();

      if (FLAG4 == VAL30 || FLAG4 == VAL10)
	{
	  drwline (dpy, XtWindow (drw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, absdwny - AW->lh[AW->ll]);
	  drwline (dpy, XtWindow (drw), 1, mvx, absdwny, mvx, mvy);
	  drwline (dpy, XtWindow (drw), 1, mvx, mvy, absdwnx - AW->cw[AW->cc], mvy);
	  drwline (dpy, XtWindow (drw), 1, absdwnx - AW->cw[AW->cc], mvy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll]);
	}

    }

  if (drwingmode == VAL39 || drwingmode == VAL42)
    {
      clearnflush ();

      switch (FLAG4)
	{
	case VAL31:
	  {
	    drwline (dpy, XtWindow (drw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, mvy);
	    break;
	  }
	case VAL32:
	  {
	    drwline (dpy, XtWindow (drw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, absdwny - AW->lh[AW->ll]);
	    drwline (dpy, XtWindow (drw), 1, mvx, absdwny - AW->lh[AW->ll], mvx, mvy);
	    drwline (dpy, XtWindow (drw), 1, mvx, mvy, absdwnx - AW->cw[AW->cc], mvy);
	    drwline (dpy, XtWindow (drw), 1, absdwnx - AW->cw[AW->cc], mvy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll]);
	    break;
	  }
	case VAL33:
	  {
	    aupx = mvx + AW->cw[AW->cc];
	    aupy = mvy + AW->lh[AW->ll];
	    centerx = absdwnx;
	    centery = absdwny;
	    width = 2 * abs (absdwnx - aupx);
	    height = 2 * abs (absdwny - aupy);
	    if (absdwnx <= aupx && absdwny <= aupy)
	      {
		a1 = 0;
		a2 = pi;
		centery += height / 2;
	      }
	    if (absdwnx >= aupx && absdwny <= aupy)
	      {
		a1 = -pi;
		a2 = pi;
		centerx -= width / 2;
	      }
	    if (absdwnx >= aupx && absdwny >= aupy)
	      {
		a1 = 2 * pi;
		a2 = pi;
		centery -= height / 2;
	      }
	    if (absdwnx <= aupx && absdwny >= aupy)
	      {
		a1 = pi;
		a2 = pi;
		centerx += width / 2;
	      }
	    drwarc
	      (dpy, XtWindow (drw), 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, a1, a2);

	    break;
	  }
	case VAL34:
	  {
	    aupx = mvx + AW->cw[AW->cc];
	    aupy = mvy + AW->lh[AW->ll];
	    centerx = (absdwnx + aupx) / 2;
	    centery = (absdwny + aupy) / 2;
	    width = abs (absdwnx - aupx);
	    height = abs (absdwny - aupy);
	    drwarc
	      (dpy, XtWindow (drw), 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height /
			   2) - AW->lh[AW->ll], width, height, 0, 360 * 64);
	    break;
	  }
	}
    }
}

drwselect ()
{
  int x1, x2, y1, y2, x;
  int i1, j1, i2, j2;
  Chrt *gr;
  Drwing *dr;

  if (drwingmode == VAL41 || drwingmode == VAL42)
    {
      dr = ActivDrwing;
      if (dr == NULL)
	{
	  return;
	}
      xa = dr->x1 - AW->cw[AW->cc];
      ya = dr->y1 - AW->lh[AW->ll];
      xb = dr->x2 - AW->cw[AW->cc];
      yb = dr->y2 - AW->lh[AW->ll];
      fillrectangle (dpy, XtWindow (drw), 1, xa - 4, ya - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xb - 4, yb - 4, 8, 8, 0);
      return;
    }

  if (flag2)
    {

      xa = grx - AW->cw[AW->cc] - 4;
      ya = gry - AW->lh[AW->ll] - 4;
      xb = grx - AW->cw[AW->cc] + grw + 4;
      yb = gry - AW->lh[AW->ll] + grh + 4;
      drwline (dpy, XtWindow (drw), 1, xa, ya, xb, ya);
      drwline (dpy, XtWindow (drw), 1, xb, ya, xb, yb);
      drwline (dpy, XtWindow (drw), 1, xb, yb, xa, yb);
      drwline (dpy, XtWindow (drw), 1, xa, yb, xa, ya);
      fillrectangle (dpy, XtWindow (drw), 1, xa - 4, ya - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xa - 4, yb - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xb - 4, ya - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xb - 4, yb - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, (xa + xb) / 2, ya - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, (xa + xb) / 2, yb - 4, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xa - 4, (ya + yb) / 2, 8, 8, 0);
      fillrectangle (dpy, XtWindow (drw), 1, xb - 4, (ya + yb) / 2, 8, 8, 0);

      return;
    }

  if (!get_select (&i1, &j1, &i2, &j2))
    return;

  if (i2 >= i1 && j2 >= j1)
    {
      i2++;
      j2++;
    }
  if (i2 < i1 && j2 >= j1)
    {
      j2++;
      i1++;
    }
  if (i2 >= i1 && j2 < j1)
    {
      i2++;
      j1++;
    }
  if (i2 < i1 && j2 < j1)
    {
      i1++;
      j1++;
    }
  ijtoxy (i1, j1, &x1, &y1);
  ijtoxy (i2, j2, &x2, &y2);

  if (x1 < 0)
    x1 = 0;
  if (x2 < 0)
    x2 = 0;
  if (y1 < 0)
    y1 = 0;
  if (y2 < 0)
    y2 = 0;
  if (x1 > Width)
    x1 = Width;
  if (x2 > Width)
    x2 = Width;
  if (y1 > Height)
    y1 = Height;
  if (y2 > Height)
    y2 = Height;

  setlineattributes (dpy, 1, 3, LineOnOffDash, CapButt, JoinBevel);
  drwline (dpy, XtWindow (drw), 1, x1, y1, x2, y1);
  drwline (dpy, XtWindow (drw), 1, x2, y1, x2, y2);
  drwline (dpy, XtWindow (drw), 1, x2, y2, x1, y2);
  drwline (dpy, XtWindow (drw), 1, x1, y2, x1, y1);
  setlineattributes (dpy, 1, 1, LineSolid, CapButt, JoinBevel);
  drwline (dpy, XtWindow (drw), 1, x2 - 5, y2 - 5, x2 + 5, y2 - 5);
  drwline (dpy, XtWindow (drw), 1, x2 + 5, y2 - 5, x2 + 5, y2 + 5);
  drwline (dpy, XtWindow (drw), 1, x2 + 5, y2 + 5, x2 - 5, y2 + 5);
  drwline (dpy, XtWindow (drw), 1, x2 - 5, y2 + 5, x2 - 5, y2 - 5);
  selX0 = x1;
  selY0 = y1;
}

int
cbsetup (_toplevel, drwzone, width, height, _colind, _linind, _text, _info)
     Widget _toplevel, drwzone, _colind, _linind, _text, _info;
     Dimension height, width;
{

  int i;
  int D;

  Height = height;
  Width = width;

  win = XtWindow (drwzone);
  dpy = XtDisplay (drwzone);
  screen = DefaultScreen (dpy);
  drw = drwzone;

  setXparam (dpy, win, _toplevel);

  Letxt = _text;
  TEXT_WIDGET = Letxt;
  linind = _linind;
  colind = _colind;
  toplevel = _toplevel;
  info = _info;

  D = DefaultDepth (dpy, DefaultScreen (dpy));
  pixmap = createpixmap (drw, width, height);
  setbackpix (drw, pixmap);
  setzm (100);
  linpixmap = createpixmap (linind, 30, height);
  colpixmap = createpixmap (colind, width, 20);
  setbackpix (linind, linpixmap);
  setbackpix (colind, colpixmap);

  init_applic ();
  xrepnt ();
  setbackpix (drw, pixmap);
  XtSetKeyboardFocus (toplevel, drw);
}

cbrepnt (l, c, width, height)
     int c, l;
     Dimension height, width;
{
  double L, C;

  if (c < 1 || c > AW->ncol)
    c = AW->cc;;
  if (l < 1 || l > AW->nlin)
    l = AW->ll;
  if (AW->cc == c && AW->ll == l)
    return;
  lx -= AW->cw[c] - AW->cw[AW->cc];
  ly -= AW->lh[l] - AW->lh[AW->ll];

  AW->cc = c;
  AW->ll = l;

  C = c;
  L = l;
  setscrollv (L);
  setscrollh (C);

  xrepnt ();
}

String
getstring (w)
     Widget w;
{
  char *str;
  Arg arglist[1];
  XtSetArg (arglist[0], XtNstring, &str);
  XtGetValues (w, arglist, 1);

  return (str);
}

setstring (w, str)
     Widget w;
     char *str;
{
  Arg arglist[1];

  XtSetArg (arglist[0], XtNstring, str);

  XtSetValues (w, arglist, 1);
  return;
}

inform (str)
     char *str;
{
  Arg arglist[1];

  XtSetArg (arglist[0], XtNstring, str);
  XtSetValues (info, arglist, 1);
  return;
}

insstr (w, str)
     Widget w;
     char *str;
{
  XawTextBlock text;
  long p = XawTextGetInsertionPoint (w);
  text.firstPos = 0;
  text.length = strlen (str);
  text.ptr = str;
  XawTextReplace (w, p, p, &text);
  XawTextSetInsertionPoint (w, p + text.length);
  cb_TextChange ();
}

mvinspt (w, delta)
     Widget w;
{
  XawTextPosition p = XawTextGetInsertionPoint (w);
  XawTextSetInsertionPoint (w, p + delta);
}

int
xytoij (x, y, i, j)
     int x, y;
     int *i, *j;
{
  int jj = 0;
  int x1, x2, y1, y2;
  x += AW->cw[AW->cc];
  y += AW->lh[AW->ll];
  getvisi (&x1, &x2, &y1, &y2);
  while (x > AW->cw[jj])
    {
      jj++;
    }
  *j = jj - 1;
  jj = 0;
  while (y > AW->lh[jj])
    {
      jj++;
    }
  *i = jj - 1;

  if (*i < 0)
    *i = 0;
  if (*j < 0)
    *j = 0;
  if (*i > AW->nlin)
    *i = AW->nlin;
  if (*j > AW->ncol)
    *j = AW->ncol;

  if (x < x1 + AW->cw[1])
    *j = 0;
  if (y < y1 + AW->lh[1])
    *i = 0;

  return 1;
}
int
ijtoxy (i, j, x, y)
     int *x, *y;
     int i, j;
{
  *x = AW->cw[j];
  *y = AW->lh[i];

  *x -= AW->cw[AW->cc];
  *y -= AW->lh[AW->ll];

  return 1;
}

int
absijtoxy (i, j, x, y)
     int *x, *y;
     int i, j;
{
  *x = AW->cw[j];
  *y = AW->lh[i];

  return 1;
}

int
xytocloij (x, y, i, j)
     int x, y;
     int *i, *j;
{
  int jj = 0;
  x += AW->cw[AW->cc];
  y += AW->lh[AW->ll];
  while (x > AW->cw[jj])
    {
      jj++;
    }
  *j = jj - 1;
  if (AW->cw[jj] - x < x - AW->cw[jj - 1])
    *j = jj;
  jj = 0;
  while (y > AW->lh[jj])
    {
      jj++;
    }
  *i = jj - 1;
  if (AW->lh[jj] - y < y - AW->lh[jj - 1])
    *i = jj;

  if (*i < 0)
    *i = 0;
  if (*j < 0)
    *j = 0;

  return 1;
}

xfit (ii, jj, name)
     char *name;
     int ii, jj;
{
  XCharStruct overall;
  int ascent, descent, direction;
  int cheight, cwidth;
  int di, dj, i, j;

  if (AW->lh[ii + 1] - AW->lh[ii] < cheight)
    {
      di = cheight - (AW->lh[ii + 1] - AW->lh[ii]);
      for (i = ii + 1; i <= AW->nlin; i++)
	AW->lh[i] += di;
    }
  if (AW->cw[jj + 1] - AW->cw[jj] < cwidth)
    {
      dj = cwidth - (AW->cw[jj + 1] - AW->cw[jj]);
      for (j = jj + 1; j < AW->ncol; j++)
	AW->cw[j] += dj;
    }
  return;
}

xfitcolumn (ii, jj)
     int ii, jj;
{
  XCharStruct overall;
  int ascent, descent, direction;
  int cheight, cwidth;
  int di, dj, i, j;
  int font, fontw, fonts;
  char *name;
  Cl *cl = (Cl *) appliccl (ii, jj, -1);
  if (cl == NULL)
    return;
  name = cl_gtext (cl);
  if (name == NULL)
    return;
  if (strlen (name) < 1)
    return;

  font = cl_gfont (cl);
  fontw = cl_gfontw (cl);
  fonts = cl_gfonts (cl);

  cwidth = gettextw (name, strlen (name), font, fontw, fonts) + 2;

  if (AW->cw[jj + 1] - AW->cw[jj] < cwidth)
    {
      dj = cwidth - (AW->cw[jj + 1] - AW->cw[jj]);
      for (j = jj + 1; j < AW->ncol; j++)
	AW->cw[j] += dj;
    }
  return;
}

xfitline (ii, jj)
     int ii, jj;
{
  XCharStruct overall;
  int ascent, descent, direction;
  int cheight, cwidth;
  int di, dj, i, j;
  int font, fontw, fonts;
  char *name;
  Cl *cl = (Cl *) appliccl (ii, jj, -1);
  if (cl == NULL)
    return;

  name = cl_gtext (cl);
  if (name == NULL)
    return;
  if (strlen (name) < 1)
    return;

  font = cl_gfont (cl);
  fontw = cl_gfontw (cl);
  fonts = cl_gfonts (cl);

  cheight = gettexth (name, strlen (name), font, fontw, fonts) + 2;

  if (AW->lh[ii + 1] - AW->lh[ii] < cheight)
    {
      di = cheight - (AW->lh[ii + 1] - AW->lh[ii]);
      for (i = ii + 1; i <= AW->nlin; i++)
	AW->lh[i] += di;
    }
  return;
}

Widget
getdrwzone ()
{
  return drw;
}

int
getvisi (x1, x2, y1, y2)
     int *x1, *x2, *y1, *y2;
{
  *x1 = AW->cw[AW->cc];
  *y1 = AW->lh[AW->ll];
  *x2 = *x1 + Width * 100 / zm;
  *y2 = *y1 + Height * 100 / zm;
  return;
}

int
getvisi_cls (i1, j1, i2, j2)
     int *i1, *j1, *i2, *j2;
{
  *i1 = AW->ll;
  *j1 = AW->cc;
  *i2 = *i1;
  *j2 = *j1;

  while (AW->lh[*i2] < AW->lh[AW->ll] + Height * 100 / zm && *i2 < AW->nlin)
    {
      (*i2)++;
    }

  while (AW->cw[*j2] < AW->cw[AW->cc] + Width * 100 / zm && *j2 < AW->ncol)
    {
      (*j2)++;
    }
  return;
}

int
setvisi (i, j)
     int i, j;
{
  int c, l;
  double C, L;
  c = AW->cc;;
  l = AW->ll;

  if (i > l && j > c && AW->cw[c] + Width * 100 / zm > AW->cw[j + 1] && AW->lh[l] + Height * 100 / zm > AW->lh[i + 1])
    return;

  if (c >= j)
    c = j - 1;
  else
    while (AW->cw[c] + Width * 100 / zm < AW->cw[j + 1] && c < AW->ncol)
      c++;

  if (l >= i)
    l = i - 1;
  else
    while (AW->lh[l] + Height * 100 / zm < AW->lh[i + 1] && l < AW->nlin)
      l++;

  if (l < 0)
    l = 0;
  if (c < 0)
    c = 0;

  cbrepnt (l, c, Width, Height);

}

coldrag (c)
     double c;
{
  int C;
  C = c;

  cbrepnt (-1, C, Width, Height);
}

lindrag (l)
     double l;
{
  int L;
  L = l;

  cbrepnt (L, -1, Width, Height);
}

void
cb_ZoomChange (Widget w, XtPointer cd, XEvent * event, Boolean * ctd)
{
  int x, y;

}

zmin ()
{
  zm += 10;
  setzm (zm);
  xrepnt ();
}

zmout ()
{
  zm -= 10;
  setzm (zm);
  xrepnt ();
}

cb_setzm (int z)
{
  Chrt *gr;
  int i;

  if (zm == z)
    return;
  setzm (z);
  ActivWks->zm = z;
  zm = z;

  for (i = 0; i < getngr (); i++)
    {
      gr = (Chrt *) getgr (i);
      gr->zm = z;
      resizegra (i);
    }
  redrwgra ();
  xrepnt ();

}

resizegra (i)
     int i;
{
  Chrt *gr;
  gr = (Chrt *) getlastgra ();
  freepixmap (drw, gr->pixmap);
  gr->pixmap = createpixmap (drw,
			     gr->w * gr->zm / 100, gr->h * gr->zm / 100);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0,
		 gr->w, gr->h, 0);
}

redrwdr (dr)
     Drwing *dr;
{
  int centerx, centery, width, height, a1, a2;
  int pi = 90 * 64;
  int x1, x2, y1, y2;

  x1 = dr->x1 - AW->cw[AW->cc];
  y1 = dr->y1 - AW->lh[AW->ll];
  x2 = dr->x2 - AW->cw[AW->cc];
  y2 = dr->y2 - AW->lh[AW->ll];

  switch (dr->type)
    {

    case VAL31:
      {

	drwline (dpy, pixmap, 1, x1, y1, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case VAL32:
      {
	drwline (dpy, pixmap, 1, x1, y1, x2, y1, AW->cw[AW->cc], AW->lh[AW->ll]);
	drwline (dpy, pixmap, 1, x2, y1, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	drwline (dpy, pixmap, 1, x2, y2, x1, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	drwline (dpy, pixmap, 1, x1, y2, x1, y1, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case VAL33:
      {
	centerx = x1;
	centery = y1;
	width = 2 * abs (x1 - x2);
	height = 2 * abs (y1 - y2);

	if (x1 <= x2 && y1 <= y2)
	  {
	    a1 = 0;
	    a2 = pi;
	    centery += height / 2;
	  }
	if (x1 >= x2 && y1 <= y2)
	  {
	    a1 = -pi;
	    a2 = pi;
	    centerx -= width / 2;
	  }
	if (x1 >= x2 && y1 >= y2)
	  {
	    a1 = 2 * pi;
	    a2 = pi;
	    centery -= height / 2;
	  }
	if (x1 <= x2 && y1 >= y2)
	  {
	    a1 = pi;
	    a2 = pi;
	    centerx += width / 2;
	  }
	drwarc
	  (dpy, pixmap, 1, centerx - width / 2, centery - height / 2, width, height, a1, a2, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case VAL34:
      {
	centerx = (x1 + x2) / 2;
	centery = (y1 + y2) / 2;
	width = abs (x1 - x2);
	height = abs (y1 - y2);
	drwarc
	  (dpy, pixmap, 1, centerx - width / 2, centery - height / 2, width, height, 0, 360 * 64,
	   AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    }
}

cb_grap (w, dialog)
     Widget w, dialog;
{
  TEXT_WIDGET = w;
  DIALOG_WIDGET = dialog;
  FLAG2 = VAL13;
}

Pixmap
createpixmapforchrt (gr)
     Chrt *gr;
{
  gr->pixmap = createpixmap (drw, gr->w, gr->h);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0, gr->w, gr->h, 0);
  return gr->pixmap;

}

getpixmap (gr, x, y, w, h)
     Chrt *gr;
     int *w, *h, *x, *y;
{
  *x = gr->x;
  *y = gr->y;

  *w = gr->w;
  *h = gr->h;
  return gr->pixmap;
}

int
bdrepnt (n)
     int n;
{
  int i, j, imin, imax, jmin, jmax, x1, x2, y1, y2;

  setfont2 (0, 1, 0, 3);
  if (n == 0 || n == VAL11X)
    {
      desactivate_zm ();
      fillrectangle (XtDisplay (linind), linpixmap, 2, 0, 0, 30, Height, 0);
      reactivate_zm ();
      for (i = AW->ll; AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
	xdrwlincl (i, 0, 0);
      clearwin (linind);
    }
  if (n == 0 || n == VAL12)
    {
      desactivate_zm ();
      fillrectangle (XtDisplay (colind), colpixmap, 2, 0, 0, Width, 20, 0);
      reactivate_zm ();
      for (j = AW->cc; AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
	xdrwcolcl (0, j, 0);
      clearwin (colind);
    }
}

xrepnt ()
{
  int i, j, imin, imax, jmin, jmax, x1, x2, y1, y2;
  bdrepnt (0);
  paint = 1;

  fillrectangle (dpy, pixmap, 0, 0, 0, Width * 100 / zm, Height * 100 / zm, 0);

  for (i = AW->ll + 1; AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
    drwline (dpy, pixmap, 2, 0, AW->lh[i] - AW->lh[AW->ll], Width * 100 / zm, AW->lh[i] - AW->lh[AW->ll]);
  for (j = AW->cc + 1; AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
    drwline (dpy, pixmap, 2, AW->cw[j] - AW->cw[AW->cc], 0, AW->cw[j] - AW->cw[AW->cc], Height * 100 / zm);

  for (i = AW->ll; AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
    {
      for (j = AW->cc; AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
	xdrwcl (i, j, 4);
    }

  redrwdra ();
  cpypix ();
  paint = 0;
}

void
cb_Repaint (w, data, event)
     Widget w;
     caddr_t data;
     XEvent *event;
{
  xrepnt ();
}

void
cb_redrwdra ()
{
  redrwdra ();
}

int
redrwdra ()
{
  Drwing *gr;
  int i;

  int numdra;

  if (ActivWks == NULL)
    {
      fprintf (stderr, "ActivWks =NULL\n");
      return;
    }

  numdra = ActivWks->nbdrwing;
  for (i = 0; i < numdra; i++)
    {
      gr = (Drwing *) getdr (i);
      if (gr != NULL)
	redrwdr (gr);
      else
	fprintf (stderr, "dr =NULL\n");

    }

}

void
cb_redrwgra ()
{
  redrwgra ();
}

int
redrwgra ()
{
  Chrt *gr;
  int i;
  int numgra;

  if (ActivWks == NULL)
    {
      fprintf (stderr, "ActivWks =NULL\n");
      return;
    }
  numgra = ActivWks->nbchrt;

  for (i = 0; i < numgra; i++)
    {
      gr = (Chrt *) getgr (i);
      if (gr != NULL)
	newplot (i, gr);
      else
	fprintf (stderr, "gr =NULL\n");

    }
  cpypix ();
  paint = 0;
}

void
cpypix ()
{
  Chrt *gr;
  int i;
  int xa, ya, xb, yb;
  int numgra;
  if (ActivWks == NULL)
    {
      fprintf (stderr, "ActivWks =NULL\n");
      return;
    }

  numgra = ActivWks->nbchrt;

  for (i = 0; i < numgra; i++)
    {
      gr = (Chrt *) getgr (i);
      if (gr != NULL)
	copyarea (gr->pixmap, pixmap, 1, 0, 0,
		  gr->w * gr->zm / 100, gr->h * gr->zm / 100,
		  (gr->x - AW->cw[AW->cc]) * gr->zm / 100,
		  (gr->y - AW->lh[AW->ll]) * gr->zm / 100);
    }

  clearnflush ();
  drwselect ();
}

cb_resize (width, height)
{
  freepixmap (drw, pixmap);
  freepixmap (linind, linpixmap);
  freepixmap (colind, colpixmap);

  Height = height - 20;
  Width = width - 30;
  pixmap = createpixmap (drw, width - 30, height - 20);
  setbackpix (drw, pixmap);

  linpixmap = createpixmap (linind, 30, height - 20);
  colpixmap = createpixmap (colind, width - 30, 20);

  setbackpix (linind, linpixmap);
  setbackpix (colind, colpixmap);
  xrepnt ();
};

checkwidth (name, width, cl, r, c)
     char *name;
     int width;
     Cl *cl;
     int r, c;
{
  int cheight, cwidth;
  int nchar;
  int i, j;
  int color, just, font, fontw, fonts;

  if (name == NULL)
    return width;
  nchar = strlen (name);
  if (nchar < 1)
    return width;

  color = cl_gfg (cl);
  just = cl_gjust (cl);
  font = cl_gfont (cl);
  fontw = cl_gfontw (cl);
  fonts = cl_gfonts (cl);

  cwidth = gettextw (name, nchar, font, fontw, fonts);

  if (cwidth > width - 2)
    {

      i = r;
      j = c;
      while (cwidth > width - 2 && (Cl *) appliccl (i, j + 1, -1) == NULL)
	{
	  width += AW->cw[j + 2] - AW->cw[j + 1];
	  j++;
	}
    }
  return width;

}

xdrwstring (name, x, y, width, widthmax, height, type, cl)
     char *name;
     int x, y, width, widthmax, height, type;
     Cl *cl;
{
  int textx, texty;

  int cheight, cwidth;
  int nchar;
  int i, j;
  int color, just, font, fontw, fonts;

  if (name == NULL)
    return;
  nchar = strlen (name);
  if (nchar < 1)
    return;

  font = cl_gfont (cl);
  fontw = cl_gfontw (cl);
  fonts = cl_gfonts (cl);

  cheight = gettexth (name, nchar, font, fontw, fonts);
  cwidth = gettextw (name, nchar, font, fontw, fonts);
  if (height < (cheight + 2))
    return width;

  while (cwidth > widthmax - 2 && nchar > 0)
    {
      nchar--;
      cwidth = gettextw (name, nchar, font, fontw, fonts);
    }
  if (nchar < 1)
    return;

  color = cl_gfg (cl);
  just = cl_gjust (cl);

  if (type == 3)
    just = 0;

  if (just == 0)
    textx = x + 1;
  if (just == 1)
    textx = x + width / 2 - cwidth / 2;
  if (just == 2)
    textx = x + width - cwidth;
  if (textx < x + 1)
    textx = x + 1;
  texty = y + height / 2 + cheight / 2 + 1;

  setfont2 (color, font, fontw, fonts);
  drwstring (XtDisplay (drw), pixmap, color, textx, texty, name, nchar, AW->cw[AW->cc], AW->lh[AW->ll]);

  return;
}

xdrwrrect (x, y, width, height, type, cl)
     int x, y, width, height;
     Cl *cl;
{

  int bg = cl_gbg (cl);
  int fg = cl_gfg (cl);

  if (bg < 0)
    bg = 0;
  if (fg < 0)
    fg = 5;
  if (type == 0)
    {
      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }
  if (type == 4)
    {

      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }

  if (type == 2 || type == 3)
    {
      fillrectangle (dpy, pixmap, 1, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);

      fillrectangle (dpy, pixmap, bg, x + 2, y + 2, width - 3, height - 3, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }

  if (type == 5 && bg != 0 && bg != 45)
    {

      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 5);
    }

  if (cl_gtop (cl))
    {
      drwline (dpy, pixmap, fg, x, y, x + width, y, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cl_gbot (cl))
    {
      drwline (dpy, pixmap, fg, x + width, y + height, x, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cl_grig (cl))
    {
      drwline (dpy, pixmap, fg, x + width, y, x + width, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cl_glef (cl))
    {
      drwline (dpy, pixmap, fg, x, y, x, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
}

xdrwlincl (i, j, color)
     int i, j, color;
{
  char label[8];
  int height;
  int top = AW->lh[i] + AW->lh[AW->ll];
  int xvis, x2, yvis, y2, x1, y1;

  if (i <= 0)
    return;
  height = AW->lh[i + 1] - AW->lh[i];
  top = AW->lh[i] - AW->lh[AW->ll];
  sprintf (label, "%d", i);
  desactivate_zm ();
  drwline (XtDisplay (linind), linpixmap, 0, 0, top * zm / 100 + 1, 28, top * zm / 100 + 1);
  drwline (XtDisplay (linind), linpixmap, 3, 29, top * zm / 100, 29, (top + height) * zm / 100);
  drwline (XtDisplay (linind), linpixmap, 3, 1, (top + height) * zm / 100, 29, (top + height) * zm / 100);
  drwline (XtDisplay (linind), linpixmap, 0, 0, top * zm / 100, 0, (top + height) * zm / 100);
  reactivate_zm ();

  drwstring (XtDisplay (linind), linpixmap, 1, 3 * 100 / zm, top + height - 4, label, strlen (label));

}

xdrwcolcl (i, j, color)
     int i, j, color;
{
  char label[4];
  int width;
  int left;
  int xvis, x2, yvis, y2, x1, y1;
  if (j <= 0)
    return;
  width = AW->cw[j + 1] - AW->cw[j];
  left = AW->cw[j] - AW->cw[AW->cc];

  if (j <= 26)
    {
      label[0] = 'A' + j - 1;
      label[1] = '\0';
    }
  else
    {
      label[0] = 'A' + (j - 1) / 26 - 1;
      label[1] = 'A' + j - 26 * ((j - 1) / 26) - 1;
      label[2] = '\0';
    }
  desactivate_zm ();
  drwline (XtDisplay (colind), colpixmap, 0, left * zm / 100 + 1, 0, left * zm / 100 + 1, 19);
  drwline (XtDisplay (colind), colpixmap, 3, (left + width) * zm / 100, 0, (left + width) * zm / 100, 19);
  drwline (XtDisplay (colind), colpixmap, 3, left * zm / 100 + 1, 19, (left + width) * zm / 100, 19);
  drwline (XtDisplay (colind), colpixmap, 0, left * zm / 100, 0, (left + width) * zm / 100 - 1, 0);
  reactivate_zm ();

  drwstring (XtDisplay (colind), colpixmap, 1, left + width / 2 - 5, 15 * 100 / zm, label, strlen (label));
  return 0;
}

xdrwcl (i, j, type)
     int i, j, type;
{

  int left;
  int top;
  int width;
  int widthmax;
  int height;
  int xviw, yvis, x2, y2;
  char *buf = NULL;
  int bord = get_border (i, j);
  int plot = 0;

  Cl *cl = (Cl *) appliccl (i, j, -1);
  if (cl == NULL && (type == 4 || type == 5))
    return;

  width = AW->cw[j + 1] - AW->cw[j];
  left = AW->cw[j] - AW->cw[AW->cc];
  height = AW->lh[i + 1] - AW->lh[i];
  top = AW->lh[i] - AW->lh[AW->ll];

  if (cl != NULL)
    buf = (char *) cl_gtext (cl);

  if (type == 2 && cl != NULL)
    buf = (char *) cl_gform (cl);

  if (type == 3)
    {
      buf = (char *) getstring (Letxt);

    }

  if ((buf != NULL || type == 3) && cl_grig (cl) == 0)
    widthmax = checkwidth (buf, width, cl, i, j);
  else
    widthmax = width;

  xdrwrrect (left, top, widthmax, height, type, cl);

  if (buf != NULL || type == 3)
    xdrwstring (buf, left, top, width, widthmax, height, type, cl, i, j);

  if (!paint && FLAG1 != VAL37)
    cleararea (dpy, win, left, top, widthmax + 1, height + 1, False);

  return 0;
}

int
createchrtpixmap (gr)
     Chrt *gr;
{
  deletechrtpixmap (gr);
  gr->pixmap = createpixmap (drw, gr->w, gr->h);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0, gr->w, gr->h, 0);
}

int
deletechrtpixmap (gr)
     Chrt *gr;
{
  if (gr)
    if (gr->pixmap)
      {
	freepixmap (drw, gr->pixmap);
	gr->pixmap = 0;
      }
}
