/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef GRAPH_H
#define GRAPH_H

#include "style.h"
#include "title.h"

#include "stdio.h"
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>

#ifndef chrtvar
#define grnone 0
#define grboth 1
#define grvert 2
#define grhori 3
#define grline 2
#define grsymb 3
#endif

typedef struct
  {
    int i1;
    int j1;
    int i2;
    int j2;
    char name[32];
  }
GRRange;

typedef struct
  {
    double MinimumScale;
    Boolean MinimumScaleIsAuto;
    double MaximumScale;
    Boolean MaximumScaleIsAuto;
    double MajorUnit;
    Boolean MajorUnitIsAuto;
    int HasMajorGridLines;
    Boolean HasTitle;
    Title AxisTitle;
  }
Axis;

#define xlCategory 1
#define xlValue 2

typedef struct
  {
    int i;
    int j;
    int x;
    int y;
    int w;
    int h;
    int zm;
    int numrange;
    int objn;
    int type;
    int graphic_grid;
    GRRange range[10];
    int graphic_format[10];
    char titre1[64];
    char titre2[64];
    char Xlabel[64];
    char Ylabel[64];
    Pixmap pixmap;
    int axe_cat_grid;
    int axe_val_grid;
    Axis Axes[3];
    Boolean HasTitle;
    Title ChtTitle;
  }
Chrt;

typedef Chrt Cht;

extern Chrt *ActivChrt;

extern Chrt *newchrt ();
extern Chrt *newchrt1 (Chrt * gr);
extern Chrt *
  newchrt1 (Chrt *);
extern int freechrt (Chrt *);
extern Chrt *
  chrt_r (FILE * fp);
extern int
  chrt_w (Chrt * chrt, FILE * fp);
extern int
  chrt_copy (Chrt * chrt, Chrt * gr);

extern int
  ActivateChrt (Chrt * chrt);

extern int
  chrt_settype (Chrt * chrt, int type);
extern int
  chrt_setseriename (Chrt * chrt, int serie, char *name);
extern int
  chrt_setserievalues (Chrt * chrt, int serie, char *valuerange);
extern int
  chrt_setgrid (Chrt * chrt, int axe, int on);

#endif
