/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef CELL_H
#define CELL_H
#include "style.h"
#include <stdio.h>
#include "absrec.h"

struct _Cl;
struct _Wks;

struct _Fam
  {
    struct _Cl **parlst;
    struct _Cl **chilst;
    int npar;
    int nchi;
    int dparlst;
    int dchilst;
  };

typedef struct _Fam Fam;

struct _Cl
  {
    obj val;
    char *form;
    int flag1;
    int r, c;
    Style *style;
    Fam *familly;
    struct _Wks *wks;
    int objn;

  };

typedef struct _Cl Cl;

extern Cl *currentcl;
extern Cl *ActivCl;

extern Cl *newcl (int r, int c);
extern int freecl (Cl * cl);
extern int cl_w (Cl * cl, FILE * fp);

extern int cl_setnumberformat (Cl * cl, char *buf);
extern int cl_setform (Cl * cl, char *buf);
extern int cl_settext (Cl * cl, char *buf);
extern char *cl_gform (Cl * cl);
extern char *cl_gnumberformat (Cl * cl);
extern char *cl_gtext (Cl * cl);
extern int cl_istext (Cl * cl);
extern double cl_gvalue (Cl * cl);
extern double cl_setvalue (Cl * cl, double val);
extern double cl_setvalue2 (double val);

extern int cl_setbord (Cl * cl, int border, int type);
extern int cl_setfg (Cl * cl, int f);
extern int cl_gfg (Cl * cl);
extern int cl_setbg (Cl * cl, int f);
extern int cl_gbg (Cl * cl);

extern int cl_gtop (Cl * cl);
extern int cl_gbot (Cl * cl);
extern int cl_grig (Cl * cl);
extern int cl_glef (Cl * cl);
extern int cl_settop (Cl * cl, int f);
extern int cl_setbot (Cl * cl, int f);
extern int cl_setrig (Cl * cl, int f);
extern int cl_setlef (Cl * cl, int f);

extern int cl_setformat (Cl * cl, int format, int deci);
extern int cl_gformat (Cl * cl, int *format, int *deci);
extern int cl_setjust (Cl * cl, int j);
extern int cl_gjust (Cl * cl);
extern int cl_setfont (Cl * cl, int f, int w, int s);
extern int cl_gfont (Cl * cl);
extern int cl_gfontw (Cl * cl);
extern int cl_gfonts (Cl * cl);
extern int cl_fname (Cl * cl, char *name);
extern int cl_fontsize (Cl * cl, int v);
extern int cl_fblt (Cl * cl, int v);
extern int cl_fital (Cl * cl, int v);

extern int cl_setbord (Cl * cl, int border, int type);
extern int cl_setborder (Cl * cl, int border);
extern int cl_gborder (Cl * cl);

extern int cl_isnew (Cl * cl);
extern int cl1isfcl2 (Cl * cl1, Cl * cl2);
extern int nupdate2 (Cl * cl);

extern int StringInput ();
extern int macroparsing (char *buf);
extern char *textparsing (char *buf);

extern int copymod (int ii, int jj, int i, int j, int incr);
extern int copymod2 (Cl * cl1, Cl * cl2, int curi, int curj, int di, int dj);
extern Cl *cl_cpy (Cl * cl1, Cl * cl2);
extern Cl *cl_stycpy (Cl * cl1, Cl * cl2);
#endif
