/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include "commandline.h"

void
echoept ()
{
  echfct ("ept ()");
}
void
echogpf ()
{
  echfct ("gpf ()");
}
void
echogpd ()
{
  echfct ("gpd ()");
}
void
echoacos ()
{
  echfct ("acos ()");
}
void
echoasin ()
{
  echfct ("asin ()");
}
void
echoatan2 ()
{
  echfct ("atan2 ()");
}
void
echoatan ()
{
  echfct ("atan ()");
}
void
echoceil ()
{
  echfct ("ceil ()");
}
void
echocos ()
{
  echfct ("cos ()");
}
void
echocosh ()
{
  echfct ("cosh ()");
}
void
echoexp ()
{
  echfct ("exp ()");
}
void
echofabs ()
{
  echfct ("fabs ()");
}
void
echofloor ()
{
  echfct ("floor ()");
}
void
echofmod ()
{
  echfct ("fmod ()");
}
void
echofrexp ()
{
  echfct ("frexp ()");
}
void
echoldexp ()
{
  echfct ("ldexp ()");
}
void
echolog ()
{
  echfct ("log ()");
}
void
echolog10 ()
{
  echfct ("log10 ()");
}
void
echomodf ()
{
  echfct ("modf ()");
}
void
echopow ()
{
  echfct ("pow ()");
}
void
echosin ()
{
  echfct ("sin ()");
}
void
echosinh ()
{
  echfct ("sinh ()");
}
void
echosqrt ()
{
  echfct ("sqrt ()");
}
void
echotan ()
{
  echfct ("tan ()");
}
void
echotanh ()
{
  echfct ("tanh ()");
}
void
echomin ()
{
  echfct ("min ()");
}
void
echomax ()
{
  echfct ("max ()");
}
void
echosum ()
{
  echfct ("sum ()");
}
void
echonmax ()
{
  echfct ("nmax ()");
}

Commandline *
newcommandline (commandline)
     Widget commandline;
{
  Commandline *cl_obj;
  Arg args[20];
  register int n;

  cl_obj = (Commandline *) absmalloc (sizeof (Commandline), "newcommandline:cl_obj ");

  n = 0;
  XtSetArg (args[0], XtNstring, "");
  n++;
  XtSetArg (args[n], XtNeditType, XawtextEdit);
  n++;
  XtSetArg (args[n], XtNborderWidth, 0);
  n++;
  XtSetArg (args[n], XtNwidth, 150);
  n++;
  XtSetArg (args[n], XtNheight, 20);
  n++;
  XtSetArg (args[n], XtNbackground, 1);
  n++;
  XtSetArg (args[n], XtNforeground, 0);
  n++;
  cl_obj->info = XtCreateManagedWidget (
					 "text",
					 asciiTextWidgetClass,
					 commandline,
					 args, n);
  XawTextDisplayCaret (cl_obj->info, False);
  addshadow (cl_obj->info, 3);

  cl_obj->btn = make_bar_button (commandline, "Fct");

  cl_obj->menu_popup = make_popup (cl_obj->btn,
		   "Fct", "Fct", fctMenuEntries, XtNumber (fctMenuEntries));

  cl_obj->cancel = (Widget) make_button_pixmap
    (commandline, "cancel", cancel_xpm, cb_BtnCancel, NULL);
  cl_obj->ok = (Widget) make_button_pixmap
    (commandline, "ok", ok_xpm, cb_BtnOk, NULL);

  n = 0;
  XtSetArg (args[0], XtNstring, "");
  n++;
  XtSetArg (args[n], XtNwidth, 500);
  n++;
  XtSetArg (args[n], XtNheight, 20);
  n++;
  XtSetArg (args[n], XtNeditType, XawtextEdit);
  n++;
  XtSetArg (args[n], XtNborderWidth, 0);
  n++;
  XtSetArg (args[n], XtNbackground, 1);
  n++;
  XtSetArg (args[n], XtNforeground, 0);
  n++;
  cl_obj->text = XtCreateManagedWidget ("text", asciiTextWidgetClass, commandline, args, n);
  XawTextDisplayCaret (cl_obj->text, False);
  addshadow (cl_obj->text, 3);

  return cl_obj;
}

make_fct_btn (commandline)
     Widget commandline;
{
  Widget btn, menu_popup;
  btn = make_bar_button (commandline, "Fct");
  menu_popup = make_popup (btn,
		   "Fct", "Fct", fctMenuEntries, XtNumber (fctMenuEntries));

}
