/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef COMMANDLINE_H
#define COMMANDLINE_H
#include <stdio.h>
#include "pixmap.h"
#include "param.h"
#include "cblist.h"
#include "menubar.h"

typedef struct
  {
    int Initialized;
    Widget text, info, cancel, ok;
    Widget btn, menu_popup;

  }
Commandline;

extern Commandline *
  newcommandline (Widget commandline);

extern void echoept ();
extern void echogpf ();
extern void echogpd ();
extern void echoacos ();
extern void echoasin ();
extern void echoatan2 ();
extern void echoatan ();
extern void echoceil ();
extern void echocos ();
extern void echocosh ();
extern void echoexp ();
extern void echofabs ();
extern void echofloor ();
extern void echofmod ();
extern void echofrexp ();
extern void echoldexp ();
extern void echolog ();
extern void echolog10 ();
extern void echomodf ();
extern void echopow ();
extern void echosin ();
extern void echosinh ();
extern void echosqrt ();
extern void echotan ();
extern void echotanh ();
extern void echomin ();
extern void echomax ();
extern void echosum ();
extern void echonmax ();

static struct menuEntry fctMenuEntries[] =
{
  "acos    ()", echoacos,
  "asin    ()", echoasin,
  "atan2   ()", echoatan2,
  "atan    ()", echoatan,
  "ceil    ()", echoceil,
  "cos     ()", echocos,
  "cosh    ()", echocosh,
  "exp     ()", echoexp,
  "fabs    ()", echofabs,
  "floor   ()", echofloor,
  "fmod    ()", echofmod,
  "frexp   ()", echofrexp,
  "ldexp   ()", echoldexp,
  "log     ()", echolog,
  "log10   ()", echolog10,
  "modf    ()", echomodf,
  "pow     ()", echopow,
  "sin     ()", echosin,
  "sinh    ()", echosinh,
  "sqrt    ()", echosqrt,
  "tan     ()", echotan,
  "tanh    ()", echotanh,
  "min     ()", echomin,
  "max     ()", echomax,
  "sum     ()", echosum,
  "nmax    ()", echonmax,
};

#endif
