/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>

#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif

#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

#define YY_USE_PROTOS

#define YY_USE_CONST

#else

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif
#endif

#ifdef __TURBOC__
#pragma warn -rch
#pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

#define YY_NULL 0

#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

#define BEGIN yy_start = 1 + 2 *

#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

typedef unsigned int yy_size_t;

struct yy_buffer_state
  {
    FILE *yy_input_file;

    char *yy_ch_buf;
    char *yy_buf_pos;

    yy_size_t yy_buf_size;

    int yy_n_chars;

    int yy_is_our_buffer;

    int yy_is_interactiv;

    int yy_at_bol;

    int yy_fill_buffer;

    int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1

#define YY_BUFFER_EOF_PENDING 2
  };

static YY_BUFFER_STATE yy_current_buffer = 0;

#define YY_CURRENT_BUFFER yy_current_buffer

static char yy_hold_char;

static int yy_n_chars;

int yyleng;

static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;
static int yy_start = 0;

static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO ((FILE * input_file));

void yy_switch_to_buffer YY_PROTO ((YY_BUFFER_STATE new_buffer));
void yy_load_buffer_state YY_PROTO ((void));
YY_BUFFER_STATE yy_create_buffer YY_PROTO ((FILE * file, int size));
void yy_delete_buffer YY_PROTO ((YY_BUFFER_STATE b));
void yy_init_buffer YY_PROTO ((YY_BUFFER_STATE b, FILE * file));
void yy_flush_buffer YY_PROTO ((YY_BUFFER_STATE b));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO ((char *base, yy_size_t size));
YY_BUFFER_STATE yy_scan_string YY_PROTO ((yyconst char *yy_str));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO ((yyconst char *bytes, int len));

static void *yy_flex_alloc YY_PROTO ((yy_size_t));
static void *yy_flex_realloc YY_PROTO ((void *, yy_size_t));
static void yy_flex_free YY_PROTO ((void *));

#define yy_n_buffer yy_create_buffer

#define yy_set_interactiv(is_interactiv) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactiv = is_interactiv; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_g_previous_state YY_PROTO ((void));
static yy_state_type yy_try_NUL_trans YY_PROTO ((yy_state_type current_state));
static int yy_g_next_buffer YY_PROTO ((void));
static void yy_fatal_error YY_PROTO ((yyconst char msg[]));

#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 143
#define YY_END_OF_BUFFER 144
static yyconst short int yy_accept[531] =
{0,
 0, 0, 144, 142, 141, 139, 140, 123, 142, 98,
 130, 122, 142, 117, 118, 128, 127, 113, 126, 121,
 129, 103, 103, 114, 110, 131, 115, 133, 137, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 119, 120, 135, 138, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 111, 136, 112, 125, 124,
 0, 109, 0, 98, 0, 0, 107, 108, 101, 0,
 103, 103, 0, 103, 132, 116, 134, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,

 98, 98, 98, 35, 98, 98, 98, 98, 98, 81,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 39, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 45, 98, 105,
 0, 107, 107, 0, 108, 101, 101, 0, 106, 103,
 104, 99, 98, 52, 55, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 69, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,

 98, 98, 98, 98, 98, 93, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 7, 98, 98, 10, 98,
 98, 98, 38, 98, 15, 16, 98, 18, 20, 21,
 98, 98, 98, 98, 25, 98, 98, 98, 98, 27,
 98, 98, 98, 31, 98, 33, 98, 0, 107, 0,
 107, 0, 108, 101, 102, 106, 99, 99, 98, 98,
 98, 56, 98, 59, 98, 60, 98, 98, 98, 98,
 98, 37, 71, 98, 98, 98, 98, 98, 98, 98,
 98, 79, 98, 98, 98, 98, 84, 98, 98, 98,
 98, 91, 98, 94, 36, 98, 98, 1, 2, 3,

 5, 98, 8, 98, 9, 11, 98, 13, 98, 98,
 98, 22, 44, 23, 98, 98, 42, 98, 26, 28,
 98, 30, 46, 98, 34, 98, 0, 107, 99, 100,
 98, 98, 98, 98, 98, 61, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 83, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 4, 98, 40, 12, 14, 17, 19, 24, 41, 98,
 29, 98, 47, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 68, 98, 98, 98, 98, 98, 98,
 77, 98, 98, 98, 98, 86, 98, 98, 90, 92,

 95, 98, 98, 98, 98, 43, 98, 98, 98, 53,
 98, 98, 58, 98, 98, 98, 98, 98, 65, 70,
 98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 32, 48, 98, 98, 98,
 54, 98, 98, 98, 98, 98, 98, 72, 98, 74,
 98, 76, 98, 98, 82, 98, 98, 98, 98, 98,
 98, 98, 98, 98, 98, 57, 98, 98, 64, 98,
 98, 98, 98, 78, 98, 85, 87, 98, 98, 96,
 98, 98, 50, 98, 98, 98, 63, 67, 98, 98,
 98, 98, 98, 98, 97, 98, 49, 51, 98, 66,

 98, 98, 98, 98, 98, 6, 62, 98, 98, 80,
 98, 98, 98, 98, 98, 88, 98, 98, 98, 98,
 98, 98, 98, 98, 89, 73, 98, 98, 75, 0
};

static yyconst int yy_ec[256] =
{0,
 1, 1, 1, 1, 1, 1, 1, 1, 2, 3,
 2, 2, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 4, 5, 6, 1, 7, 8, 9, 10, 11,
 12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
 22, 22, 22, 22, 22, 22, 22, 23, 24, 25,
 26, 27, 28, 1, 29, 30, 31, 32, 33, 34,
 35, 36, 37, 38, 38, 39, 40, 41, 42, 43,
 38, 44, 45, 46, 47, 48, 49, 50, 38, 38,
 51, 52, 53, 54, 55, 1, 56, 57, 58, 59,

 60, 61, 62, 63, 64, 65, 66, 67, 68, 69,
 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
 80, 81, 82, 83, 84, 85, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,

 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1
};

static yyconst int yy_meta[86] =
{0,
 1, 1, 1, 1, 1, 1, 2, 1, 1, 3,
 1, 1, 1, 1, 1, 1, 1, 1, 4, 4,
 4, 4, 1, 1, 1, 1, 1, 1, 4, 4,
 4, 4, 4, 4, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 1, 1, 1, 1, 1, 4, 4, 4, 4, 4,
 4, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 1, 1, 1, 1
};

static yyconst short int yy_base[535] =
{0,
 0, 0, 678, 679, 679, 679, 679, 651, 80, 0,
 679, 679, 624, 679, 679, 679, 679, 679, 679, 68,
 679, 116, 74, 679, 679, 649, 648, 647, 679, 39,
 602, 46, 32, 34, 44, 42, 607, 36, 597, 596,
 59, 82, 60, 612, 597, 679, 679, 679, 679, 69,
 70, 87, 60, 92, 595, 94, 105, 110, 592, 52,
 588, 603, 113, 98, 599, 679, 679, 679, 679, 679,
 99, 679, 658, 0, 146, 164, 180, 184, 209, 238,
 132, 142, 0, 244, 679, 679, 679, 585, 600, 599,
 64, 113, 590, 589, 599, 587, 593, 578, 592, 118,

 581, 575, 575, 0, 572, 590, 576, 576, 575, 0,
 578, 572, 562, 143, 583, 557, 561, 579, 556, 574,
 566, 559, 561, 566, 573, 564, 138, 570, 0, 551,
 554, 567, 553, 552, 548, 560, 135, 559, 556, 538,
 547, 556, 535, 557, 553, 533, 546, 545, 550, 538,
 537, 549, 531, 543, 534, 527, 531, 0, 535, 679,
 259, 679, 267, 276, 679, 135, 158, 213, 293, 679,
 679, 254, 534, 175, 0, 523, 522, 536, 535, 526,
 525, 518, 145, 534, 529, 0, 513, 519, 528, 197,
 521, 524, 516, 522, 521, 523, 510, 516, 188, 517,

 512, 530, 503, 513, 499, 0, 496, 501, 493, 502,
 493, 497, 496, 497, 505, 499, 485, 556, 0, 485,
 488, 498, 0, 477, 0, 0, 476, 534, 0, 0,
 492, 477, 472, 490, 0, 480, 473, 487, 487, 482,
 466, 468, 471, 0, 466, 477, 472, 288, 297, 319,
 679, 303, 323, 679, 679, 679, 191, 183, 461, 473,
 473, 0, 489, 0, 474, 0, 459, 457, 458, 462,
 454, 0, 0, 452, 452, 470, 461, 443, 450, 458,
 476, 0, 460, 444, 458, 457, 0, 458, 455, 444,
 453, 0, 454, 0, 0, 451, 179, 0, 0, 489,

 0, 453, 0, 446, 679, 0, 434, 0, 435, 434,
 485, 0, 0, 0, 430, 427, 0, 437, 0, 0,
 431, 0, 0, 439, 0, 438, 327, 331, 679, 679,
 185, 428, 440, 431, 421, 0, 226, 456, 423, 431,
 423, 425, 423, 412, 416, 421, 426, 408, 409, 439,
 0, 416, 404, 404, 401, 402, 415, 400, 403, 409,
 0, 396, 0, 0, 0, 0, 0, 0, 0, 393,
 0, 401, 0, 393, 239, 407, 395, 390, 390, 406,
 175, 393, 197, 0, 405, 390, 389, 391, 388, 386,
 0, 375, 420, 377, 390, 387, 419, 376, 0, 0,

 0, 378, 387, 386, 385, 0, 384, 239, 380, 0,
 382, 374, 0, 375, 364, 367, 378, 372, 0, 0,
 366, 361, 373, 357, 358, 363, 359, 353, 364, 356,
 355, 366, 357, 362, 352, 0, 0, 353, 363, 358,
 0, 357, 356, 348, 354, 353, 353, 0, 376, 0,
 354, 0, 348, 331, 0, 322, 327, 328, 334, 319,
 317, 335, 322, 315, 327, 0, 328, 325, 0, 305,
 308, 309, 314, 0, 312, 0, 0, 312, 346, 0,
 303, 301, 0, 300, 299, 298, 0, 0, 309, 307,
 340, 312, 307, 310, 0, 305, 0, 0, 289, 0,

 302, 292, 283, 299, 281, 0, 0, 288, 290, 0,
 262, 275, 265, 266, 262, 0, 236, 234, 224, 222,
 206, 180, 153, 130, 0, 0, 103, 96, 0, 679,
 398, 401, 405, 122
};

static yyconst short int yy_def[535] =
{0,
 530, 1, 530, 530, 530, 530, 530, 530, 531, 532,
 530, 530, 533, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 530, 530, 530, 530, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 530, 530, 530, 530, 530,
 531, 530, 531, 532, 533, 533, 530, 530, 530, 530,
 530, 530, 534, 530, 530, 530, 530, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,

 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 534, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,

 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,

 532, 532, 532, 532, 530, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 530, 530, 530, 530,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,

 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,

 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 532,
 532, 532, 532, 532, 532, 532, 532, 532, 532, 0,
 530, 530, 530, 530
};

static yyconst short int yy_nxt[765] =
{0,
 4, 5, 6, 7, 8, 9, 10, 11, 12, 13,
 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
 23, 23, 24, 25, 26, 27, 28, 29, 30, 31,
 32, 10, 33, 34, 10, 35, 36, 10, 37, 10,
 38, 39, 40, 41, 42, 43, 10, 44, 45, 10,
 46, 4, 47, 48, 49, 50, 10, 51, 52, 53,
 54, 55, 10, 10, 10, 10, 56, 57, 58, 59,
 60, 61, 62, 63, 64, 10, 10, 65, 10, 10,
 10, 66, 67, 68, 69, 72, 77, 77, 77, 77,
 78, 108, 84, 84, 84, 84, 88, 89, 98, 102,

 99, 93, 104, 100, 72, 94, 80, 90, 95, 101,
 105, 109, 81, 103, 112, 96, 106, 91, 97, 119,
 82, 146, 120, 176, 147, 172, 123, 177, 113, 126,
 130, 73, 78, 80, 79, 79, 79, 79, 131, 127,
 81, 114, 124, 125, 115, 116, 128, 132, 80, 82,
 73, 117, 138, 157, 81, 160, 129, 118, 133, 134,
 140, 135, 82, 139, 136, 83, 530, 158, 141, 143,
 529, 528, 150, 75, 142, 80, 151, 144, 170, 178,
 171, 254, 81, 152, 153, 179, 187, 154, 155, 527,
 188, 82, 156, 225, 83, 226, 255, 76, 77, 77,

 77, 77, 163, 163, 163, 163, 215, 170, 171, 200,
 254, 216, 161, 260, 269, 201, 164, 202, 162, 261,
 270, 330, 165, 286, 255, 78, 526, 79, 79, 79,
 79, 169, 169, 169, 169, 359, 276, 329, 415, 161,
 374, 80, 277, 164, 375, 418, 162, 166, 525, 330,
 165, 168, 360, 168, 416, 167, 169, 169, 169, 169,
 78, 287, 84, 84, 84, 84, 329, 380, 80, 408,
 419, 381, 248, 524, 248, 166, 80, 249, 249, 249,
 249, 523, 81, 409, 167, 163, 163, 163, 163, 252,
 82, 252, 257, 522, 253, 253, 253, 253, 438, 250,

 258, 439, 521, 80, 520, 251, 249, 249, 249, 249,
 81, 169, 169, 169, 169, 249, 249, 249, 249, 82,
 257, 253, 253, 253, 253, 519, 250, 518, 517, 258,
 516, 256, 327, 251, 327, 162, 515, 328, 328, 328,
 328, 253, 253, 253, 253, 328, 328, 328, 328, 328,
 328, 328, 328, 514, 513, 512, 511, 510, 509, 256,
 508, 165, 507, 162, 506, 505, 504, 503, 502, 251,
 501, 500, 499, 498, 497, 496, 495, 494, 493, 492,
 491, 490, 489, 488, 487, 486, 485, 484, 483, 165,
 482, 481, 480, 479, 478, 477, 476, 251, 71, 71,

 71, 71, 74, 475, 74, 75, 75, 474, 75, 473,
 472, 471, 470, 469, 468, 467, 466, 465, 464, 463,
 462, 461, 460, 459, 458, 457, 456, 455, 454, 453,
 452, 451, 450, 449, 448, 447, 446, 445, 444, 443,
 442, 441, 440, 437, 436, 435, 434, 433, 432, 431,
 430, 429, 428, 427, 426, 425, 424, 423, 422, 421,
 420, 417, 414, 413, 412, 411, 410, 407, 406, 405,
 404, 403, 402, 401, 400, 399, 398, 397, 396, 395,
 394, 393, 392, 391, 390, 389, 388, 387, 386, 385,
 384, 383, 382, 379, 378, 377, 376, 373, 372, 371,

 370, 369, 368, 367, 366, 365, 364, 363, 362, 361,
 358, 357, 356, 355, 354, 353, 352, 351, 350, 349,
 348, 347, 346, 345, 344, 343, 342, 341, 340, 339,
 338, 337, 336, 335, 334, 333, 332, 331, 326, 325,
 324, 323, 322, 321, 320, 319, 318, 317, 316, 315,
 314, 313, 312, 311, 310, 309, 308, 307, 306, 305,
 304, 303, 302, 301, 300, 299, 298, 297, 296, 295,
 294, 293, 292, 291, 290, 289, 288, 285, 284, 283,
 282, 281, 280, 279, 278, 275, 274, 273, 272, 271,
 268, 267, 266, 265, 264, 263, 262, 259, 247, 246,

 245, 244, 243, 242, 241, 240, 239, 238, 237, 236,
 235, 234, 233, 232, 231, 230, 229, 228, 227, 224,
 223, 222, 221, 220, 219, 218, 217, 214, 213, 212,
 211, 210, 209, 208, 207, 206, 205, 204, 203, 199,
 198, 197, 196, 195, 194, 193, 192, 191, 190, 189,
 186, 185, 184, 183, 182, 181, 180, 175, 174, 173,
 530, 159, 149, 148, 145, 137, 122, 121, 111, 110,
 107, 92, 87, 86, 85, 76, 70, 530, 3, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,

 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530
};

static yyconst short int yy_chk[765] =
{0,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 9, 20, 20, 20, 20,
 23, 38, 23, 23, 23, 23, 30, 30, 33, 35,

 33, 32, 36, 34, 71, 32, 23, 30, 32, 34,
 36, 38, 23, 35, 41, 32, 36, 30, 32, 43,
 23, 60, 43, 91, 60, 534, 50, 91, 41, 51,
 53, 9, 22, 23, 22, 22, 22, 22, 53, 51,
 23, 42, 50, 50, 42, 42, 52, 54, 22, 23,
 71, 42, 56, 64, 22, 75, 52, 42, 54, 54,
 57, 54, 22, 56, 54, 22, 76, 64, 57, 58,
 528, 527, 63, 76, 57, 22, 63, 58, 81, 92,
 82, 166, 22, 63, 63, 92, 100, 63, 63, 524,
 100, 22, 63, 137, 22, 137, 167, 75, 77, 77,

 77, 77, 78, 78, 78, 78, 127, 81, 82, 114,
 166, 127, 77, 174, 183, 114, 78, 114, 77, 174,
 183, 258, 78, 199, 167, 79, 523, 79, 79, 79,
 79, 168, 168, 168, 168, 297, 190, 257, 381, 77,
 331, 79, 190, 78, 331, 383, 77, 79, 522, 258,
 78, 80, 297, 80, 381, 79, 80, 80, 80, 80,
 84, 199, 84, 84, 84, 84, 257, 337, 79, 375,
 383, 337, 161, 521, 161, 79, 84, 161, 161, 161,
 161, 520, 84, 375, 79, 163, 163, 163, 163, 164,
 84, 164, 172, 519, 164, 164, 164, 164, 408, 163,

 172, 408, 518, 84, 517, 163, 248, 248, 248, 248,
 84, 169, 169, 169, 169, 249, 249, 249, 249, 84,
 172, 252, 252, 252, 252, 515, 163, 514, 513, 172,
 512, 169, 250, 163, 250, 249, 511, 250, 250, 250,
 250, 253, 253, 253, 253, 327, 327, 327, 327, 328,
 328, 328, 328, 509, 508, 505, 504, 503, 502, 169,
 501, 253, 499, 249, 496, 494, 493, 492, 491, 328,
 490, 489, 486, 485, 484, 482, 481, 479, 478, 475,
 473, 472, 471, 470, 468, 467, 465, 464, 463, 253,
 462, 461, 460, 459, 458, 457, 456, 328, 531, 531,

 531, 531, 532, 454, 532, 533, 533, 453, 533, 451,
 449, 447, 446, 445, 444, 443, 442, 440, 439, 438,
 435, 434, 433, 432, 431, 430, 429, 428, 427, 426,
 425, 424, 423, 422, 421, 418, 417, 416, 415, 414,
 412, 411, 409, 407, 405, 404, 403, 402, 398, 397,
 396, 395, 394, 393, 392, 390, 389, 388, 387, 386,
 385, 382, 380, 379, 378, 377, 376, 374, 372, 370,
 362, 360, 359, 358, 357, 356, 355, 354, 353, 352,
 350, 349, 348, 347, 346, 345, 344, 343, 342, 341,
 340, 339, 338, 335, 334, 333, 332, 326, 324, 321,

 318, 316, 315, 311, 310, 309, 307, 304, 302, 300,
 296, 293, 291, 290, 289, 288, 286, 285, 284, 283,
 281, 280, 279, 278, 277, 276, 275, 274, 271, 270,
 269, 268, 267, 265, 263, 261, 260, 259, 247, 246,
 245, 243, 242, 241, 240, 239, 238, 237, 236, 234,
 233, 232, 231, 228, 227, 224, 222, 221, 220, 218,
 217, 216, 215, 214, 213, 212, 211, 210, 209, 208,
 207, 205, 204, 203, 202, 201, 200, 198, 197, 196,
 195, 194, 193, 192, 191, 189, 188, 187, 185, 184,
 182, 181, 180, 179, 178, 177, 176, 173, 159, 157,

 156, 155, 154, 153, 152, 151, 150, 149, 148, 147,
 146, 145, 144, 143, 142, 141, 140, 139, 138, 136,
 135, 134, 133, 132, 131, 130, 128, 126, 125, 124,
 123, 122, 121, 120, 119, 118, 117, 116, 115, 113,
 112, 111, 109, 108, 107, 106, 105, 103, 102, 101,
 99, 98, 97, 96, 95, 94, 93, 90, 89, 88,
 73, 65, 62, 61, 59, 55, 45, 44, 40, 39,
 37, 31, 28, 27, 26, 13, 8, 3, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,

 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530, 530, 530, 530, 530, 530, 530,
 530, 530, 530, 530
};

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "calcl.l"
#define INITIAL 0
#line 10 "calcl.l"
#include <stdio.h>
#include "y.tab.h"
#include "input.h"

#ifdef MYLEXDEBUG
#define LEXRETURN(x) printf("Lex: %d (%s)\n", (x), yytext); catnewstring(yytext); return (x)
#else
#define LEXRETURN(x) catnewstring(yytext); return(x)
#endif

extern int yylval;
#line 726 "lex.yy.c"

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO ((void));
#else
extern int yywrap YY_PROTO ((void));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO ((int c, char *buf_ptr));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO ((char *, yyconst char *, int));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO ((yyconst char *));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO ((void));
#else
static int input YY_PROTO ((void));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO ((int new_state));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO ((void));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO ((void));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else

#endif
#endif

#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

#ifndef ECHO

#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactiv ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETVAL36 \
	YY_USER_ACTION

YY_DECL
{
  register yy_state_type yy_current_state;
  register char *yy_cp, *yy_bp;
  register int yy_act;

#line 26 "calcl.l"

#line 879 "lex.yy.c"

  if (yy_init)
    {
      yy_init = 0;

#ifdef YY_USER_INIT
      YY_USER_INIT;
#endif

      if (!yy_start)
	yy_start = 1;

      if (!yyin)
	yyin = stdin;

      if (!yyout)
	yyout = stdout;

      if (!yy_current_buffer)
	yy_current_buffer =
	  yy_create_buffer (yyin, YY_BUF_SIZE);

      yy_load_buffer_state ();
    }

  while (1)
    {
      yy_cp = yy_c_buf_p;

      *yy_cp = yy_hold_char;

      yy_bp = yy_cp;

      yy_current_state = yy_start;
    yy_match:
      do
	{
	  register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI (*yy_cp)];
	  if (yy_accept[yy_current_state])
	    {
	      yy_last_accepting_state = yy_current_state;
	      yy_last_accepting_cpos = yy_cp;
	    }
	  while (yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
	    {
	      yy_current_state = (int) yy_def[yy_current_state];
	      if (yy_current_state >= 531)
		yy_c = yy_meta[(unsigned int) yy_c];
	    }
	  yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	  ++yy_cp;
	}
      while (yy_base[yy_current_state] != 679);

    yy_f_action:
      yy_act = yy_accept[yy_current_state];
      if (yy_act == 0)
	{
	  yy_cp = yy_last_accepting_cpos;
	  yy_current_state = yy_last_accepting_state;
	  yy_act = yy_accept[yy_current_state];
	}

      YY_DO_BEFORE_ACTION;

    do_action:

      switch (yy_act)
	{
	case 0:

	  *yy_cp = yy_hold_char;
	  yy_cp = yy_last_accepting_cpos;
	  yy_current_state = yy_last_accepting_state;
	  goto yy_f_action;

	case 1:
	  YY_RULE_SETVAL36
#line 27 "calcl.l"
	  {
	    LEXRETURN (ACOS);
	  }
	  YY_BREAK
	case 2:
	  YY_RULE_SETVAL36
#line 28 "calcl.l"
	  {
	    LEXRETURN (ASIN);
	  }
	  YY_BREAK
	case 3:
	  YY_RULE_SETVAL36
#line 29 "calcl.l"
	  {
	    LEXRETURN (ATAN);
	  }
	  YY_BREAK
	case 4:
	  YY_RULE_SETVAL36
#line 30 "calcl.l"
	  {
	    LEXRETURN (ATAN2);
	  }
	  YY_BREAK
	case 5:
	  YY_RULE_SETVAL36
#line 31 "calcl.l"
	  {
	    LEXRETURN (CEIL);
	  }
	  YY_BREAK
	case 6:
	  YY_RULE_SETVAL36
#line 32 "calcl.l"
	  {
	    LEXRETURN (CONCATENATE);
	  }
	  YY_BREAK
	case 7:
	  YY_RULE_SETVAL36
#line 33 "calcl.l"
	  {
	    LEXRETURN (COS);
	  }
	  YY_BREAK
	case 8:
	  YY_RULE_SETVAL36
#line 34 "calcl.l"
	  {
	    LEXRETURN (COSH);
	  }
	  YY_BREAK
	case 9:
	  YY_RULE_SETVAL36
#line 35 "calcl.l"
	  {
	    LEXRETURN (EPT);
	  }
	  YY_BREAK
	case 10:
	  YY_RULE_SETVAL36
#line 36 "calcl.l"
	  {
	    LEXRETURN (EXP);
	  }
	  YY_BREAK
	case 11:
	  YY_RULE_SETVAL36
#line 37 "calcl.l"
	  {
	    LEXRETURN (FABS);
	  }
	  YY_BREAK
	case 12:
	  YY_RULE_SETVAL36
#line 38 "calcl.l"
	  {
	    LEXRETURN (FLOOR);
	  }
	  YY_BREAK
	case 13:
	  YY_RULE_SETVAL36
#line 39 "calcl.l"
	  {
	    LEXRETURN (FMOD);
	  }
	  YY_BREAK
	case 14:
	  YY_RULE_SETVAL36
#line 40 "calcl.l"
	  {
	    LEXRETURN (FREXP);
	  }
	  YY_BREAK
	case 15:
	  YY_RULE_SETVAL36
#line 41 "calcl.l"
	  {
	    LEXRETURN (GPD);
	  }
	  YY_BREAK
	case 16:
	  YY_RULE_SETVAL36
#line 42 "calcl.l"
	  {
	    LEXRETURN (GPF);
	  }
	  YY_BREAK
	case 17:
	  YY_RULE_SETVAL36
#line 43 "calcl.l"
	  {
	    LEXRETURN (LDEXP);
	  }
	  YY_BREAK
	case 18:
	  YY_RULE_SETVAL36
#line 44 "calcl.l"
	  {
	    LEXRETURN (LOG);
	  }
	  YY_BREAK
	case 19:
	  YY_RULE_SETVAL36
#line 45 "calcl.l"
	  {
	    LEXRETURN (LOG10);
	  }
	  YY_BREAK
	case 20:
	  YY_RULE_SETVAL36
#line 46 "calcl.l"
	  {
	    LEXRETURN (absMAX);
	  }
	  YY_BREAK
	case 21:
	  YY_RULE_SETVAL36
#line 47 "calcl.l"
	  {
	    LEXRETURN (absMIN);
	  }
	  YY_BREAK
	case 22:
	  YY_RULE_SETVAL36
#line 48 "calcl.l"
	  {
	    LEXRETURN (MODF);
	  }
	  YY_BREAK
	case 23:
	  YY_RULE_SETVAL36
#line 49 "calcl.l"
	  {
	    LEXRETURN (MAXMEAN);
	  }
	  YY_BREAK
	case 24:
	  YY_RULE_SETVAL36
#line 50 "calcl.l"
	  {
	    LEXRETURN (ORDER);
	  }
	  YY_BREAK
	case 25:
	  YY_RULE_SETVAL36
#line 51 "calcl.l"
	  {
	    LEXRETURN (POW);
	  }
	  YY_BREAK
	case 26:
	  YY_RULE_SETVAL36
#line 52 "calcl.l"
	  {
	    LEXRETURN (SEND);
	  }
	  YY_BREAK
	case 27:
	  YY_RULE_SETVAL36
#line 53 "calcl.l"
	  {
	    LEXRETURN (SIN);
	  }
	  YY_BREAK
	case 28:
	  YY_RULE_SETVAL36
#line 54 "calcl.l"
	  {
	    LEXRETURN (SINH);
	  }
	  YY_BREAK
	case 29:
	  YY_RULE_SETVAL36
#line 55 "calcl.l"
	  {
	    LEXRETURN (SPAWN);
	  }
	  YY_BREAK
	case 30:
	  YY_RULE_SETVAL36
#line 56 "calcl.l"
	  {
	    LEXRETURN (SQRT);
	  }
	  YY_BREAK
	case 31:
	  YY_RULE_SETVAL36
#line 57 "calcl.l"
	  {
	    LEXRETURN (SUM);
	  }
	  YY_BREAK
	case 32:
	  YY_RULE_SETVAL36
#line 58 "calcl.l"
	  {
	    LEXRETURN (RECEIVE);
	  }
	  YY_BREAK
	case 33:
	  YY_RULE_SETVAL36
#line 59 "calcl.l"
	  {
	    LEXRETURN (TAN);
	  }
	  YY_BREAK
	case 34:
	  YY_RULE_SETVAL36
#line 60 "calcl.l"
	  {
	    LEXRETURN (TANH);
	  }
	  YY_BREAK
	case 35:
	  YY_RULE_SETVAL36
#line 62 "calcl.l"
	  {
	    LEXRETURN (IF);
	  }
	  YY_BREAK
	case 36:
	  YY_RULE_SETVAL36
#line 63 "calcl.l"
	  {
	    LEXRETURN (THEN);
	  }
	  YY_BREAK
	case 37:
	  YY_RULE_SETVAL36
#line 64 "calcl.l"
	  {
	    LEXRETURN (ELSE);
	  }
	  YY_BREAK
	case 38:
	  YY_RULE_SETVAL36
#line 65 "calcl.l"
	  {
	    LEXRETURN (FOR);
	  }
	  YY_BREAK
	case 39:
	  YY_RULE_SETVAL36
#line 66 "calcl.l"
	  {
	    LEXRETURN (DO);
	  }
	  YY_BREAK
	case 40:
	  YY_RULE_SETVAL36
#line 67 "calcl.l"
	  {
	    LEXRETURN (DEBUG);
	  }
	  YY_BREAK
	case 41:
	  YY_RULE_SETVAL36
#line 68 "calcl.l"
	  {
	    LEXRETURN (PRINT);
	  }
	  YY_BREAK
	case 42:
	  YY_RULE_SETVAL36
#line 69 "calcl.l"
	  {
	    LEXRETURN (QUIT);
	  }
	  YY_BREAK
	case 43:
	  YY_RULE_SETVAL36
#line 70 "calcl.l"
	  {
	    LEXRETURN (SYSTEM);
	  }
	  YY_BREAK
	case 44:
	  YY_RULE_SETVAL36
#line 71 "calcl.l"
	  {
	    LEXRETURN (NEXT);
	  }
	  YY_BREAK
	case 45:
	  YY_RULE_SETVAL36
#line 72 "calcl.l"
	  {
	    LEXRETURN (TO);
	  }
	  YY_BREAK
	case 46:
	  YY_RULE_SETVAL36
#line 73 "calcl.l"
	  {
	    LEXRETURN (STEP);
	  }
	  YY_BREAK
	case 47:
	  YY_RULE_SETVAL36
#line 75 "calcl.l"
	  {
	    LEXRETURN (WHILE);
	  }
	  YY_BREAK
	case 48:
	  YY_RULE_SETVAL36
#line 77 "calcl.l"
	  {
	    LEXRETURN (ACTIVATE);
	  }
	  YY_BREAK
	case 49:
	  YY_RULE_SETVAL36
#line 78 "calcl.l"
	  {
	    LEXRETURN (ACTIVECHART);
	  }
	  YY_BREAK
	case 50:
	  YY_RULE_SETVAL36
#line 79 "calcl.l"
	  {
	    LEXRETURN (ACTIVECELL);
	  }
	  YY_BREAK
	case 51:
	  YY_RULE_SETVAL36
#line 80 "calcl.l"
	  {
	    LEXRETURN (ACTIVESHEET);
	  }
	  YY_BREAK
	case 52:
	  YY_RULE_SETVAL36
#line 81 "calcl.l"
	  {
	    LEXRETURN (ADD);
	  }
	  YY_BREAK
	case 53:
	  YY_RULE_SETVAL36
#line 82 "calcl.l"
	  {
	    LEXRETURN (ADDLINE);
	  }
	  YY_BREAK
	case 54:
	  YY_RULE_SETVAL36
#line 83 "calcl.l"
	  {
	    LEXRETURN (ADDSHAPE);
	  }
	  YY_BREAK
	case 55:
	  YY_RULE_SETVAL36
#line 84 "calcl.l"
	  {
	    LEXRETURN (AND);
	  }
	  YY_BREAK
	case 56:
	  YY_RULE_SETVAL36
#line 85 "calcl.l"
	  {
	    LEXRETURN (AXES);
	  }
	  YY_BREAK
	case 57:
	  YY_RULE_SETVAL36
#line 86 "calcl.l"
	  {
	    LEXRETURN (AXISTITLE);
	  }
	  YY_BREAK
	case 58:
	  YY_RULE_SETVAL36
#line 87 "calcl.l"
	  {
	    LEXRETURN (BORDERS);
	  }
	  YY_BREAK
	case 59:
	  YY_RULE_SETVAL36
#line 88 "calcl.l"
	  {
	    LEXRETURN (BOLD);
	  }
	  YY_BREAK
	case 60:
	  YY_RULE_SETVAL36
#line 89 "calcl.l"
	  {
	    LEXRETURN (CALL);
	  }
	  YY_BREAK
	case 61:
	  YY_RULE_SETVAL36
#line 90 "calcl.l"
	  {
	    LEXRETURN (CELLS);
	  }
	  YY_BREAK
	case 62:
	  YY_RULE_SETVAL36
#line 91 "calcl.l"
	  {
	    LEXRETURN (CHARTOBJECTS);
	  }
	  YY_BREAK
	case 63:
	  YY_RULE_SETVAL36
#line 92 "calcl.l"
	  {
	    LEXRETURN (CHARTTITLE);
	  }
	  YY_BREAK
	case 64:
	  YY_RULE_SETVAL36
#line 93 "calcl.l"
	  {
	    LEXRETURN (CHARTTYPE);
	  }
	  YY_BREAK
	case 65:
	  YY_RULE_SETVAL36
#line 94 "calcl.l"
	  {
	    LEXRETURN (COLUMNS);
	  }
	  YY_BREAK
	case 66:
	  YY_RULE_SETVAL36
#line 95 "calcl.l"
	  {
	    LEXRETURN (COLUMNWIDTH);
	  }
	  YY_BREAK
	case 67:
	  YY_RULE_SETVAL36
#line 96 "calcl.l"
	  {
	    LEXRETURN (COLORINDEX);
	  }
	  YY_BREAK
	case 68:
	  YY_RULE_SETVAL36
#line 97 "calcl.l"
	  {
	    LEXRETURN (CREATE);
	  }
	  YY_BREAK
	case 69:
	  YY_RULE_SETVAL36
#line 98 "calcl.l"
	  {
	    LEXRETURN (END);
	  }
	  YY_BREAK
	case 70:
	  YY_RULE_SETVAL36
#line 99 "calcl.l"
	  {
	    LEXRETURN (FORMULA);
	  }
	  YY_BREAK
	case 71:
	  YY_RULE_SETVAL36
#line 100 "calcl.l"
	  {
	    LEXRETURN (FONT);
	  }
	  YY_BREAK
	case 72:
	  YY_RULE_SETVAL36
#line 101 "calcl.l"
	  {
	    LEXRETURN (FUNCTION);
	  }
	  YY_BREAK
	case 73:
	  YY_RULE_SETVAL36
#line 102 "calcl.l"
	  {
	    LEXRETURN (HASMAJORGRIDLINES);
	  }
	  YY_BREAK
	case 74:
	  YY_RULE_SETVAL36
#line 103 "calcl.l"
	  {
	    LEXRETURN (HASTITLE);
	  }
	  YY_BREAK
	case 75:
	  YY_RULE_SETVAL36
#line 104 "calcl.l"
	  {
	    LEXRETURN (HORIZONTALALIGNMENT);
	  }
	  YY_BREAK
	case 76:
	  YY_RULE_SETVAL36
#line 105 "calcl.l"
	  {
	    LEXRETURN (INTERIOR);
	  }
	  YY_BREAK
	case 77:
	  YY_RULE_SETVAL36
#line 106 "calcl.l"
	  {
	    LEXRETURN (ITALIC);
	  }
	  YY_BREAK
	case 78:
	  YY_RULE_SETVAL36
#line 107 "calcl.l"
	  {
	    LEXRETURN (LINESTYLE);
	  }
	  YY_BREAK
	case 79:
	  YY_RULE_SETVAL36
#line 108 "calcl.l"
	  {
	    LEXRETURN (NAME);
	  }
	  YY_BREAK
	case 80:
	  YY_RULE_SETVAL36
#line 109 "calcl.l"
	  {
	    LEXRETURN (NUMBERFORMAT);
	  }
	  YY_BREAK
	case 81:
	  YY_RULE_SETVAL36
#line 110 "calcl.l"
	  {
	    LEXRETURN (OR);
	  }
	  YY_BREAK
	case 82:
	  YY_RULE_SETVAL36
#line 111 "calcl.l"
	  {
	    LEXRETURN (PRINTOUT);
	  }
	  YY_BREAK
	case 83:
	  YY_RULE_SETVAL36
#line 112 "calcl.l"
	  {
	    LEXRETURN (RANGE);
	  }
	  YY_BREAK
	case 84:
	  YY_RULE_SETVAL36
#line 113 "calcl.l"
	  {
	    LEXRETURN (ROWS);
	  }
	  YY_BREAK
	case 85:
	  YY_RULE_SETVAL36
#line 114 "calcl.l"
	  {
	    LEXRETURN (ROWHEIGHT);
	  }
	  YY_BREAK
	case 86:
	  YY_RULE_SETVAL36
#line 115 "calcl.l"
	  {
	    LEXRETURN (SELECT);
	  }
	  YY_BREAK
	case 87:
	  YY_RULE_SETVAL36
#line 116 "calcl.l"
	  {
	    LEXRETURN (SELECTION);
	  }
	  YY_BREAK
	case 88:
	  YY_RULE_SETVAL36
#line 117 "calcl.l"
	  {
	    LEXRETURN (SETSOURCEDATA);
	  }
	  YY_BREAK
	case 89:
	  YY_RULE_SETVAL36
#line 118 "calcl.l"
	  {
	    LEXRETURN (SERIESCOLLECTION);
	  }
	  YY_BREAK
	case 90:
	  YY_RULE_SETVAL36
#line 119 "calcl.l"
	  {
	    LEXRETURN (SHAPES);
	  }
	  YY_BREAK
	case 91:
	  YY_RULE_SETVAL36
#line 120 "calcl.l"
	  {
	    LEXRETURN (SIZE);
	  }
	  YY_BREAK
	case 92:
	  YY_RULE_SETVAL36
#line 121 "calcl.l"
	  {
	    LEXRETURN (SOURCE);
	  }
	  YY_BREAK
	case 93:
	  YY_RULE_SETVAL36
#line 122 "calcl.l"
	  {
	    LEXRETURN (SUB);
	  }
	  YY_BREAK
	case 94:
	  YY_RULE_SETVAL36
#line 123 "calcl.l"
	  {
	    LEXRETURN (TEXT);
	  }
	  YY_BREAK
	case 95:
	  YY_RULE_SETVAL36
#line 124 "calcl.l"
	  {
	    LEXRETURN (VALUES);
	  }
	  YY_BREAK
	case 96:
	  YY_RULE_SETVAL36
#line 125 "calcl.l"
	  {
	    LEXRETURN (WORKBOOKS);
	  }
	  YY_BREAK
	case 97:
	  YY_RULE_SETVAL36
#line 126 "calcl.l"
	  {
	    LEXRETURN (WORKSHEETS);
	  }
	  YY_BREAK
	case 98:
	  YY_RULE_SETVAL36
#line 128 "calcl.l"
	  {
	    int t;
	    FillTokenBuf (yytext);
	    t = check_type ();
	    LEXRETURN (t);
	  }
	  YY_BREAK
	case 99:
	  YY_RULE_SETVAL36
#line 130 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 100:
	  YY_RULE_SETVAL36
#line 131 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 101:
	  YY_RULE_SETVAL36
#line 132 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 102:
	  YY_RULE_SETVAL36
#line 133 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 103:
	  YY_RULE_SETVAL36
#line 134 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 104:
	  YY_RULE_SETVAL36
#line 135 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (INTEGER_CONSTANT);
	  }
	  YY_BREAK
	case 105:
	  YY_RULE_SETVAL36
#line 137 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (CHARACTER_CONSTANT);
	  }
	  YY_BREAK
	case 106:
	  YY_RULE_SETVAL36
#line 139 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (FLOATING_CONSTANT);
	  }
	  YY_BREAK
	case 107:
	  YY_RULE_SETVAL36
#line 140 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (FLOATING_CONSTANT);
	  }
	  YY_BREAK
	case 108:
	  YY_RULE_SETVAL36
#line 141 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (FLOATING_CONSTANT);
	  }
	  YY_BREAK
	case 109:
	  YY_RULE_SETVAL36
#line 143 "calcl.l"
	  {
	    FillTokenBuf (yytext);
	    LEXRETURN (STRING_CONSTANT);
	  }
	  YY_BREAK
	case 110:
	  YY_RULE_SETVAL36
#line 146 "calcl.l"
	  {
	    LEXRETURN (';');
	  }
	  YY_BREAK
	case 111:
	  YY_RULE_SETVAL36
#line 147 "calcl.l"
	  {
	    LEXRETURN ('{');
	  }
	  YY_BREAK
	case 112:
	  YY_RULE_SETVAL36
#line 148 "calcl.l"
	  {
	    LEXRETURN ('}');
	  }
	  YY_BREAK
	case 113:
	  YY_RULE_SETVAL36
#line 149 "calcl.l"
	  {
	    LEXRETURN (',');
	  }
	  YY_BREAK
	case 114:
	  YY_RULE_SETVAL36
#line 150 "calcl.l"
	  {
	    LEXRETURN (':');
	  }
	  YY_BREAK
	case 115:
	  YY_RULE_SETVAL36
#line 151 "calcl.l"
	  {
	    LEXRETURN ('=');
	  }
	  YY_BREAK
	case 116:
	  YY_RULE_SETVAL36
#line 152 "calcl.l"
	  {
	    LEXRETURN (EQ);
	  }
	  YY_BREAK
	case 117:
	  YY_RULE_SETVAL36
#line 153 "calcl.l"
	  {
	    LEXRETURN ('(');
	  }
	  YY_BREAK
	case 118:
	  YY_RULE_SETVAL36
#line 154 "calcl.l"
	  {
	    LEXRETURN (')');
	  }
	  YY_BREAK
	case 119:
	  YY_RULE_SETVAL36
#line 155 "calcl.l"
	  {
	    LEXRETURN ('[');
	  }
	  YY_BREAK
	case 120:
	  YY_RULE_SETVAL36
#line 156 "calcl.l"
	  {
	    LEXRETURN (']');
	  }
	  YY_BREAK
	case 121:
	  YY_RULE_SETVAL36
#line 157 "calcl.l"
	  {
	    LEXRETURN ('.');
	  }
	  YY_BREAK
	case 122:
	  YY_RULE_SETVAL36
#line 158 "calcl.l"
	  {
	    LEXRETURN ('&');
	  }
	  YY_BREAK
	case 123:
	  YY_RULE_SETVAL36
#line 159 "calcl.l"
	  {
	    LEXRETURN ('!');
	  }
	  YY_BREAK
	case 124:
	  YY_RULE_SETVAL36
#line 160 "calcl.l"
	  {
	    LEXRETURN (NE);
	  }
	  YY_BREAK
	case 125:
	  YY_RULE_SETVAL36
#line 161 "calcl.l"
	  {
	    LEXRETURN ('~');
	  }
	  YY_BREAK
	case 126:
	  YY_RULE_SETVAL36
#line 162 "calcl.l"
	  {
	    LEXRETURN ('-');
	  }
	  YY_BREAK
	case 127:
	  YY_RULE_SETVAL36
#line 163 "calcl.l"
	  {
	    LEXRETURN ('+');
	  }
	  YY_BREAK
	case 128:
	  YY_RULE_SETVAL36
#line 164 "calcl.l"
	  {
	    LEXRETURN ('*');
	  }
	  YY_BREAK
	case 129:
	  YY_RULE_SETVAL36
#line 165 "calcl.l"
	  {
	    LEXRETURN ('/');
	  }
	  YY_BREAK
	case 130:
	  YY_RULE_SETVAL36
#line 166 "calcl.l"
	  {
	    LEXRETURN ('%');
	  }
	  YY_BREAK
	case 131:
	  YY_RULE_SETVAL36
#line 167 "calcl.l"
	  {
	    LEXRETURN (LT);
	  }
	  YY_BREAK
	case 132:
	  YY_RULE_SETVAL36
#line 168 "calcl.l"
	  {
	    LEXRETURN (LE);
	  }
	  YY_BREAK
	case 133:
	  YY_RULE_SETVAL36
#line 169 "calcl.l"
	  {
	    LEXRETURN (GT);
	  }
	  YY_BREAK
	case 134:
	  YY_RULE_SETVAL36
#line 170 "calcl.l"
	  {
	    LEXRETURN (GE);
	  }
	  YY_BREAK
	case 135:
	  YY_RULE_SETVAL36
#line 171 "calcl.l"
	  {
	    LEXRETURN ('^');
	  }
	  YY_BREAK
	case 136:
	  YY_RULE_SETVAL36
#line 172 "calcl.l"
	  {
	    LEXRETURN ('|');
	  }
	  YY_BREAK
	case 137:
	  YY_RULE_SETVAL36
#line 173 "calcl.l"
	  {
	    LEXRETURN ('?');
	  }
	  YY_BREAK
	case 138:
	  YY_RULE_SETVAL36
#line 174 "calcl.l"
	  {
	    LEXRETURN ('_');
	  }
	  YY_BREAK
	case 139:
	  YY_RULE_SETVAL36
#line 176 "calcl.l"
	  {
	    LEXRETURN (NEWLINE);
	  }
	  YY_BREAK
	case 140:
	  YY_RULE_SETVAL36
#line 177 "calcl.l"
	  {
	  }
	  YY_BREAK
	case 141:
	  YY_RULE_SETVAL36
#line 179 "calcl.l"
	  {
	  }
	  YY_BREAK
	case 142:
	  YY_RULE_SETVAL36
#line 181 "calcl.l"
	  {
	  }
	  YY_BREAK
	case 143:
	  YY_RULE_SETVAL36
#line 183 "calcl.l"
	    ECHO;
	  YY_BREAK
#line 1677 "lex.yy.c"
	case YY_STATE_EOF (INITIAL):
	  yyterminate ();

	case YY_END_OF_BUFFER:
	  {

	    int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

	    *yy_cp = yy_hold_char;
	    YY_RESTORE_YY_MORE_OFFSET

	      if (yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW)
	      {

		yy_n_chars = yy_current_buffer->yy_n_chars;
		yy_current_buffer->yy_input_file = yyin;
		yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
	      }

	    if (yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars])
	      {
		yy_state_type yy_next_state;

		yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

		yy_current_state = yy_g_previous_state ();

		yy_next_state = yy_try_NUL_trans (yy_current_state);

		yy_bp = yytext_ptr + YY_MORE_ADJ;

		if (yy_next_state)
		  {

		    yy_cp = ++yy_c_buf_p;
		    yy_current_state = yy_next_state;
		    goto yy_match;
		  }

		else
		  {
		    yy_cp = yy_c_buf_p;
		    goto yy_f_action;
		  }
	      }

	    else
	      switch (yy_g_next_buffer ())
		{
		case EOB_ACT_END_OF_FILE:
		  {
		    yy_did_buffer_switch_on_eof = 0;

		    if (yywrap ())
		      {

			yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

			yy_act = YY_STATE_EOF (YY_START);
			goto do_action;
		      }

		    else
		      {
			if (!yy_did_buffer_switch_on_eof)
			  YY_NEW_FILE;
		      }
		    break;
		  }

		case EOB_ACT_CONTINUE_SCAN:
		  yy_c_buf_p =
		    yytext_ptr + yy_amount_of_matched_text;

		  yy_current_state = yy_g_previous_state ();

		  yy_cp = yy_c_buf_p;
		  yy_bp = yytext_ptr + YY_MORE_ADJ;
		  goto yy_match;

		case EOB_ACT_LAST_MATCH:
		  yy_c_buf_p =
		    &yy_current_buffer->yy_ch_buf[yy_n_chars];

		  yy_current_state = yy_g_previous_state ();

		  yy_cp = yy_c_buf_p;
		  yy_bp = yytext_ptr + YY_MORE_ADJ;
		  goto yy_f_action;
		}
	    break;
	  }

	default:
	  YY_FATAL_ERROR (
		      "fatal flex scanner internal error--no action found");
	}
    }
}

static int
yy_g_next_buffer ()
{
  register char *dest = yy_current_buffer->yy_ch_buf;
  register char *source = yytext_ptr;
  register int number_to_move, i;
  int ret_val;

  if (yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1])
    YY_FATAL_ERROR (
		 "fatal flex scanner internal error--end of buffer missed");

  if (yy_current_buffer->yy_fill_buffer == 0)
    {
      if (yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1)
	{

	  return EOB_ACT_END_OF_FILE;
	}

      else
	{

	  return EOB_ACT_LAST_MATCH;
	}
    }

  number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

  for (i = 0; i < number_to_move; ++i)
    *(dest++) = *(source++);

  if (yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING)

    yy_current_buffer->yy_n_chars = yy_n_chars = 0;

  else
    {
      int num_to_r =
      yy_current_buffer->yy_buf_size - number_to_move - 1;

      while (num_to_r <= 0)
	{
#ifdef YY_USES_REJECT
	  YY_FATAL_ERROR (
			   "input buffer overflow, can't enlarge buffer because scanner uses REJECT");
#else

	  YY_BUFFER_STATE b = yy_current_buffer;

	  int yy_c_buf_p_offset =
	  (int) (yy_c_buf_p - b->yy_ch_buf);

	  if (b->yy_is_our_buffer)
	    {
	      int new_size = b->yy_buf_size * 2;

	      if (new_size <= 0)
		b->yy_buf_size += b->yy_buf_size / 8;
	      else
		b->yy_buf_size *= 2;

	      b->yy_ch_buf = (char *)

		yy_flex_realloc ((void *) b->yy_ch_buf,
				 b->yy_buf_size + 2);
	    }
	  else
	    b->yy_ch_buf = 0;

	  if (!b->yy_ch_buf)
	    YY_FATAL_ERROR (
			     "fatal error - scanner input buffer overflow");

	  yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

	  num_to_r = yy_current_buffer->yy_buf_size -
	    number_to_move - 1;
#endif
	}

      if (num_to_r > YY_READ_BUF_SIZE)
	num_to_r = YY_READ_BUF_SIZE;

      YY_INPUT ((&yy_current_buffer->yy_ch_buf[number_to_move]),
		yy_n_chars, num_to_r);

      yy_current_buffer->yy_n_chars = yy_n_chars;
    }

  if (yy_n_chars == 0)
    {
      if (number_to_move == YY_MORE_ADJ)
	{
	  ret_val = EOB_ACT_END_OF_FILE;
	  yyrestart (yyin);
	}

      else
	{
	  ret_val = EOB_ACT_LAST_MATCH;
	  yy_current_buffer->yy_buffer_status =
	    YY_BUFFER_EOF_PENDING;
	}
    }

  else
    ret_val = EOB_ACT_CONTINUE_SCAN;

  yy_n_chars += number_to_move;
  yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
  yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

  yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

  return ret_val;
}

static yy_state_type
yy_g_previous_state ()
{
  register yy_state_type yy_current_state;
  register char *yy_cp;

  yy_current_state = yy_start;

  for (yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp)
    {
      register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI (*yy_cp)] : 1);
      if (yy_accept[yy_current_state])
	{
	  yy_last_accepting_state = yy_current_state;
	  yy_last_accepting_cpos = yy_cp;
	}
      while (yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
	{
	  yy_current_state = (int) yy_def[yy_current_state];
	  if (yy_current_state >= 531)
	    yy_c = yy_meta[(unsigned int) yy_c];
	}
      yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
    }

  return yy_current_state;
}

#ifdef YY_USE_PROTOS
static yy_state_type
yy_try_NUL_trans (yy_state_type yy_current_state)
#else
static yy_state_type
yy_try_NUL_trans (yy_current_state)
     yy_state_type yy_current_state;
#endif
{
  register int yy_is_jam;
  register char *yy_cp = yy_c_buf_p;

  register YY_CHAR yy_c = 1;
  if (yy_accept[yy_current_state])
    {
      yy_last_accepting_state = yy_current_state;
      yy_last_accepting_cpos = yy_cp;
    }
  while (yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
    {
      yy_current_state = (int) yy_def[yy_current_state];
      if (yy_current_state >= 531)
	yy_c = yy_meta[(unsigned int) yy_c];
    }
  yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
  yy_is_jam = (yy_current_state == 530);

  return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void
yyunput (int c, register char *yy_bp)
#else
static void
yyunput (c, yy_bp)
     int c;
     register char *yy_bp;
#endif
{
  register char *yy_cp = yy_c_buf_p;

  *yy_cp = yy_hold_char;

  if (yy_cp < yy_current_buffer->yy_ch_buf + 2)
    {

      register int number_to_move = yy_n_chars + 2;
      register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
      register char *source =
      &yy_current_buffer->yy_ch_buf[number_to_move];

      while (source > yy_current_buffer->yy_ch_buf)
	*--dest = *--source;

      yy_cp += (int) (dest - source);
      yy_bp += (int) (dest - source);
      yy_current_buffer->yy_n_chars =
	yy_n_chars = yy_current_buffer->yy_buf_size;

      if (yy_cp < yy_current_buffer->yy_ch_buf + 2)
	YY_FATAL_ERROR ("flex scanner push-back overflow");
    }

  *--yy_cp = (char) c;

  yytext_ptr = yy_bp;
  yy_hold_char = *yy_cp;
  yy_c_buf_p = yy_cp;
}
#endif

#ifdef __cplusplus
static int
yyinput ()
#else
static int
input ()
#endif
{
  int c;

  *yy_c_buf_p = yy_hold_char;

  if (*yy_c_buf_p == YY_END_OF_BUFFER_CHAR)
    {

      if (yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars])

	*yy_c_buf_p = '\0';

      else
	{
	  int offset = yy_c_buf_p - yytext_ptr;
	  ++yy_c_buf_p;

	  switch (yy_g_next_buffer ())
	    {
	    case EOB_ACT_LAST_MATCH:

	      yyrestart (yyin);

	    case EOB_ACT_END_OF_FILE:
	      {
		if (yywrap ())
		  return EOF;

		if (!yy_did_buffer_switch_on_eof)
		  YY_NEW_FILE;
#ifdef __cplusplus
		return yyinput ();
#else
		return input ();
#endif
	      }

	    case EOB_ACT_CONTINUE_SCAN:
	      yy_c_buf_p = yytext_ptr + offset;
	      break;
	    }
	}
    }

  c = *(unsigned char *) yy_c_buf_p;
  *yy_c_buf_p = '\0';
  yy_hold_char = *++yy_c_buf_p;

  return c;
}

#ifdef YY_USE_PROTOS
void
yyrestart (FILE * input_file)
#else
void
yyrestart (input_file)
     FILE *input_file;
#endif
{
  if (!yy_current_buffer)
    yy_current_buffer = yy_create_buffer (yyin, YY_BUF_SIZE);

  yy_init_buffer (yy_current_buffer, input_file);
  yy_load_buffer_state ();
}

#ifdef YY_USE_PROTOS
void
yy_switch_to_buffer (YY_BUFFER_STATE new_buffer)
#else
void
yy_switch_to_buffer (new_buffer)
     YY_BUFFER_STATE new_buffer;
#endif
{
  if (yy_current_buffer == new_buffer)
    return;

  if (yy_current_buffer)
    {

      *yy_c_buf_p = yy_hold_char;
      yy_current_buffer->yy_buf_pos = yy_c_buf_p;
      yy_current_buffer->yy_n_chars = yy_n_chars;
    }

  yy_current_buffer = new_buffer;
  yy_load_buffer_state ();

  yy_did_buffer_switch_on_eof = 1;
}

#ifdef YY_USE_PROTOS
void
yy_load_buffer_state (void)
#else
void
yy_load_buffer_state ()
#endif
{
  yy_n_chars = yy_current_buffer->yy_n_chars;
  yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
  yyin = yy_current_buffer->yy_input_file;
  yy_hold_char = *yy_c_buf_p;
}

#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_create_buffer (FILE * file, int size)
#else
YY_BUFFER_STATE
yy_create_buffer (file, size)
     FILE *file;
     int size;
#endif
{
  YY_BUFFER_STATE b;

  b = (YY_BUFFER_STATE) yy_flex_alloc (sizeof (struct yy_buffer_state));
  if (!b)
    YY_FATAL_ERROR ("out of dynamic memory in yy_create_buffer()");

  b->yy_buf_size = size;

  b->yy_ch_buf = (char *) yy_flex_alloc (b->yy_buf_size + 2);
  if (!b->yy_ch_buf)
    YY_FATAL_ERROR ("out of dynamic memory in yy_create_buffer()");

  b->yy_is_our_buffer = 1;

  yy_init_buffer (b, file);

  return b;
}

#ifdef YY_USE_PROTOS
void
yy_delete_buffer (YY_BUFFER_STATE b)
#else
void
yy_delete_buffer (b)
     YY_BUFFER_STATE b;
#endif
{
  if (!b)
    return;

  if (b == yy_current_buffer)
    yy_current_buffer = (YY_BUFFER_STATE) 0;

  if (b->yy_is_our_buffer)
    yy_flex_free ((void *) b->yy_ch_buf);

  yy_flex_free ((void *) b);
}

#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO ((int));
#endif
#endif

#ifdef YY_USE_PROTOS
void
yy_init_buffer (YY_BUFFER_STATE b, FILE * file)
#else
void
yy_init_buffer (b, file)
     YY_BUFFER_STATE b;
     FILE *file;
#endif

{
  yy_flush_buffer (b);

  b->yy_input_file = file;
  b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
  b->yy_is_interactiv = 1;
#else
#if YY_NEVER_INTERACTIVE
  b->yy_is_interactiv = 0;
#else
  b->yy_is_interactiv = file ? (isatty (fileno (file)) > 0) : 0;
#endif
#endif
}

#ifdef YY_USE_PROTOS
void
yy_flush_buffer (YY_BUFFER_STATE b)
#else
void
yy_flush_buffer (b)
     YY_BUFFER_STATE b;
#endif

{
  if (!b)
    return;

  b->yy_n_chars = 0;

  b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
  b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

  b->yy_buf_pos = &b->yy_ch_buf[0];

  b->yy_at_bol = 1;
  b->yy_buffer_status = YY_BUFFER_NEW;

  if (b == yy_current_buffer)
    yy_load_buffer_state ();
}

#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_buffer (char *base, yy_size_t size)
#else
YY_BUFFER_STATE
yy_scan_buffer (base, size)
     char *base;
     yy_size_t size;
#endif
{
  YY_BUFFER_STATE b;

  if (size < 2 ||
      base[size - 2] != YY_END_OF_BUFFER_CHAR ||
      base[size - 1] != YY_END_OF_BUFFER_CHAR)

    return 0;

  b = (YY_BUFFER_STATE) yy_flex_alloc (sizeof (struct yy_buffer_state));
  if (!b)
    YY_FATAL_ERROR ("out of dynamic memory in yy_scan_buffer()");

  b->yy_buf_size = size - 2;
  b->yy_buf_pos = b->yy_ch_buf = base;
  b->yy_is_our_buffer = 0;
  b->yy_input_file = 0;
  b->yy_n_chars = b->yy_buf_size;
  b->yy_is_interactiv = 0;
  b->yy_at_bol = 1;
  b->yy_fill_buffer = 0;
  b->yy_buffer_status = YY_BUFFER_NEW;

  yy_switch_to_buffer (b);

  return b;
}
#endif

#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_string (yyconst char *yy_str)
#else
YY_BUFFER_STATE
yy_scan_string (yy_str)
     yyconst char *yy_str;
#endif
{
  int len;
  for (len = 0; yy_str[len]; ++len)
    ;

  return yy_scan_bytes (yy_str, len);
}
#endif

#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_bytes (yyconst char *bytes, int len)
#else
YY_BUFFER_STATE
yy_scan_bytes (bytes, len)
     yyconst char *bytes;
     int len;
#endif
{
  YY_BUFFER_STATE b;
  char *buf;
  yy_size_t n;
  int i;

  n = len + 2;
  buf = (char *) yy_flex_alloc (n);
  if (!buf)
    YY_FATAL_ERROR ("out of dynamic memory in yy_scan_bytes()");

  for (i = 0; i < len; ++i)
    buf[i] = bytes[i];

  buf[len] = buf[len + 1] = YY_END_OF_BUFFER_CHAR;

  b = yy_scan_buffer (buf, n);
  if (!b)
    YY_FATAL_ERROR ("bad buffer in yy_scan_bytes()");

  b->yy_is_our_buffer = 1;

  return b;
}
#endif

#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void
yy_push_state (int new_state)
#else
static void
yy_push_state (new_state)
     int new_state;
#endif
{
  if (yy_start_stack_ptr >= yy_start_stack_depth)
    {
      yy_size_t new_size;

      yy_start_stack_depth += YY_START_STACK_INCR;
      new_size = yy_start_stack_depth * sizeof (int);

      if (!yy_start_stack)
	yy_start_stack = (int *) yy_flex_alloc (new_size);

      else
	yy_start_stack = (int *) yy_flex_realloc (
					 (void *) yy_start_stack, new_size);

      if (!yy_start_stack)
	YY_FATAL_ERROR (
			 "out of memory expanding start-condition stack");
    }

  yy_start_stack[yy_start_stack_ptr++] = YY_START;

  BEGIN (new_state);
}
#endif

#ifndef YY_NO_POP_STATE
static void
yy_pop_state ()
{
  if (--yy_start_stack_ptr < 0)
    YY_FATAL_ERROR ("start-condition stack underflow");

  BEGIN (yy_start_stack[yy_start_stack_ptr]);
}
#endif

#ifndef YY_NO_TOP_STATE
static int
yy_top_state ()
{
  return yy_start_stack[yy_start_stack_ptr - 1];
}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void
yy_fatal_error (yyconst char msg[])
#else
static void
yy_fatal_error (msg)
     char msg[];
#endif
{
  (void) fprintf (stderr, "%s\n", msg);
  exit (YY_EXIT_FAILURE);
}

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void
yy_flex_strncpy (char *s1, yyconst char *s2, int n)
#else
static void
yy_flex_strncpy (s1, s2, n)
     char *s1;
     yyconst char *s2;
     int n;
#endif
{
  register int i;
  for (i = 0; i < n; ++i)
    s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int
yy_flex_strlen (yyconst char *s)
#else
static int
yy_flex_strlen (s)
     yyconst char *s;
#endif
{
  register int n;
  for (n = 0; s[n]; ++n)
    ;

  return n;
}
#endif

#ifdef YY_USE_PROTOS
static void *
yy_flex_alloc (yy_size_t size)
#else
static void *
yy_flex_alloc (size)
     yy_size_t size;
#endif
{
  return (void *) malloc (size);
}

#ifdef YY_USE_PROTOS
static void *
yy_flex_realloc (void *ptr, yy_size_t size)
#else
static void *
yy_flex_realloc (ptr, size)
     void *ptr;
     yy_size_t size;
#endif
{

  return (void *) realloc ((char *) ptr, size);
}

#ifdef YY_USE_PROTOS
static void
yy_flex_free (void *ptr)
#else
static void
yy_flex_free (ptr)
     void *ptr;
#endif
{
  free (ptr);
}

#if YY_MAIN
int
main ()
{
  yylex ();
  return 0;
}
#endif
#line 183 "calcl.l"

#ifdef AIX
#undef input
#define input()  (((yytchar=yysptr>yysbuf?U(*--yysptr):StringInput())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
