/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include <stdio.h>
#include <sys/stat.h>
#include "param.h"

typedef struct
  {
    Widget back;
    Widget track;
    Widget up, down, left, right, thumb;
    int h, w;
    int vmin, vmax, val;
    int curx, cury, curh, curw;
    int thumbpx, thumbpy;

    int ssx, ssy;
    void (*cbfunction) ();
    Widget parent;
  }
Myscroll;

Myscroll *
  CreateMyscroll (Widget parent, int h, int w, int vmin, int vmax,
		  void (*func) ());

void
  setscrollval (Myscroll * ms, int val);
int
  setscrolllimit (Myscroll * ms, int vmin, int vmax);

void
  btncb (Widget widget, XtPointer pointer, XtPointer junk);

extern void
  shadow2 (Widget widget, XtPointer pointer, XEvent * event, Boolean * ctd);
