/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef PARAM_H
#define PARAM_H
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Core.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Shell.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Repeater.h>
#include <X11/RectObj.h>

Arg w_args[50];
int w_n;

struct menuEntry
  {
    char *name;
    void (*function) ();
  };

struct buttonEntry
  {
    char *name;
    char *pixmapname;
    void (*function) ();
  };

struct paneEntry
  {
    char *name;
  };
extern void
  shadow3 (Widget widget, XtPointer pointer, XEvent * event, Boolean * ctd);

extern void
  shadow2 (Widget widget, XtPointer pointer, XEvent * event, Boolean * ctd);
extern void
  shadow (Widget widget, XtPointer pointer, XEvent * event, Boolean * ctd);

extern int
  addshadow (Widget w, int type);

Widget CreateLabel ();
Widget CreateEntry ();
Widget CreateText ();
void TextPrintf (Widget w, char *str);
int SetEntryVal (Widget w, double val);
double GetEntryVal (Widget w);

#endif
