/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include "pldlg.h"
#include "chrt.h"

void
X11m_plottype ()
{
  selectedtype = -1;
  activpane (td2, 0);
  display_prompt (td2, gettop ());
}

void
X11m_plotdata ()
{
  selectedtype = -1;
  activpane (td2, 1);
  display_prompt (td2, gettop ());
}

void
X11m_plotoption ()
{
  char *buf;
  char name[32];
  char buf1[32];
  int serie;
  Arg arglist[1];
  selectedtype = -1;

  if (ActivChrt == NULL)
    return;

  buf = (char *) gettitre1 ();
  if (buf != NULL)
    {
      XtSetArg (arglist[0], XtNstring, buf);
      XtSetValues (titre1, arglist, 1);
    }
  else
    {
      XtSetArg (arglist[0], XtNstring, "");
      XtSetValues (titre1, arglist, 1);
    }

  buf = (char *) getXaxis ();
  if (buf != NULL)
    {
      XtSetArg (arglist[0], XtNstring, buf);
      XtSetValues (Xaxis, arglist, 1);
    }
  else
    {
      XtSetArg (arglist[0], XtNstring, "");
      XtSetValues (Xaxis, arglist, 1);
    }

  buf = (char *) getYaxis ();
  if (buf != NULL)
    {
      XtSetArg (arglist[0], XtNstring, buf);
      XtSetValues (Yaxis, arglist, 1);
    }
  else
    {
      XtSetArg (arglist[0], XtNstring, "");
      XtSetValues (Yaxis, arglist, 1);
    }

  serie = 1;
  XawListHighlight (ranges, serie - 1);
  getrange (serie, buf1, name);
  if (buf1 != NULL)
    {
      XtSetArg (arglist[0], XtNstring, &buf1);
      XtSetValues (range, arglist, 1);
    }

  if (name != NULL)
    {
      XtSetArg (arglist[0], XtNstring, &name);
      XtSetValues (seriename, arglist, 1);
    }

  if (ActivChrt != NULL)
    {
      setcheck (vgrid, ActivChrt->Axes[xlCategory].HasMajorGridLines);
      setcheck (hgrid, ActivChrt->Axes[xlValue].HasMajorGridLines);

      setcheck (xmin, ActivChrt->Axes[xlCategory].MinimumScaleIsAuto);
      SetEntryVal (xminv, ActivChrt->Axes[xlCategory].MinimumScale);

      setcheck (xmax, ActivChrt->Axes[xlCategory].MaximumScaleIsAuto);
      SetEntryVal (xmaxv, ActivChrt->Axes[xlCategory].MaximumScale);

      setcheck (xunit, ActivChrt->Axes[xlCategory].MajorUnitIsAuto);
      SetEntryVal (xunitv, ActivChrt->Axes[xlCategory].MajorUnit);

      setcheck (ymin, ActivChrt->Axes[xlValue].MinimumScaleIsAuto);
      SetEntryVal (yminv, ActivChrt->Axes[xlValue].MinimumScale);

      setcheck (ymax, ActivChrt->Axes[xlValue].MaximumScaleIsAuto);
      SetEntryVal (ymaxv, ActivChrt->Axes[xlValue].MaximumScale);

      setcheck (yunit, ActivChrt->Axes[xlValue].MajorUnitIsAuto);
      SetEntryVal (yunitv, ActivChrt->Axes[xlValue].MajorUnit);

    }

  previousrange = 1;

  display_prompt (td2, gettop ());
}

void
initplotdial ()
{
  int type = 0;

  if (ActivChrt != NULL)
    {
      type = ActivChrt->type;

      XawListHighlight (typelist, type);

    }

};

void
formatplot ()
{
  char *str, *str1, *str2;
  Arg arglist[1];
  char buf[256];
  Boolean on;
  int *touched_pane = (int *) get_touched_pane (td2);

  if (touched_pane[0])
    {
      if (selectedtype >= 0)
	settype (selectedtype);
    }
  if (touched_pane[1])
    {
      char *str1;
      char *str2;
      XtSetArg (arglist[0], XtNstring, &str1);
      XtGetValues (range, arglist, 1);
      XtSetArg (arglist[0], XtNstring, &str2);
      XtGetValues (seriename, arglist, 1);
      setrange (previousrange, str1, str2);
    }
  if (touched_pane[2])
    {
      XtSetArg (arglist[0], XtNstring, &str);
      XtGetValues (titre1, arglist, 1);
      settitre1 (str);
      XtSetArg (arglist[0], XtNstring, &str);
      XtGetValues (Xaxis, arglist, 1);
      setXaxis (str);
      XtGetValues (Yaxis, arglist, 1);
      setYaxis (str);
    }
  if (touched_pane[3])
    {
      XtSetArg (arglist[0], XtNstate, &on);
      XtGetValues (vgrid, arglist, 1);
      setgridv (on);
      XtSetArg (arglist[0], XtNstate, &on);
      XtGetValues (hgrid, arglist, 1);
      setgridh (on);
    }

  if (touched_pane[4])
    if (ActivChrt != NULL)
      {
	ActivChrt->Axes[xlCategory].MinimumScaleIsAuto = getcheck (xmin);
	ActivChrt->Axes[xlCategory].MinimumScale = GetEntryVal (xminv);

	ActivChrt->Axes[xlCategory].MaximumScaleIsAuto = getcheck (xmax);
	ActivChrt->Axes[xlCategory].MaximumScale = GetEntryVal (xmaxv);

	ActivChrt->Axes[xlCategory].MajorUnitIsAuto = getcheck (xunit);
	ActivChrt->Axes[xlCategory].MajorUnit = GetEntryVal (xunitv);

	ActivChrt->Axes[xlValue].MinimumScaleIsAuto = getcheck (ymin);
	ActivChrt->Axes[xlValue].MinimumScale = GetEntryVal (yminv);

	ActivChrt->Axes[xlValue].MaximumScaleIsAuto = getcheck (ymax);
	ActivChrt->Axes[xlValue].MaximumScale = GetEntryVal (ymaxv);

	ActivChrt->Axes[xlValue].MajorUnitIsAuto = getcheck (yunit);
	ActivChrt->Axes[xlValue].MajorUnit = GetEntryVal (yunitv);

      }

  plot ();

}

void
graprange (w, pointer, call_data)
     Widget w;
     XtPointer pointer;
     XtPointer call_data;
{
  ThumbDialog *td = (ThumbDialog *) pointer;
  XtUnmanageChild (td->promptShell);

  cb_grap (range, td->promptShell);
}

void
grapseriename (w, pointer, call_data)
     Widget w;
     XtPointer pointer;
     XtPointer call_data;
{
  ThumbDialog *td = (ThumbDialog *) pointer;
  XtUnmanageChild (td->promptShell);

  cb_grap (seriename, td->promptShell);

}
void
graptitre1 (w, pointer, call_data)
     Widget w;
     XtPointer pointer;
     XtPointer call_data;
{
  ThumbDialog *td = (ThumbDialog *) pointer;
  XtUnmanageChild (td->promptShell);

  cb_grap (titre1, td->promptShell);

}
void
grapXaxis (w, pointer, call_data)
     Widget w;
     XtPointer pointer;
     XtPointer call_data;
{
  ThumbDialog *td = (ThumbDialog *) pointer;
  XtUnmanageChild (td->promptShell);

  cb_grap (Xaxis, td->promptShell);
}

void
grapYaxis (w, pointer, call_data)
     Widget w;
     XtPointer pointer;
     XtPointer call_data;
{
  ThumbDialog *td = (ThumbDialog *) pointer;
  XtUnmanageChild (td->promptShell);

  cb_grap (Yaxis, td->promptShell);
}

void
updaterange (w, closure, call_data)
     Widget w;
     XtPointer closure, call_data;
{
  Arg arglist[1];
  int serie;
  char buf[32];
  char name[32];

  char *str1;
  char *str2;
  XawListReturnStruct *item;

  XtSetArg (arglist[0], XtNstring, &str1);
  XtGetValues (range, arglist, 1);
  XtSetArg (arglist[0], XtNstring, &str2);
  XtGetValues (seriename, arglist, 1);
  setrange (previousrange, str1, str2);

  item = (XawListReturnStruct *) call_data;
  serie = item->list_index + 1;
  previousrange = serie;
  getrange (serie, buf, name);
  XtSetArg (arglist[0], XtNstring, &buf);
  XtSetValues (range, arglist, 1);
  XtSetArg (arglist[0], XtNstring, &name);
  XtSetValues (seriename, arglist, 1);

}

void
set_plottype (w, closure, call_data)
     Widget w;
     XtPointer closure, call_data;
{
  Arg arglist[1];
  XawListReturnStruct *item = (XawListReturnStruct *) call_data;
  selectedtype = item->list_index;
}

make_plot_dial ()
{
  Widget viewport, label1, label4, viewport2, label2, label3;
  Widget base;

  td2 = CreateThumbDialog (gettop (), XtNumber (plotpane), plotpane, formatplot, initplotdial);

  base = (Widget) get_base (td2);

  w_n = 0;
  w_bord (0);
  w_dim (100, 120);
  w_rel (NULL, 20, 55);
  XtSetArg (w_args[w_n], XtNuseRight, True);
  w_n++;
  XtSetArg (w_args[w_n], XtNallowVert, True);
  w_n++;
  XtSetArg (w_args[w_n], XtNforceBars, True);
  w_n++;
  viewport = XtCreateManagedWidget ("viewport",
				    viewportWidgetClass, base, w_args, w_n);

  addshadow (viewport, 6);
  addpanechild (td2, 0, viewport);

  w_n = 0;
  w_bord (0);
  XtSetArg (w_args[w_n], XtNdefaultColumns, 1);
  w_n++;
  XtSetArg (w_args[w_n], XtNforceColumns, True);
  w_n++;
  typelist = XtCreateManagedWidget ("typelist", listWidgetClass,
				    viewport, w_args, w_n);
  XtAddCallback (typelist, XtNcallback, set_plottype, NULL);
  XawListChange (typelist, plot_type, 5, 0, True);

  w_n = 0;
  w_bord (0);
  w_dim (100, 120);
  w_rel (NULL, 20, 55);
  XtSetArg (w_args[w_n], XtNuseRight, True);
  w_n++;
  XtSetArg (w_args[w_n], XtNallowVert, True);
  w_n++;
  XtSetArg (w_args[w_n], XtNforceBars, True);
  w_n++;
  viewport2 = XtCreateManagedWidget ("viewport",
				     viewportWidgetClass, base, w_args, w_n);
  addshadow (viewport2, 6);

  addpanechild (td2, 1, viewport2);

  w_n = 0;
  w_bord (0);
  XtSetArg (w_args[w_n], XtNdefaultColumns, 1);
  w_n++;
  XtSetArg (w_args[w_n], XtNforceColumns, True);
  w_n++;

  ranges = XtCreateManagedWidget ("list", listWidgetClass,
				  viewport2, w_args, w_n);
  XtAddCallback (ranges, XtNcallback, updaterange, NULL);
  XawListChange (ranges, serie, 5, 0, True);

  addpanechild (td2, 1, CreateLabel (base, "Range", 160, 35, 80, 20));
  range = CreateEntry (base, "test", 160, 60, 100, 20, "");
  XtAddEventHandler (range,
		     ExposureMask,
		     FALSE,
		     shadow3,
		     (caddr_t) range);

  addpanechild (td2, 1, range);

  w_n = 0;
  w_rel (NULL, 270, 60);
  btn = (Widget) make_button_pixmap (base, "grap", grap_xpm, graprange, (caddr_t) td2);
  XtSetValues (btn, w_args, w_n);
  addpanechild (td2, 1, btn);

  addpanechild (td2, 1, CreateLabel (base, "Name", 160, 90, 80, 20));
  seriename = CreateEntry (base, "text", 160, 115, 100, 20, "");
  XtAddEventHandler (seriename,
		     ExposureMask,
		     FALSE,
		     shadow3,
		     (caddr_t) seriename);

  addpanechild (td2, 1, seriename);

  w_n = 0;
  w_rel (NULL, 270, 115);
  btn2 = (Widget) make_button_pixmap (base, "grap", grap_xpm, grapseriename, (caddr_t) td2);
  XtSetValues (btn2, w_args, w_n);
  addpanechild (td2, 1, btn2);

  addpanechild (td2, 2, CreateLabel (base, "Title", 20, 35, 80, 20));
  titre1 = CreateEntry (base, "text", 110, 35, 180, 20, "");
  XtAddEventHandler (titre1,
		     ExposureMask,
		     FALSE,
		     shadow3,
		     (caddr_t) titre1);

  addpanechild (td2, 2, titre1);
  w_n = 0;
  w_rel (NULL, 300, 35);
  btn3 = (Widget) make_button_pixmap (base, "grap", grap_xpm, graptitre1, (caddr_t) td2);
  XtSetValues (btn3, w_args, w_n);
  addpanechild (td2, 2, btn3);

  addpanechild (td2, 2, CreateLabel (base, "X Axis", 20, 65, 80, 20));
  Xaxis = CreateEntry (base, "text", 110, 65, 180, 20, "");
  XtAddEventHandler (Xaxis,
		     ExposureMask,
		     FALSE,
		     shadow3,
		     (caddr_t) Xaxis);
  addpanechild (td2, 2, Xaxis);

  w_n = 0;
  w_rel (NULL, 300, 65);
  btn4 = (Widget) make_button_pixmap (base, "grap", grap_xpm, grapXaxis, (caddr_t) td2);
  XtSetValues (btn4, w_args, w_n);
  addpanechild (td2, 2, btn4);

  addpanechild (td2, 2, CreateLabel (base, "Y Axis", 20, 95, 80, 20));
  Yaxis = CreateEntry (base, "text", 110, 95, 180, 20, "");
  XtAddEventHandler (Yaxis,
		     ExposureMask,
		     FALSE,
		     shadow3,
		     (caddr_t) Yaxis);
  addpanechild (td2, 2, Yaxis);

  w_n = 0;
  w_rel (NULL, 300, 95);
  btn5 = (Widget) make_button_pixmap (base, "grap", grap_xpm, grapYaxis, (caddr_t) td2);
  XtSetValues (btn5, w_args, w_n);
  addpanechild (td2, 2, btn5);

  addpanechild (td2, 3, CreateLabel (base, "Vertical   grid", 20, 35, 80, 20));

  w_n = 0;
  w_rel (NULL, 130, 35);
  vgrid = (Widget) make_check (base, "vgrid", NULL, (caddr_t) td2);
  XtSetValues (vgrid, w_args, w_n);
  addpanechild (td2, 3, vgrid);

  addpanechild (td2, 3, CreateLabel (base, "Horizontal grid", 20, 65, 80, 20));

  w_n = 0;
  w_rel (NULL, 130, 65);
  hgrid = (Widget) make_check (base, "hgrid", NULL, (caddr_t) td2);
  XtSetValues (hgrid, w_args, w_n);
  addpanechild (td2, 3, hgrid);

  activpane (td2, 0);

  addpanechild (td2, 4, CreateLabel (base, "Automatic", 10, 35, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "X Minimum", 30, 60, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "X Maximum", 30, 85, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "X Unit", 30, 110, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "Y Minimum", 30, 135, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "Y Maximum", 30, 160, 100, 22));
  addpanechild (td2, 4, CreateLabel (base, "Y Unit", 30, 185, 100, 22));

  w_n = 0;
  w_rel (NULL, 10, 60);
  xmin = (Widget) make_check (base, "xmin", NULL, (caddr_t) td2);
  XtSetValues (xmin, w_args, w_n);
  addpanechild (td2, 4, xmin);

  w_n = 0;
  w_rel (NULL, 10, 85);
  xmax = (Widget) make_check (base, "xmax", NULL, (caddr_t) td2);
  XtSetValues (xmax, w_args, w_n);
  addpanechild (td2, 4, xmax);

  w_n = 0;
  w_rel (NULL, 10, 110);
  xunit = (Widget) make_check (base, "xunit", NULL, (caddr_t) td2);
  XtSetValues (xunit, w_args, w_n);
  addpanechild (td2, 4, xunit);

  w_n = 0;
  w_rel (NULL, 10, 135);
  ymin = (Widget) make_check (base, "ymin", NULL, (caddr_t) td2);
  XtSetValues (ymin, w_args, w_n);
  addpanechild (td2, 4, ymin);

  w_n = 0;
  w_rel (NULL, 10, 160);
  ymax = (Widget) make_check (base, "ymax", NULL, (caddr_t) td2);
  XtSetValues (ymax, w_args, w_n);
  addpanechild (td2, 4, ymax);

  w_n = 0;
  w_rel (NULL, 10, 185);
  yunit = (Widget) make_check (base, "yunit", NULL, (caddr_t) td2);
  XtSetValues (yunit, w_args, w_n);
  addpanechild (td2, 4, yunit);

  xminv = CreateEntry (base, "xminv", 160, 60, 150, 22, "");
  XtAddEventHandler (xminv, ExposureMask, FALSE, shadow3, (caddr_t) xminv);
  addpanechild (td2, 4, xminv);

  xmaxv = CreateEntry (base, "xmaxv", 160, 85, 150, 22, "");
  XtAddEventHandler (xmaxv, ExposureMask, FALSE, shadow3, (caddr_t) xmaxv);
  addpanechild (td2, 4, xmaxv);

  xunitv = CreateEntry (base, "xunitv", 160, 110, 150, 22, "");
  XtAddEventHandler (xunitv, ExposureMask, FALSE, shadow3, (caddr_t) xunitv);
  addpanechild (td2, 4, xunitv);
  yminv = CreateEntry (base, "yminv", 160, 135, 150, 22, "");
  XtAddEventHandler (yminv, ExposureMask, FALSE, shadow3, (caddr_t) yminv);
  addpanechild (td2, 4, yminv);
  ymaxv = CreateEntry (base, "ymaxv", 160, 160, 150, 22, "");
  XtAddEventHandler (ymaxv, ExposureMask, FALSE, shadow3, (caddr_t) ymaxv);
  addpanechild (td2, 4, ymaxv);
  yunitv = CreateEntry (base, "yunitv", 160, 185, 150, 22, "");
  XtAddEventHandler (yunitv, ExposureMask, FALSE, shadow3, (caddr_t) yunitv);
  addpanechild (td2, 4, yunitv);

  activpane (td2, 0);

}
