/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef ROUTINE_H
#define ROUTINE_H

#include <stdlib.h>
#include <stdio.h>

struct _Loop
  {
    int loopid;
    int loopline;
    double loopend;
    double loopstep;
  };

typedef struct _Loop Loop;

struct _Ifblk
  {
    int ifline;
    int elseline;
    int endifline;
  };

typedef struct _Ifblk Ifblk;

typedef enum
  {
    Sub, Func
  }
routinetype;

struct _Routine
  {
    char **sourcecode;
    int dimsource;
    int nlc;
    int endl;

    Loop loops[30];
    int nl;
    int nloop;
    int acl;

    Ifblk ifblks[50];
    int nif;
    int ifdeep;
    int maxdeep;

    int subid;
    int subnparam;
    int subparamid[20];
    struct _Routine *calling;
    routinetype type;
  };

typedef struct _Routine Routine;

#endif
