/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include "title.h"
#include "stdlib.h"

title_settext (Title * t, char *buf)
{
  if (buf == NULL)
    return;
  if (strlen (buf) < 1)
    return;
  if (t == NULL)
    return;
  t->Text = (char *) absmalloc (strlen (buf) + 1, "title_settext:t->Text ");
  strcpy (t->Text, buf);
}

int
title_copy (t1, t2)
     Title *t1;
     Title *t2;
{
  if (t2 == NULL || t1 == NULL || (t1 == t2))
    return;

  if (t2->Text == NULL)
    {
      absfree (t1->Text);
      t1->Text = NULL;
      return;
    }
  if (strlen (t2->Text) < 1)
    {
      sprintf (t1->Text, "");
      return;
    };

  t1->Text = (char *) absrealloc (t1, strlen (t2->Text) + 1, "title_copy:t1->Text");
  strcpy (t1->Text, t2->Text);

}

char *
title_gtext (Title t)
{
  return t.Text;
}

title_free (Title * t)
{
  absfree (t->Text, "title_free:t->Text ");
  t->Text = NULL;
};
