/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef WORKBOOK_H
#define WORKBOOK_H
#include "wks.h"
#include "macro.h"

typedef struct
  {
    Wks **Wkss;
    int nbwks;
    Wks *activwks;
    Style *style;
    int objn;
    Macrofile *macrofile;
    char *name;
  }
Wkb;

extern Wkb *ActivWkb;

extern Wkb *newwkb ();
extern Wkb *
  newwkb1 (int nbwks);
extern int freewkb ();

extern Wkb *
  wkb_o (char *filename);
extern int
  wkb_s (Wkb * doc, char *filename);

extern int
  ActivateWkb (Wkb * wb);
extern Wks *
  wkb_gsht (Wkb * wb, char *name);
extern Wks *
  wkb_gsht2 (Wkb * wb, int num);

extern Wks *
  wkb_as (Wkb * wb, char *name);
extern Wks *
  wkb_ds (Wkb * wb, int num);

#endif
