/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef WORKSHEET_H
#define WORKSHEET_H
#include "cl.h"
#include "chrt.h"
#include "drw.h"
#include "selection.h"

#include "stdio.h"

#define NBCOL  256
#define NBLIN  1000
#define WCOL     84
#define HLIN     20

struct _Wks
  {
    Cl *defcl;
    Chrt **Chrts;
    Drwing **Drwings;
    char Name[32];

    Cl *activcl;
    Chrt *activchrt;
    Drwing *activdrwing;

    int nbcl, nbchrt, nbdrwing;
    int zm;
    int objn;
    int nlin, ncol;
    int cw[NBCOL + 1];
    int lh[NBLIN + 1];
    int cc, ll;
    Selection *selection;
    Cl ***matrix;
    int mrow;
    int *mcol;
  };

typedef struct _Wks Wks;

extern Wks *ActivWks;

extern Wks *newwks ();
extern Wks *newwks1 (int nbcl, int nbchrt, int nbdrwing);
extern int freewks ();

extern int wks_w (Wks * w, FILE * fp);
extern int wks_update (Wks * wks);

extern int wks_f (Wks * wks, int x, int y);
extern Cl *wks_gcl (Wks * wks, int r, int c, int new);
extern int wks_delcl (Wks * wks, int r, int c);
extern Chrt *wks_nchrt (Wks * wks);
extern Drwing *wks_ndrwing (Wks * wks);

extern int ActivateWks (Wks * wks);

extern Cht *wks_gcht (Wks * wks, int n);
extern int wks_addcht (Wks * wks, int *args, int n);
extern int wks_addshape (Wks * wks, int *args, int n);
extern int wks_setcw (Wks * wks, int col, double w);
extern int wks_setrh (Wks * wks, int lin, double h);
extern int wks_setname (Wks * wks, char *name);

#endif
