/********************************************************************
This file is part of abs, a spreadsheet with graphical user interface

Copyright (C) 1998  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "calcy.y"
#include <stdio.h>
#include <math.h>

#include "absrec.h"
#include "stack.h"

extern int addroutine (int, int, int *);
extern int callroutine (int, obj *, int);
extern int callroutine2 (int, obj *, int);

extern double getdouble ();
extern double memberfct ();
extern double getobjectval ();
extern double getfloat ();
extern double getidval ();
extern double getidval2 ();
extern double obj2double (obj o);
extern obj getidval3 (int v);
extern obj userfct (int v, obj * o, int nobj);
extern int printobj (obj o);
extern double getclval ();
extern double wsgetclval ();
extern char *getstackstr (int v);
extern int settext (char *buf);

static stack *s = NULL;

obj arglist[20];
int narg;
int idnum;
int listid[20];
double tmp;
int i;

#line 49 "y.tab.c"
#define DIGIT 257
#define LETTER 258
#define QUIT 259
#define DEBUG 260
#define INTEGER_CONSTANT 261
#define CHARACTER_CONSTANT 262
#define FLOATING_CONSTANT 263
#define STRING_CONSTANT 264
#define STRING_IDENTIFIER 265
#define IDENTIFIER 266
#define YY_CELL 267
#define IF 268
#define THEN 269
#define ELSE 270
#define FOR 271
#define DO 272
#define WHILE 273
#define TO 274
#define STEP 275
#define CONTINUE 276
#define BREAK 277
#define RETURN 278
#define GOTO 279
#define SUB 280
#define END 281
#define CALL 282
#define FUNCTION 283
#define SWITCH 284
#define PRINT 285
#define NEXT 286
#define SYSTEM 287
#define PRINTOUT 288
#define WORKBOOKS 289
#define WORKBOOK_OBJ 290
#define WORKSHEETS 291
#define WORKSHEET_OBJ 292
#define CELLS 293
#define CELL_OBJ 294
#define FORMULA 295
#define LINESTYLE 296
#define BORDERS 297
#define RANGE 298
#define NUMBERFORMAT 299
#define SELECT 300
#define SELECTION 301
#define CHARTOBJECTS 302
#define ADD 303
#define CHART 304
#define AXES 305
#define HASMAJORGRIDLINES 306
#define HASTITLE 307
#define TEXT 308
#define CHARTTITLE 309
#define AXISTITLE 310
#define SHAPES 311
#define ADDLINE 312
#define ADDSHAPE 313
#define ACTIVECHART 314
#define ACTIVECELL 315
#define ACTIVESHEET 316
#define SETSOURCEDATA 317
#define SOURCE 318
#define SERIESCOLLECTION 319
#define VALUES 320
#define NAME 321
#define SERIE 322
#define CHARTTYPE 323
#define FONT 324
#define SIZE 325
#define ITALIC 326
#define BOLD 327
#define INTERIOR 328
#define COLORINDEX 329
#define HORIZONTALALIGNMENT 330
#define COLUMNS 331
#define COLUMNWIDTH 332
#define ROWS 333
#define ROWHEIGHT 334
#define ACOS 335
#define ASIN 336
#define ATAN 337
#define ATAN2 338
#define CEIL 339
#define CONCATENATE 340
#define COS 341
#define COSH 342
#define EPT 343
#define EXP 344
#define FABS 345
#define FLOOR 346
#define FMOD 347
#define FREXP 348
#define GPD 349
#define GPF 350
#define LDEXP 351
#define LOG 352
#define LOG10 353
#define absMAX 354
#define absMIN 355
#define MODF 356
#define MAXMEAN 357
#define ORDER 358
#define POW 359
#define SEND 360
#define SIN 361
#define SINH 362
#define SPAWN 363
#define SQRT 364
#define SUM 365
#define RECEIVE 366
#define TAN 367
#define TANH 368
#define ACTIVATE 369
#define CREATE 370
#define EQ 371
#define NE 372
#define LE 373
#define LT 374
#define GT 375
#define GE 376
#define OR 377
#define AND 378
#define NEWLINE 379
#define UMINUS 380
#define YYERRCODE 256
short yylhs[] =
{-1,
 0, 0, 0, 0, 0, 1, 1, 1, 1, 3,
 3, 3, 4, 4, 4, 4, 4, 4, 5, 5,
 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
 5, 5, 5, 5, 5, 5, 2, 2, 2, 2,
 2, 2, 15, 2, 9, 9, 9, 9, 9, 9,
 9, 9, 9, 6, 6, 6, 6, 6, 6, 6,
 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
 19, 19, 19, 16, 10, 10, 13, 13, 8, 8,
 7, 14, 14, 12, 11, 11, 20, 20, 20, 20,
 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
 20, 20, 20, 20, 17, 17, 17, 17, 17, 17,
 17, 17, 18, 18, 18, 18, 18, 18, 18, 18,
 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,
 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,
 18, 18, 18, 18, 18, 18,
};
short yylen[] =
{2,
 1, 2, 1, 2, 1, 1, 1, 1, 1, 3,
 1, 5, 5, 7, 6, 8, 1, 2, 2, 4,
 5, 5, 4, 5, 5, 2, 2, 5, 5, 4,
 2, 2, 1, 1, 1, 3, 2, 4, 4, 4,
 3, 3, 0, 7, 3, 3, 3, 3, 3, 3,
 3, 3, 1, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 2, 3, 2, 3, 6, 6,
 5, 3, 3, 0, 4, 4, 1, 1, 1, 1,
 1, 1, 1, 3, 1, 3, 1, 1, 3, 3,
 1, 1, 1, 4, 1, 3, 4, 4, 1, 1,
 4, 4, 4, 1, 1, 1, 1, 1, 1, 1,
 4, 1, 1, 1, 4, 1, 4, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 4,
 1, 4, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1,
};
short yydefred[] =
{0,
 0, 81, 82, 87, 88, 91, 85, 0, 11, 0,
 0, 0, 33, 34, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 112, 114, 0,
 0, 113, 118, 0, 0, 104, 105, 108, 106, 107,
 134, 109, 110, 119, 0, 121, 120, 122, 123, 125,
 126, 124, 127, 128, 129, 0, 131, 0, 133, 150,
 151, 153, 152, 154, 176, 155, 156, 149, 157, 158,
 159, 160, 161, 148, 147, 162, 163, 164, 144, 143,
 165, 145, 166, 167, 168, 169, 170, 171, 172, 146,
 173, 174, 175, 5, 0, 0, 0, 0, 0, 6,
 7, 8, 9, 0, 0, 0, 0, 79, 0, 78,
 95, 4, 0, 0, 80, 0, 0, 0, 0, 0,
 32, 0, 26, 27, 0, 0, 0, 0, 18, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,
 0, 0, 37, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 10, 0, 0, 0, 36,
 0, 0, 0, 0, 42, 0, 0, 0, 0, 0,
 0, 53, 0, 0, 0, 0, 0, 0, 0, 68,
 58, 59, 55, 54, 56, 57, 0, 0, 0, 0,
 0, 0, 0, 0, 41, 0, 86, 0, 0, 140,
 141, 136, 137, 138, 142, 135, 139, 0, 96, 73,
 0, 0, 0, 0, 0, 20, 0, 0, 30, 0,
 0, 23, 0, 0, 0, 0, 97, 98, 0, 0,
 111, 0, 0, 0, 115, 117, 101, 103, 102, 130,
 132, 0, 38, 39, 40, 0, 75, 76, 0, 0,
 13, 21, 0, 22, 0, 29, 28, 24, 25, 12,
 43, 0, 50, 0, 49, 0, 52, 0, 51, 0,
 84, 0, 71, 0, 0, 0, 0, 89, 90, 0,
 70, 69, 0, 14, 92, 93, 44, 0,
};
short yydgoto[] =
{98,
 99, 100, 101, 102, 103, 104, 114, 228, 180, 115,
 116, 159, 108, 297, 290, 182, 218, 109, 110, 111,
};
short yysindex[] =
{1385,
 -375, 0, 0, 0, 0, 0, 0, 2754, 0, -237,
 2265, -1, 0, 0, 2754, -237, -237, -250, -237, -237,
 17, 2754, -237, 32, 34, 36, 38, 0, 0, 42,
 43, 0, 0, 48, 61, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 62, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 69, 0, 71, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 2754, 2754, 2754, 0, -323, 0,
 0, 0, 0, 1470, -30, 6, -34, 0, 86, 0,
 0, 0, 1925, 94, 0, 57, 58, -144, 2754, 1994,
 0, 90, 0, 0, 91, 100, 2754, 789, 0, -254,
 2754, 2754, 2754, -237, -254, 2754, 2754, 2754, -254, -254,
 2078, 2078, 1780, 0, 2754, 2754, 2754, 2754, 2754, 2754,
 2754, 2754, 0, 2754, 2754, 2754, 2754, 19, -247, 2754,
 -126, 2754, 2754, 2454, 2373, 0, 2754, 102, 1791, 0,
 -35, 2537, -32, 1855, 0, 103, 1863, 1871, 1976, -23,
 85, 0, 104, 105, 1879, 1900, 1949, 106, 107, 0,
 0, 0, 0, 0, 0, 0, -258, -258, 2078, 2078,
 -278, -278, 2859, 88, 0, 1153, 0, 1244, 1740, 0,
 0, 0, 0, 0, 0, 0, 0, 112, 0, 0,
 63, -19, 2033, 2754, 2265, 0, 27, 79, 0, 154,
 -7, 0, 80, 84, 2265, -225, 0, 0, 2754, 2754,
 0, 2754, 2754, -243, 0, 0, 0, 0, 0, 0,
 0, 2859, 0, 0, 0, 2645, 0, 0, 2754, 1957,
 0, 0, -237, 0, -237, 0, 0, 0, 0, 0,
 0, 2056, 0, 2056, 0, 2056, 0, 2056, 0, 94,
 0, 109, 0, 204, -6, 2004, 97, 0, 0, -210,
 0, 0, 2754, 0, 0, 0, 0, 2056,
};
short yyrindex[] =
{2146,
 157, 0, 0, 0, 0, 0, 0, 2086, 0, 0,
 1831, 0, 0, 0, 1084, 0, 0, 0, 0, 0,
 0, 1831, 5, 0, 0, 1, 0, 0, 0, 92,
 0, 0, 0, 183, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 173, 173, 1965, 0, 158, 0,
 0, 0, 0, 0, 1561, 1655, 1763, 0, 0, 0,
 0, 0, 0, 295, 0, 386, 0, 0, 1965, 0,
 0, 13, 0, 0, 16, 0, 1965, 0, 0, 0,
 1965, 1965, 2128, 0, 0, 1965, 1965, 1965, 0, 0,
 974, 1065, 0, 0, 173, 173, 173, 173, 173, 173,
 173, 173, 0, 173, 173, 173, 173, 0, 0, 1831,
 0, 1831, 1831, 0, 2128, 0, 2138, 0, 0, 0,
 0, 2128, 0, 0, 0, 0, 0, 0, 0, 0,
 1772, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 589, 680, 1177, 1268,
 771, 883, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 477, 0, 0,
 0, 0, 0, 1965, 1831, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1831, 0, 0, 0, -27, -27,
 0, -27, -27, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 2128, 0, 0, 1041, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 10, 0, 14, 0, 20, 0, 22, 0, 0,
 0, -220, 0, 0, 0, 28, 0, 0, 0, 0,
 0, 0, 496, 0, 0, 0, 0, 70,
};
short yygindex[] =
{0,
 15, 0, 0, 0, 0, 3115, 3124, -13, -165, 3151,
 8, 0, -55, 0, 0, -153, 0, 0, 0, -162,
};
#define YYTABLESIZE 3408
short yytable[] =
{222,
 99, 219, 161, 112, 17, 226, 231, 107, 232, 4,
 5, 164, 19, 74, 74, 31, 74, 241, 107, 74,
 243, 258, 6, 7, 243, 118, 163, 15, 6, 123,
 160, 74, 124, 267, 292, 242, 243, 243, 119, 242,
 219, 99, 99, 99, 99, 99, 99, 99, 295, 296,
 46, 242, 242, 46, 45, 144, 127, 45, 99, 99,
 48, 99, 47, 48, 203, 47, 162, 262, 46, 16,
 263, 130, 45, 131, 176, 132, 204, 133, 48, 184,
 47, 134, 135, 188, 189, 273, 275, 136, 277, 279,
 285, 116, 145, 146, 147, 148, 149, 150, 151, 152,
 137, 138, 164, 257, 156, 154, 240, 155, 139, 157,
 140, 158, 145, 146, 147, 148, 149, 150, 167, 264,
 268, 239, 265, 263, 269, 165, 161, 265, 168, 171,
 172, 205, 116, 116, 116, 116, 116, 116, 116, 173,
 207, 224, 244, 236, 245, 246, 250, 251, 252, 116,
 116, 256, 116, 271, 203, 294, 3, 1, 94, 234,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 74, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 100, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 266, 156, 154, 240, 155, 0,
 157, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 239, 74, 74, 0, 74, 0, 0, 74,
 0, 0, 0, 100, 100, 100, 100, 100, 100, 100,
 6, 74, 107, 6, 0, 0, 0, 0, 0, 261,
 100, 100, 107, 100, 291, 156, 154, 240, 155, 270,
 157, 0, 0, 0, 0, 0, 0, 0, 0, 282,
 0, 0, 239, 0, 0, 0, 0, 0, 0, 99,
 0, 0, 0, 99, 99, 99, 0, 17, 0, 0,
 0, 0, 0, 0, 0, 19, 0, 0, 31, 99,
 0, 99, 0, 99, 77, 99, 99, 99, 99, 99,
 15, 99, 99, 0, 0, 99, 99, 99, 99, 99,
 99, 99, 0, 0, 99, 0, 99, 0, 99, 99,
 99, 99, 0, 99, 99, 99, 99, 99, 99, 99,
 99, 99, 99, 99, 99, 77, 77, 77, 77, 77,
 0, 77, 16, 74, 74, 74, 74, 74, 74, 74,
 74, 0, 0, 77, 0, 0, 0, 0, 0, 0,
 116, 0, 0, 0, 116, 116, 116, 0, 0, 0,
 0, 99, 99, 99, 99, 99, 99, 99, 99, 99,
 116, 0, 116, 17, 116, 83, 116, 116, 116, 116,
 116, 19, 116, 116, 31, 0, 116, 116, 116, 116,
 116, 116, 116, 0, 0, 116, 15, 116, 0, 116,
 116, 116, 116, 0, 116, 116, 116, 116, 116, 116,
 116, 116, 116, 116, 116, 116, 83, 83, 83, 83,
 83, 0, 83, 145, 146, 147, 148, 149, 150, 151,
 152, 74, 0, 0, 83, 74, 74, 74, 16, 0,
 0, 100, 0, 0, 0, 100, 100, 100, 0, 0,
 0, 0, 116, 116, 116, 116, 116, 116, 116, 116,
 116, 100, 0, 100, 0, 100, 72, 100, 100, 100,
 100, 100, 0, 100, 100, 0, 0, 100, 100, 100,
 100, 100, 100, 100, 0, 74, 100, 0, 100, 0,
 100, 100, 100, 100, 0, 100, 100, 100, 100, 100,
 100, 100, 100, 100, 100, 100, 100, 72, 72, 72,
 72, 72, 0, 72, 145, 146, 147, 148, 149, 150,
 151, 152, 0, 0, 0, 72, 0, 74, 0, 0,
 0, 0, 74, 74, 74, 74, 74, 74, 74, 74,
 74, 74, 0, 100, 100, 100, 100, 100, 100, 100,
 100, 100, 0, 77, 0, 0, 0, 77, 77, 77,
 0, 0, 0, 0, 145, 146, 147, 148, 149, 150,
 151, 152, 0, 77, 0, 77, 0, 77, 61, 77,
 77, 77, 77, 77, 0, 77, 77, 0, 0, 77,
 77, 77, 77, 77, 77, 77, 0, 0, 77, 0,
 77, 0, 77, 77, 77, 77, 0, 77, 77, 77,
 77, 77, 77, 77, 77, 77, 77, 77, 77, 61,
 61, 61, 61, 61, 0, 61, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 61, 0, 0,
 0, 0, 0, 0, 83, 0, 0, 0, 83, 83,
 83, 0, 0, 0, 0, 77, 77, 77, 77, 77,
 77, 77, 77, 77, 83, 0, 83, 0, 83, 60,
 83, 83, 83, 83, 83, 0, 83, 83, 0, 0,
 83, 83, 83, 83, 83, 83, 83, 0, 0, 83,
 0, 83, 0, 83, 83, 83, 83, 0, 83, 83,
 83, 83, 83, 83, 83, 83, 83, 83, 83, 83,
 60, 60, 60, 60, 60, 0, 60, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 60, 0,
 0, 0, 0, 0, 0, 72, 0, 0, 0, 72,
 72, 72, 0, 0, 0, 0, 83, 83, 83, 83,
 83, 83, 83, 83, 83, 72, 0, 72, 74, 72,
 62, 72, 72, 72, 72, 72, 0, 72, 72, 0,
 0, 72, 72, 72, 72, 72, 72, 72, 0, 0,
 72, 0, 72, 0, 72, 72, 72, 72, 0, 72,
 72, 72, 72, 72, 72, 72, 72, 72, 72, 72,
 72, 62, 62, 62, 62, 62, 0, 62, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 62,
 156, 154, 0, 155, 0, 157, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 72, 72, 72,
 72, 72, 72, 72, 72, 72, 0, 61, 0, 0,
 0, 61, 61, 61, 0, 0, 74, 74, 74, 74,
 74, 74, 74, 74, 74, 0, 0, 61, 0, 61,
 0, 61, 63, 61, 61, 61, 61, 61, 0, 61,
 61, 0, 0, 61, 61, 61, 61, 61, 61, 61,
 0, 0, 61, 0, 61, 0, 61, 61, 61, 61,
 0, 61, 61, 61, 61, 61, 61, 61, 61, 61,
 61, 61, 61, 63, 63, 63, 63, 63, 0, 63,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 63, 0, 0, 0, 0, 0, 0, 60, 0,
 0, 0, 60, 60, 60, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 61, 61, 61, 60, 0,
 60, 0, 60, 65, 60, 60, 60, 60, 60, 0,
 60, 60, 0, 0, 60, 60, 60, 60, 60, 60,
 60, 0, 0, 60, 0, 60, 0, 60, 60, 60,
 60, 0, 60, 60, 60, 60, 60, 60, 60, 60,
 60, 60, 60, 60, 65, 0, 65, 65, 65, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 65, 0, 0, 0, 0, 0, 0, 62,
 74, 0, 0, 62, 62, 62, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 60, 60, 60, 62,
 0, 62, 0, 62, 67, 62, 62, 62, 62, 62,
 0, 62, 62, 0, 0, 62, 62, 62, 62, 62,
 62, 62, 74, 35, 62, 0, 62, 74, 62, 62,
 62, 62, 0, 62, 62, 62, 62, 62, 62, 62,
 62, 62, 62, 62, 62, 67, 0, 67, 67, 67,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 67, 0, 74, 0, 0, 0, 0,
 74, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 74, 0, 0, 0, 0, 0, 0, 62,
 0, 63, 0, 0, 0, 63, 63, 63, 0, 145,
 146, 147, 148, 149, 150, 151, 152, 175, 0, 0,
 0, 63, 0, 63, 0, 63, 64, 63, 63, 63,
 63, 63, 0, 63, 63, 0, 0, 63, 63, 63,
 63, 63, 63, 63, 156, 154, 63, 155, 63, 157,
 63, 63, 63, 63, 0, 63, 63, 63, 63, 63,
 63, 63, 63, 63, 63, 63, 63, 64, 0, 64,
 64, 64, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
 0, 0, 65, 0, 0, 0, 65, 65, 65, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 63, 65, 0, 65, 0, 65, 66, 65, 65,
 65, 65, 65, 0, 65, 65, 0, 0, 65, 65,
 65, 65, 65, 65, 65, 156, 154, 65, 155, 65,
 157, 65, 65, 65, 65, 0, 65, 65, 65, 65,
 65, 65, 65, 65, 65, 65, 65, 65, 66, 0,
 66, 66, 66, 74, 0, 74, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 66, 0, 0, 0,
 0, 0, 0, 67, 0, 0, 0, 67, 67, 67,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 65, 67, 0, 67, 35, 67, 0, 67,
 67, 67, 67, 67, 0, 67, 67, 0, 0, 67,
 67, 67, 67, 67, 67, 67, 0, 0, 67, 0,
 67, 0, 67, 67, 67, 67, 0, 67, 67, 67,
 67, 67, 67, 67, 67, 67, 67, 67, 67, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 74, 74, 74, 74, 74, 74, 74, 74, 74,
 0, 0, 0, 0, 97, 0, 0, 95, 0, 96,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 67, 0, 64, 0, 0, 0, 64,
 64, 64, 0, 0, 74, 74, 74, 74, 74, 74,
 74, 74, 35, 0, 0, 64, 0, 64, 0, 64,
 0, 64, 64, 64, 64, 64, 0, 64, 64, 0,
 0, 64, 64, 64, 64, 64, 64, 64, 0, 0,
 64, 0, 64, 0, 64, 64, 64, 64, 0, 64,
 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
 64, 156, 154, 0, 155, 0, 157, 0, 0, 0,
 0, 0, 0, 145, 146, 147, 148, 149, 150, 151,
 152, 253, 0, 0, 0, 0, 66, 0, 0, 0,
 66, 66, 66, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 64, 66, 0, 66, 0,
 66, 0, 66, 66, 66, 66, 66, 0, 66, 66,
 0, 0, 66, 66, 66, 66, 66, 66, 66, 0,
 0, 66, 0, 66, 0, 66, 66, 66, 66, 0,
 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
 66, 66, 77, 77, 0, 77, 0, 77, 0, 0,
 0, 0, 0, 0, 145, 146, 147, 148, 149, 150,
 151, 152, 254, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1, 0, 0, 0, 0, 2, 66, 3, 4, 5,
 6, 7, 8, 0, 9, 10, 11, 12, 0, 0,
 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,
 23, 24, 0, 25, 0, 26, 0, 27, 0, 28,
 29, 30, 31, 32, 0, 33, 34, 0, 0, 35,
 36, 37, 38, 39, 40, 41, 80, 80, 42, 80,
 43, 80, 44, 45, 46, 47, 0, 48, 49, 50,
 51, 52, 53, 54, 55, 56, 57, 58, 59, 60,
 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,
 91, 92, 93, 0, 0, 0, 0, 0, 25, 0,
 26, 0, 27, 94, 28, 29, 30, 31, 32, 0,
 33, 34, 0, 0, 35, 36, 37, 38, 39, 40,
 41, 156, 154, 42, 155, 43, 157, 44, 45, 46,
 47, 0, 48, 49, 50, 51, 52, 53, 54, 55,
 56, 57, 58, 59, 83, 83, 0, 83, 0, 83,
 0, 0, 80, 80, 80, 80, 80, 0, 80, 0,
 190, 156, 154, 0, 155, 0, 157, 0, 0, 0,
 80, 225, 156, 154, 0, 155, 0, 157, 0, 0,
 145, 146, 147, 148, 149, 150, 151, 152, 153, 77,
 0, 77, 0, 77, 0, 77, 77, 77, 77, 77,
 0, 77, 77, 0, 0, 77, 77, 77, 77, 77,
 77, 77, 74, 0, 77, 0, 77, 74, 77, 77,
 77, 77, 0, 77, 77, 77, 77, 77, 77, 77,
 77, 77, 77, 77, 77, 235, 156, 154, 0, 155,
 0, 157, 0, 237, 156, 154, 0, 155, 0, 157,
 0, 238, 156, 154, 0, 155, 0, 157, 0, 247,
 156, 154, 0, 155, 0, 157, 0, 0, 0, 0,
 0, 77, 77, 77, 77, 77, 77, 77, 77, 77,
 248, 156, 154, 80, 155, 80, 157, 80, 0, 80,
 80, 80, 80, 80, 0, 80, 80, 0, 0, 80,
 80, 80, 80, 80, 80, 80, 156, 154, 80, 155,
 80, 157, 80, 80, 80, 80, 0, 80, 80, 80,
 80, 80, 80, 80, 80, 80, 80, 80, 80, 249,
 156, 154, 0, 155, 0, 157, 0, 287, 156, 154,
 0, 155, 0, 157, 0, 74, 74, 0, 0, 0,
 0, 74, 0, 0, 0, 0, 0, 156, 154, 240,
 155, 0, 157, 0, 0, 80, 80, 80, 80, 80,
 80, 80, 80, 80, 239, 156, 154, 0, 155, 0,
 157, 0, 0, 0, 0, 156, 154, 0, 155, 0,
 157, 83, 170, 83, 0, 83, 0, 83, 83, 83,
 83, 83, 0, 83, 83, 0, 0, 83, 83, 83,
 83, 83, 83, 83, 156, 154, 83, 155, 83, 157,
 83, 83, 83, 83, 0, 83, 83, 83, 83, 83,
 83, 83, 83, 83, 83, 83, 83, 156, 154, 0,
 155, 0, 157, 0, 0, 0, 0, 0, 0, 0,
 145, 146, 147, 148, 149, 150, 151, 152, 255, 156,
 0, 0, 0, 0, 157, 0, 0, 74, 0, 0,
 0, 0, 74, 83, 83, 83, 83, 83, 83, 83,
 83, 83, 80, 80, 80, 80, 80, 80, 80, 80,
 145, 146, 147, 148, 149, 150, 151, 152, 0, 0,
 0, 145, 146, 147, 148, 149, 150, 151, 152, 74,
 0, 74, 0, 0, 74, 0, 0, 0, 0, 74,
 0, 0, 0, 0, 74, 0, 74, 74, 0, 0,
 0, 0, 74, 166, 0, 0, 0, 0, 0, 0,
 0, 74, 74, 74, 74, 74, 74, 74, 74, 74,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 145, 146, 147, 148, 149,
 150, 151, 152, 145, 146, 147, 148, 149, 150, 151,
 152, 145, 146, 147, 148, 149, 150, 151, 152, 145,
 146, 147, 148, 149, 150, 151, 152, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 145, 146, 147, 148, 149, 150, 151, 152, 293, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 145, 146, 147, 148, 149,
 150, 151, 152, 0, 97, 0, 259, 95, 0, 96,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 145,
 146, 147, 148, 149, 150, 151, 152, 145, 146, 147,
 148, 149, 150, 151, 152, 74, 74, 74, 74, 74,
 74, 74, 74, 0, 0, 0, 145, 146, 147, 148,
 149, 150, 151, 152, 74, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 145, 146, 147, 148, 149, 150,
 151, 152, 0, 0, 145, 146, 147, 148, 149, 150,
 151, 152, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 145, 146, 147, 148, 149, 150, 151,
 152, 74, 97, 220, 0, 95, 0, 96, 0, 0,
 0, 0, 0, 0, 0, 0, 145, 146, 147, 148,
 149, 150, 151, 152, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 145, 146,
 147, 148, 149, 150, 151, 152, 74, 74, 74, 74,
 74, 74, 74, 74, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 74, 74,
 74, 74, 74, 74, 74, 74, 0, 0, 74, 74,
 74, 74, 74, 74, 74, 74, 74, 74, 74, 74,
 74, 74, 74, 74, 0, 2, 0, 3, 4, 5,
 6, 7, 8, 0, 9, 10, 11, 12, 0, 0,
 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,
 23, 24, 0, 25, 0, 26, 0, 27, 0, 28,
 29, 30, 31, 32, 0, 33, 34, 0, 0, 35,
 36, 37, 38, 39, 40, 41, 97, 229, 42, 95,
 43, 96, 44, 45, 46, 47, 0, 48, 49, 50,
 51, 52, 53, 54, 55, 56, 57, 58, 59, 60,
 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,
 91, 92, 93, 2, 0, 3, 4, 5, 6, 7,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 25, 0, 26, 0, 27, 0, 28, 29, 30,
 31, 32, 0, 33, 34, 0, 0, 35, 36, 37,
 38, 39, 40, 41, 97, 283, 42, 95, 43, 96,
 44, 45, 46, 47, 0, 48, 49, 50, 51, 52,
 53, 54, 55, 56, 57, 58, 59, 60, 61, 62,
 63, 64, 65, 66, 67, 68, 69, 70, 71, 72,
 73, 74, 75, 76, 77, 78, 79, 80, 81, 82,
 83, 84, 85, 86, 87, 88, 89, 90, 91, 92,
 93, 210, 25, 0, 26, 0, 27, 0, 28, 29,
 30, 31, 32, 211, 33, 34, 212, 0, 35, 36,
 37, 38, 39, 40, 41, 213, 214, 42, 0, 43,
 215, 44, 45, 46, 47, 0, 48, 49, 50, 51,
 52, 53, 54, 55, 56, 57, 58, 59, 0, 0,
 0, 0, 0, 97, 0, 0, 95, 2, 96, 3,
 4, 5, 6, 7, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 216, 217, 0, 25, 0, 26, 0, 27,
 0, 28, 29, 30, 31, 32, 0, 33, 34, 0,
 0, 35, 36, 37, 38, 39, 40, 41, 0, 0,
 42, 0, 43, 0, 44, 45, 46, 47, 0, 48,
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58,
 59, 60, 61, 62, 63, 64, 65, 66, 67, 68,
 69, 70, 71, 72, 73, 74, 75, 76, 77, 78,
 79, 80, 81, 82, 83, 84, 85, 86, 87, 88,
 89, 90, 91, 92, 93, 2, 0, 3, 4, 5,
 6, 7, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 25, 0, 26, 0, 27, 0, 28,
 29, 30, 31, 32, 0, 33, 34, 0, 0, 35,
 36, 37, 38, 39, 40, 41, 0, 0, 42, 0,
 43, 0, 44, 45, 46, 47, 0, 48, 49, 50,
 51, 52, 53, 54, 55, 56, 57, 58, 59, 60,
 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,
 91, 92, 93, 0, 2, 0, 3, 4, 5, 6,
 7, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 25, 0, 26, 0, 27, 0, 28, 29,
 30, 31, 32, 0, 33, 34, 0, 0, 35, 36,
 37, 38, 39, 40, 41, 0, 0, 42, 0, 43,
 0, 44, 45, 46, 47, 0, 48, 49, 50, 51,
 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
 62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
 72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
 82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
 92, 93, 113, 105, 0, 0, 0, 0, 0, 120,
 0, 0, 0, 117, 105, 0, 128, 0, 0, 121,
 122, 0, 125, 126, 0, 0, 129, 25, 0, 26,
 106, 27, 0, 28, 29, 30, 31, 32, 0, 33,
 34, 106, 0, 35, 36, 37, 38, 39, 40, 41,
 0, 0, 42, 0, 43, 0, 44, 45, 46, 47,
 0, 48, 49, 50, 51, 52, 53, 54, 55, 56,
 57, 58, 59, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 141,
 142, 143, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 169, 0, 0, 0, 0, 0, 0,
 0, 174, 0, 0, 0, 177, 178, 179, 0, 0,
 185, 186, 187, 0, 0, 0, 0, 183, 0, 191,
 192, 193, 194, 195, 196, 197, 198, 0, 199, 200,
 201, 202, 0, 0, 206, 0, 208, 209, 0, 221,
 0, 223, 0, 181, 0, 0, 230, 0, 0, 0,
 0, 0, 0, 0, 227, 0, 233, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 181, 0, 0, 0, 0,
 0, 0, 181, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 260, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 105, 0,
 0, 0, 0, 272, 274, 0, 276, 278, 105, 0,
 0, 0, 0, 0, 0, 0, 0, 280, 0, 0,
 284, 0, 0, 286, 0, 106, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 106, 288, 0, 289, 181,
 181, 0, 181, 181, 281, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 181, 298,
};
short yycheck[] =
{165,
 0, 164, 33, 379, 0, 41, 172, 0, 41, 264,
 265, 46, 0, 41, 42, 0, 44, 41, 11, 47,
 44, 41, 266, 267, 44, 11, 61, 0, 266, 280,
 61, 59, 283, 41, 41, 59, 44, 44, 40, 59,
 203, 41, 42, 43, 44, 45, 46, 47, 259, 260,
 41, 59, 59, 44, 41, 379, 40, 44, 58, 59,
 41, 61, 41, 44, 46, 44, 61, 41, 59, 0,
 44, 40, 59, 40, 130, 40, 58, 40, 59, 135,
 59, 40, 40, 139, 140, 239, 240, 40, 242, 243,
 256, 0, 371, 372, 373, 374, 375, 376, 377, 378,
 40, 40, 46, 41, 42, 43, 44, 45, 40, 47,
 40, 104, 371, 372, 373, 374, 375, 376, 61, 41,
 41, 59, 44, 44, 41, 40, 33, 44, 273, 40,
 40, 379, 41, 42, 43, 44, 45, 46, 47, 40,
 267, 40, 58, 41, 41, 41, 41, 41, 61, 58,
 59, 40, 61, 379, 46, 59, 0, 0, 379, 173,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 0, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 0, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, 41, 42, 43, 44, 45, -1,
 47, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 59, 41, 42, -1, 44, -1, -1, 47,
 -1, -1, -1, 41, 42, 43, 44, 45, 46, 47,
 266, 59, 225, 266, -1, -1, -1, -1, -1, 225,
 58, 59, 235, 61, 41, 42, 43, 44, 45, 235,
 47, -1, -1, -1, -1, -1, -1, -1, -1, 252,
 -1, -1, 59, -1, -1, -1, -1, -1, -1, 269,
 -1, -1, -1, 273, 274, 275, -1, 273, -1, -1,
 -1, -1, -1, -1, -1, 273, -1, -1, 273, 289,
 -1, 291, -1, 293, 0, 295, 296, 297, 298, 299,
 273, 301, 302, -1, -1, 305, 306, 307, 308, 309,
 310, 311, -1, -1, 314, -1, 316, -1, 318, 319,
 320, 321, -1, 323, 324, 325, 326, 327, 328, 329,
 330, 331, 332, 333, 334, 41, 42, 43, 44, 45,
 -1, 47, 273, 371, 372, 373, 374, 375, 376, 377,
 378, -1, -1, 59, -1, -1, -1, -1, -1, -1,
 269, -1, -1, -1, 273, 274, 275, -1, -1, -1,
 -1, 371, 372, 373, 374, 375, 376, 377, 378, 379,
 289, -1, 291, 379, 293, 0, 295, 296, 297, 298,
 299, 379, 301, 302, 379, -1, 305, 306, 307, 308,
 309, 310, 311, -1, -1, 314, 379, 316, -1, 318,
 319, 320, 321, -1, 323, 324, 325, 326, 327, 328,
 329, 330, 331, 332, 333, 334, 41, 42, 43, 44,
 45, -1, 47, 371, 372, 373, 374, 375, 376, 377,
 378, 269, -1, -1, 59, 273, 274, 275, 379, -1,
 -1, 269, -1, -1, -1, 273, 274, 275, -1, -1,
 -1, -1, 371, 372, 373, 374, 375, 376, 377, 378,
 379, 289, -1, 291, -1, 293, 0, 295, 296, 297,
 298, 299, -1, 301, 302, -1, -1, 305, 306, 307,
 308, 309, 310, 311, -1, 0, 314, -1, 316, -1,
 318, 319, 320, 321, -1, 323, 324, 325, 326, 327,
 328, 329, 330, 331, 332, 333, 334, 41, 42, 43,
 44, 45, -1, 47, 371, 372, 373, 374, 375, 376,
 377, 378, -1, -1, -1, 59, -1, 42, -1, -1,
 -1, -1, 47, 371, 372, 373, 374, 375, 376, 377,
 378, 379, -1, 371, 372, 373, 374, 375, 376, 377,
 378, 379, -1, 269, -1, -1, -1, 273, 274, 275,
 -1, -1, -1, -1, 371, 372, 373, 374, 375, 376,
 377, 378, -1, 289, -1, 291, -1, 293, 0, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, -1, -1, 314, -1,
 316, -1, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, 41,
 42, 43, 44, 45, -1, 47, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, 59, -1, -1,
 -1, -1, -1, -1, 269, -1, -1, -1, 273, 274,
 275, -1, -1, -1, -1, 371, 372, 373, 374, 375,
 376, 377, 378, 379, 289, -1, 291, -1, 293, 0,
 295, 296, 297, 298, 299, -1, 301, 302, -1, -1,
 305, 306, 307, 308, 309, 310, 311, -1, -1, 314,
 -1, 316, -1, 318, 319, 320, 321, -1, 323, 324,
 325, 326, 327, 328, 329, 330, 331, 332, 333, 334,
 41, 42, 43, 44, 45, -1, 47, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, 59, -1,
 -1, -1, -1, -1, -1, 269, -1, -1, -1, 273,
 274, 275, -1, -1, -1, -1, 371, 372, 373, 374,
 375, 376, 377, 378, 379, 289, -1, 291, 273, 293,
 0, 295, 296, 297, 298, 299, -1, 301, 302, -1,
 -1, 305, 306, 307, 308, 309, 310, 311, -1, -1,
 314, -1, 316, -1, 318, 319, 320, 321, -1, 323,
 324, 325, 326, 327, 328, 329, 330, 331, 332, 333,
 334, 41, 42, 43, 44, 45, -1, 47, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, 59,
 42, 43, -1, 45, -1, 47, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, 371, 372, 373,
 374, 375, 376, 377, 378, 379, -1, 269, -1, -1,
 -1, 273, 274, 275, -1, -1, 371, 372, 373, 374,
 375, 376, 377, 378, 379, -1, -1, 289, -1, 291,
 -1, 293, 0, 295, 296, 297, 298, 299, -1, 301,
 302, -1, -1, 305, 306, 307, 308, 309, 310, 311,
 -1, -1, 314, -1, 316, -1, 318, 319, 320, 321,
 -1, 323, 324, 325, 326, 327, 328, 329, 330, 331,
 332, 333, 334, 41, 42, 43, 44, 45, -1, 47,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, 59, -1, -1, -1, -1, -1, -1, 269, -1,
 -1, -1, 273, 274, 275, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 377, 378, 379, 289, -1,
 291, -1, 293, 0, 295, 296, 297, 298, 299, -1,
 301, 302, -1, -1, 305, 306, 307, 308, 309, 310,
 311, -1, -1, 314, -1, 316, -1, 318, 319, 320,
 321, -1, 323, 324, 325, 326, 327, 328, 329, 330,
 331, 332, 333, 334, 41, -1, 43, 44, 45, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 59, -1, -1, -1, -1, -1, -1, 269,
 0, -1, -1, 273, 274, 275, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, 377, 378, 379, 289,
 -1, 291, -1, 293, 0, 295, 296, 297, 298, 299,
 -1, 301, 302, -1, -1, 305, 306, 307, 308, 309,
 310, 311, 42, 0, 314, -1, 316, 47, 318, 319,
 320, 321, -1, 323, 324, 325, 326, 327, 328, 329,
 330, 331, 332, 333, 334, 41, -1, 43, 44, 45,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, 59, -1, 42, -1, -1, -1, -1,
 47, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 59, -1, -1, -1, -1, -1, -1, 379,
 -1, 269, -1, -1, -1, 273, 274, 275, -1, 371,
 372, 373, 374, 375, 376, 377, 378, 379, -1, -1,
 -1, 289, -1, 291, -1, 293, 0, 295, 296, 297,
 298, 299, -1, 301, 302, -1, -1, 305, 306, 307,
 308, 309, 310, 311, 42, 43, 314, 45, 316, 47,
 318, 319, 320, 321, -1, 323, 324, 325, 326, 327,
 328, 329, 330, 331, 332, 333, 334, 41, -1, 43,
 44, 45, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 59, -1, -1, -1, -1,
 -1, -1, 269, -1, -1, -1, 273, 274, 275, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, 379, 289, -1, 291, -1, 293, 0, 295, 296,
 297, 298, 299, -1, 301, 302, -1, -1, 305, 306,
 307, 308, 309, 310, 311, 42, 43, 314, 45, 316,
 47, 318, 319, 320, 321, -1, 323, 324, 325, 326,
 327, 328, 329, 330, 331, 332, 333, 334, 41, -1,
 43, 44, 45, 273, -1, 275, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, 59, -1, -1, -1,
 -1, -1, -1, 269, -1, -1, -1, 273, 274, 275,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 379, 289, -1, 291, 273, 293, -1, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, -1, -1, 314, -1,
 316, -1, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, 371, 372, 373, 374, 375, 376, 377, 378, 379,
 -1, -1, -1, -1, 40, -1, -1, 43, -1, 45,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, 379, -1, 269, -1, -1, -1, 273,
 274, 275, -1, -1, 371, 372, 373, 374, 375, 376,
 377, 378, 379, -1, -1, 289, -1, 291, -1, 293,
 -1, 295, 296, 297, 298, 299, -1, 301, 302, -1,
 -1, 305, 306, 307, 308, 309, 310, 311, -1, -1,
 314, -1, 316, -1, 318, 319, 320, 321, -1, 323,
 324, 325, 326, 327, 328, 329, 330, 331, 332, 333,
 334, 42, 43, -1, 45, -1, 47, -1, -1, -1,
 -1, -1, -1, 371, 372, 373, 374, 375, 376, 377,
 378, 379, -1, -1, -1, -1, 269, -1, -1, -1,
 273, 274, 275, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 379, 289, -1, 291, -1,
 293, -1, 295, 296, 297, 298, 299, -1, 301, 302,
 -1, -1, 305, 306, 307, 308, 309, 310, 311, -1,
 -1, 314, -1, 316, -1, 318, 319, 320, 321, -1,
 323, 324, 325, 326, 327, 328, 329, 330, 331, 332,
 333, 334, 42, 43, -1, 45, -1, 47, -1, -1,
 -1, -1, -1, -1, 371, 372, 373, 374, 375, 376,
 377, 378, 379, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 256, -1, -1, -1, -1, 261, 379, 263, 264, 265,
 266, 267, 268, -1, 270, 271, 272, 273, -1, -1,
 276, 277, 278, 279, 280, 281, 282, 283, 284, 285,
 286, 287, -1, 289, -1, 291, -1, 293, -1, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, 42, 43, 314, 45,
 316, 47, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, 335,
 336, 337, 338, 339, 340, 341, 342, 343, 344, 345,
 346, 347, 348, 349, 350, 351, 352, 353, 354, 355,
 356, 357, 358, 359, 360, 361, 362, 363, 364, 365,
 366, 367, 368, -1, -1, -1, -1, -1, 289, -1,
 291, -1, 293, 379, 295, 296, 297, 298, 299, -1,
 301, 302, -1, -1, 305, 306, 307, 308, 309, 310,
 311, 42, 43, 314, 45, 316, 47, 318, 319, 320,
 321, -1, 323, 324, 325, 326, 327, 328, 329, 330,
 331, 332, 333, 334, 42, 43, -1, 45, -1, 47,
 -1, -1, 41, 42, 43, 44, 45, -1, 47, -1,
 41, 42, 43, -1, 45, -1, 47, -1, -1, -1,
 59, 41, 42, 43, -1, 45, -1, 47, -1, -1,
 371, 372, 373, 374, 375, 376, 377, 378, 379, 289,
 -1, 291, -1, 293, -1, 295, 296, 297, 298, 299,
 -1, 301, 302, -1, -1, 305, 306, 307, 308, 309,
 310, 311, 42, -1, 314, -1, 316, 47, 318, 319,
 320, 321, -1, 323, 324, 325, 326, 327, 328, 329,
 330, 331, 332, 333, 334, 41, 42, 43, -1, 45,
 -1, 47, -1, 41, 42, 43, -1, 45, -1, 47,
 -1, 41, 42, 43, -1, 45, -1, 47, -1, 41,
 42, 43, -1, 45, -1, 47, -1, -1, -1, -1,
 -1, 371, 372, 373, 374, 375, 376, 377, 378, 379,
 41, 42, 43, 289, 45, 291, 47, 293, -1, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, 42, 43, 314, 45,
 316, 47, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, 41,
 42, 43, -1, 45, -1, 47, -1, 41, 42, 43,
 -1, 45, -1, 47, -1, 41, 42, -1, -1, -1,
 -1, 47, -1, -1, -1, -1, -1, 42, 43, 44,
 45, -1, 47, -1, -1, 371, 372, 373, 374, 375,
 376, 377, 378, 379, 59, 42, 43, -1, 45, -1,
 47, -1, -1, -1, -1, 42, 43, -1, 45, -1,
 47, 289, 59, 291, -1, 293, -1, 295, 296, 297,
 298, 299, -1, 301, 302, -1, -1, 305, 306, 307,
 308, 309, 310, 311, 42, 43, 314, 45, 316, 47,
 318, 319, 320, 321, -1, 323, 324, 325, 326, 327,
 328, 329, 330, 331, 332, 333, 334, 42, 43, -1,
 45, -1, 47, -1, -1, -1, -1, -1, -1, -1,
 371, 372, 373, 374, 375, 376, 377, 378, 379, 42,
 -1, -1, -1, -1, 47, -1, -1, 42, -1, -1,
 -1, -1, 47, 371, 372, 373, 374, 375, 376, 377,
 378, 379, 371, 372, 373, 374, 375, 376, 377, 378,
 371, 372, 373, 374, 375, 376, 377, 378, -1, -1,
 -1, 371, 372, 373, 374, 375, 376, 377, 378, 42,
 -1, 44, -1, -1, 47, -1, -1, -1, -1, 42,
 -1, -1, -1, -1, 47, -1, 59, 42, -1, -1,
 -1, -1, 47, 269, -1, -1, -1, -1, -1, -1,
 -1, 371, 372, 373, 374, 375, 376, 377, 378, 379,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 371, 372, 373, 374, 375,
 376, 377, 378, 371, 372, 373, 374, 375, 376, 377,
 378, 371, 372, 373, 374, 375, 376, 377, 378, 371,
 372, 373, 374, 375, 376, 377, 378, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 371, 372, 373, 374, 375, 376, 377, 378, 275, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 371, 372, 373, 374, 375,
 376, 377, 378, -1, 40, -1, 274, 43, -1, 45,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, 371,
 372, 373, 374, 375, 376, 377, 378, 371, 372, 373,
 374, 375, 376, 377, 378, 371, 372, 373, 374, 375,
 376, 377, 378, -1, -1, -1, 371, 372, 373, 374,
 375, 376, 377, 378, 269, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, 371, 372, 373, 374, 375, 376,
 377, 378, -1, -1, 371, 372, 373, 374, 375, 376,
 377, 378, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, 371, 372, 373, 374, 375, 376, 377,
 378, 274, 40, 41, -1, 43, -1, 45, -1, -1,
 -1, -1, -1, -1, -1, -1, 371, 372, 373, 374,
 375, 376, 377, 378, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, 371, 372,
 373, 374, 375, 376, 377, 378, 371, 372, 373, 374,
 375, 376, 377, 378, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, 371, 372,
 373, 374, 375, 376, 377, 378, -1, -1, 371, 372,
 373, 374, 375, 376, 377, 378, 371, 372, 373, 374,
 375, 376, 377, 378, -1, 261, -1, 263, 264, 265,
 266, 267, 268, -1, 270, 271, 272, 273, -1, -1,
 276, 277, 278, 279, 280, 281, 282, 283, 284, 285,
 286, 287, -1, 289, -1, 291, -1, 293, -1, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, 40, 41, 314, 43,
 316, 45, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, 335,
 336, 337, 338, 339, 340, 341, 342, 343, 344, 345,
 346, 347, 348, 349, 350, 351, 352, 353, 354, 355,
 356, 357, 358, 359, 360, 361, 362, 363, 364, 365,
 366, 367, 368, 261, -1, 263, 264, 265, 266, 267,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, 289, -1, 291, -1, 293, -1, 295, 296, 297,
 298, 299, -1, 301, 302, -1, -1, 305, 306, 307,
 308, 309, 310, 311, 40, 41, 314, 43, 316, 45,
 318, 319, 320, 321, -1, 323, 324, 325, 326, 327,
 328, 329, 330, 331, 332, 333, 334, 335, 336, 337,
 338, 339, 340, 341, 342, 343, 344, 345, 346, 347,
 348, 349, 350, 351, 352, 353, 354, 355, 356, 357,
 358, 359, 360, 361, 362, 363, 364, 365, 366, 367,
 368, 288, 289, -1, 291, -1, 293, -1, 295, 296,
 297, 298, 299, 300, 301, 302, 303, -1, 305, 306,
 307, 308, 309, 310, 311, 312, 313, 314, -1, 316,
 317, 318, 319, 320, 321, -1, 323, 324, 325, 326,
 327, 328, 329, 330, 331, 332, 333, 334, -1, -1,
 -1, -1, -1, 40, -1, -1, 43, 261, 45, 263,
 264, 265, 266, 267, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 369, 370, -1, 289, -1, 291, -1, 293,
 -1, 295, 296, 297, 298, 299, -1, 301, 302, -1,
 -1, 305, 306, 307, 308, 309, 310, 311, -1, -1,
 314, -1, 316, -1, 318, 319, 320, 321, -1, 323,
 324, 325, 326, 327, 328, 329, 330, 331, 332, 333,
 334, 335, 336, 337, 338, 339, 340, 341, 342, 343,
 344, 345, 346, 347, 348, 349, 350, 351, 352, 353,
 354, 355, 356, 357, 358, 359, 360, 361, 362, 363,
 364, 365, 366, 367, 368, 261, -1, 263, 264, 265,
 266, 267, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, 289, -1, 291, -1, 293, -1, 295,
 296, 297, 298, 299, -1, 301, 302, -1, -1, 305,
 306, 307, 308, 309, 310, 311, -1, -1, 314, -1,
 316, -1, 318, 319, 320, 321, -1, 323, 324, 325,
 326, 327, 328, 329, 330, 331, 332, 333, 334, 335,
 336, 337, 338, 339, 340, 341, 342, 343, 344, 345,
 346, 347, 348, 349, 350, 351, 352, 353, 354, 355,
 356, 357, 358, 359, 360, 361, 362, 363, 364, 365,
 366, 367, 368, -1, 261, -1, 263, 264, 265, 266,
 267, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, 289, -1, 291, -1, 293, -1, 295, 296,
 297, 298, 299, -1, 301, 302, -1, -1, 305, 306,
 307, 308, 309, 310, 311, -1, -1, 314, -1, 316,
 -1, 318, 319, 320, 321, -1, 323, 324, 325, 326,
 327, 328, 329, 330, 331, 332, 333, 334, 335, 336,
 337, 338, 339, 340, 341, 342, 343, 344, 345, 346,
 347, 348, 349, 350, 351, 352, 353, 354, 355, 356,
 357, 358, 359, 360, 361, 362, 363, 364, 365, 366,
 367, 368, 8, 0, -1, -1, -1, -1, -1, 15,
 -1, -1, -1, 10, 11, -1, 22, -1, -1, 16,
 17, -1, 19, 20, -1, -1, 23, 289, -1, 291,
 0, 293, -1, 295, 296, 297, 298, 299, -1, 301,
 302, 11, -1, 305, 306, 307, 308, 309, 310, 311,
 -1, -1, 314, -1, 316, -1, 318, 319, 320, 321,
 -1, 323, 324, 325, 326, 327, 328, 329, 330, 331,
 332, 333, 334, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, 95,
 96, 97, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, 119, -1, -1, -1, -1, -1, -1,
 -1, 127, -1, -1, -1, 131, 132, 133, -1, -1,
 136, 137, 138, -1, -1, -1, -1, 134, -1, 145,
 146, 147, 148, 149, 150, 151, 152, -1, 154, 155,
 156, 157, -1, -1, 160, -1, 162, 163, -1, 165,
 -1, 167, -1, 133, -1, -1, 172, -1, -1, -1,
 -1, -1, -1, -1, 171, -1, 173, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 165, -1, -1, -1, -1,
 -1, -1, 172, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, 224, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, 225, -1,
 -1, -1, -1, 239, 240, -1, 242, 243, 235, -1,
 -1, -1, -1, -1, -1, -1, -1, 244, -1, -1,
 256, -1, -1, 259, -1, 225, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 235, 263, -1, 265, 239,
 240, -1, 242, 243, 244, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, 256, 293,
};
#define YYFINAL 98
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 380
#if YYDEBUG
char *yyname[] =
{
  "end-of-file", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  "'!'", 0, 0, 0, 0, 0, 0, "'('", "')'", "'*'", "'+'", "','", "'-'", "'.'", "'/'", 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, "':'", "';'", 0, "'='", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, "DIGIT", "LETTER", "QUIT", "DEBUG", "INTEGER_CONSTANT",
  "CHARACTER_CONSTANT", "FLOATING_CONSTANT", "STRING_CONSTANT", "STRING_IDENTIFIER",
  "IDENTIFIER", "YY_CELL", "IF", "THEN", "ELSE", "FOR", "DO", "WHILE", "TO", "STEP",
  "CONTINUE", "BREAK", "RETURN", "GOTO", "SUB", "END", "CALL", "FUNCTION", "SWITCH",
  "PRINT", "NEXT", "SYSTEM", "PRINTOUT", "WORKBOOKS", "WORKBOOK_OBJ", "WORKSHEETS",
  "WORKSHEET_OBJ", "CELLS", "CELL_OBJ", "FORMULA", "LINESTYLE", "BORDERS", "RANGE",
  "NUMBERFORMAT", "SELECT", "SELECTION", "CHARTOBJECTS", "ADD", "CHART", "AXES",
"HASMAJORGRIDLINES", "HASTITLE", "TEXT", "CHARTTITLE", "AXISTITLE", "SHAPES",
  "ADDLINE", "ADDSHAPE", "ACTIVECHART", "ACTIVECELL", "ACTIVESHEET", "SETSOURCEDATA",
  "SOURCE", "SERIESCOLLECTION", "VALUES", "NAME", "SERIE", "CHARTTYPE", "FONT", "SIZE",
"ITALIC", "BOLD", "INTERIOR", "COLORINDEX", "HORIZONTALALIGNMENT", "COLUMNS",
"COLUMNWIDTH", "ROWS", "ROWHEIGHT", "ACOS", "ASIN", "ATAN", "ATAN2", "CEIL",
  "CONCATENATE", "COS", "COSH", "EPT", "EXP", "FABS", "FLOOR", "FMOD", "FREXP", "GPD",
  "GPF", "LDEXP", "LOG", "LOG10", "absMAX", "absMIN", "MODF", "MAXMEAN", "ORDER", "POW",
  "SEND", "SIN", "SINH", "SPAWN", "SQRT", "SUM", "RECEIVE", "TAN", "TANH", "ACTIVATE",
  "CREATE", "EQ", "NE", "LE", "LT", "GT", "GE", "OR", "AND", "NEWLINE", "UMINUS",
};
char *yyrule[] =
{
  "$accept : list",
  "list : stat",
  "list : stat NEWLINE",
  "list : error",
  "list : error NEWLINE",
  "list : NEWLINE",
  "stat : expr_stat",
  "stat : select_stat",
  "stat : iter_stat",
  "stat : jump_stat",
  "select_stat : IF expr THEN",
  "select_stat : ELSE",
  "select_stat : SWITCH '(' expr ')' stat",
  "iter_stat : WHILE '(' expr ')' stat",
  "iter_stat : DO stat WHILE '(' expr ')' ';'",
  "iter_stat : FOR identifier '=' expr TO expr",
  "iter_stat : FOR identifier '=' expr TO expr STEP expr",
  "iter_stat : NEXT",
  "iter_stat : NEXT identifier",
  "jump_stat : SUB identifier",
  "jump_stat : SUB identifier '(' ')'",
  "jump_stat : SUB identifier '(' identifier ')'",
  "jump_stat : SUB identifier '(' identifier_list ')'",
  "jump_stat : FUNCTION identifier '(' ')'",
  "jump_stat : FUNCTION identifier '(' identifier ')'",
  "jump_stat : FUNCTION identifier '(' identifier_list ')'",
  "jump_stat : END SUB",
  "jump_stat : END FUNCTION",
  "jump_stat : CALL identifier '(' expr_list ')'",
  "jump_stat : CALL identifier '(' expr ')'",
  "jump_stat : CALL identifier '(' ')'",
  "jump_stat : CALL identifier",
  "jump_stat : GOTO identifier",
  "jump_stat : CONTINUE",
  "jump_stat : BREAK",
  "jump_stat : RETURN",
  "jump_stat : RETURN expr ';'",
  "expr_stat : expr NEWLINE",
  "expr_stat : identifier '=' expr NEWLINE",
  "expr_stat : cl '=' expr NEWLINE",
  "expr_stat : object '=' expr NEWLINE",
  "expr_stat : expr objectinit NEWLINE",
  "expr_stat : PRINT expr NEWLINE",
  "$$1 :",
  "expr_stat : SYSTEM '(' string ')' NEWLINE $$1 keyword",
  "expr_list : expr ',' expr",
  "expr_list : expr ';' expr",
  "expr_list : expr_list ',' expr",
  "expr_list : expr_list ';' expr",
  "expr_list : expr ',' range",
  "expr_list : expr ';' range",
  "expr_list : expr_list ',' range",
  "expr_list : expr_list ';' range",
  "expr_list : range",
  "expr : expr LT expr",
  "expr : expr LE expr",
  "expr : expr GT expr",
  "expr : expr GE expr",
  "expr : expr EQ expr",
  "expr : expr NE expr",
  "expr : expr AND expr",
  "expr : expr OR expr",
  "expr : expr '*' expr",
  "expr : expr '/' expr",
  "expr : expr '+' expr",
  "expr : '+' expr",
  "expr : expr '-' expr",
  "expr : '-' expr",
  "expr : '(' expr ')'",
  "expr : object '.' memberfunction '(' expr_list ')'",
  "expr : object '.' memberfunction '(' expr ')'",
  "expr : object '.' memberfunction '(' ')'",
  "expr : object '.' memberfunction",
  "expr : function '(' ')'",
  "expr :",
  "expr : function '(' expr ')'",
  "expr : function '(' expr_list ')'",
  "expr : identifier",
  "expr : reel",
  "expr : string",
  "expr : cl",
  "reel : INTEGER_CONSTANT",
  "reel : FLOATING_CONSTANT",
  "reel : object",
  "range : cl ':' cl",
  "cl : YY_CELL",
  "cl : identifier '!' YY_CELL",
  "string : STRING_CONSTANT",
  "string : STRING_IDENTIFIER",
  "identifier_list : identifier ',' identifier",
  "identifier_list : identifier_list ',' identifier",
  "identifier : IDENTIFIER",
  "keyword : QUIT",
  "keyword : DEBUG",
  "objectinit : object ':' '=' object",
  "object : baseobject",
  "object : object '.' baseobject",
  "baseobject : WORKBOOKS '(' expr ')'",
  "baseobject : WORKSHEETS '(' expr ')'",
  "baseobject : WORKSHEETS",
  "baseobject : CHARTOBJECTS",
  "baseobject : CHARTOBJECTS '(' expr ')'",
  "baseobject : SERIESCOLLECTION '(' expr ')'",
  "baseobject : AXES '(' expr ')'",
  "baseobject : HASMAJORGRIDLINES",
  "baseobject : HASTITLE",
  "baseobject : CHARTTITLE",
  "baseobject : AXISTITLE",
  "baseobject : TEXT",
  "baseobject : ACTIVECHART",
  "baseobject : ACTIVESHEET",
  "baseobject : CELLS '(' expr_list ')'",
  "baseobject : FORMULA",
  "baseobject : NUMBERFORMAT",
  "baseobject : LINESTYLE",
  "baseobject : BORDERS '(' identifier ')'",
  "baseobject : BORDERS",
  "baseobject : RANGE '(' string ')'",
  "baseobject : SELECTION",
  "baseobject : SOURCE",
  "baseobject : NAME",
  "baseobject : VALUES",
  "baseobject : CHARTTYPE",
  "baseobject : FONT",
  "baseobject : BOLD",
  "baseobject : SIZE",
  "baseobject : ITALIC",
  "baseobject : INTERIOR",
  "baseobject : COLORINDEX",
  "baseobject : HORIZONTALALIGNMENT",
  "baseobject : COLUMNS '(' string ')'",
  "baseobject : COLUMNWIDTH",
  "baseobject : ROWS '(' string ')'",
  "baseobject : ROWHEIGHT",
  "baseobject : SHAPES",
  "memberfunction : ACTIVATE",
  "memberfunction : ADD",
  "memberfunction : ADDLINE",
  "memberfunction : ADDSHAPE",
  "memberfunction : CREATE",
  "memberfunction : PRINTOUT",
  "memberfunction : SELECT",
  "memberfunction : SETSOURCEDATA",
  "function : absMIN",
  "function : absMAX",
  "function : MAXMEAN",
  "function : SUM",
  "function : GPF",
  "function : GPD",
  "function : EPT",
  "function : ACOS",
  "function : ASIN",
  "function : ATAN2",
  "function : ATAN",
  "function : CEIL",
  "function : COS",
  "function : COSH",
  "function : EXP",
  "function : FABS",
  "function : FLOOR",
  "function : FMOD",
  "function : FREXP",
  "function : LDEXP",
  "function : LOG",
  "function : LOG10",
  "function : MODF",
  "function : ORDER",
  "function : POW",
  "function : SEND",
  "function : SIN",
  "function : SINH",
  "function : SPAWN",
  "function : SQRT",
  "function : RECEIVE",
  "function : TAN",
  "function : TANH",
  "function : CONCATENATE",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1061 "calcy.y"

yyerror (s)
     char *s;
{
  error_in_parser ();
  lexecho ();
}

yywrap ()
{
  return (1);
}

#line 1256 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse ()
{
  register int yym, yyn, yystate;
#if YYDEBUG
  register char *yys;
  extern char *getenv ();

  if (yys = getenv ("YYDEBUG"))
    {
      yyn = *yys;
      if (yyn >= '0' && yyn <= '9')
	yydebug = yyn - '0';
    }
#endif

  yynerrs = 0;
  yyerrflag = 0;
  yychar = (-1);

  yyssp = yyss;
  yyvsp = yyvs;
  *yyssp = yystate = 0;

yyloop:
  if (yyn = yydefred[yystate])
    goto yyreduce;
  if (yychar < 0)
    {
      if ((yychar = yylex ()) < 0)
	yychar = 0;
#if YYDEBUG
      if (yydebug)
	{
	  yys = 0;
	  if (yychar <= YYMAXTOKEN)
	    yys = yyname[yychar];
	  if (!yys)
	    yys = "illegal-symbol";
	  printf ("%sdebug: state %d, reading %d (%s)\n",
		  YYPREFIX, yystate, yychar, yys);
	}
#endif
    }
  if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
      if (yydebug)
	printf ("%sdebug: state %d, shifting to state %d\n",
		YYPREFIX, yystate, yytable[yyn]);
#endif
      if (yyssp >= yyss + yystacksize - 1)
	{
	  goto yyoverflow;
	}
      *++yyssp = yystate = yytable[yyn];
      *++yyvsp = yylval;
      yychar = (-1);
      if (yyerrflag > 0)
	--yyerrflag;
      goto yyloop;
    }
  if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
      yyn = yytable[yyn];
      goto yyreduce;
    }
  if (yyerrflag)
    goto yyinrecovery;
#ifdef lint
  goto yynewerror;
#endif
yynewerror:
  yyerror ("syntax error");
#ifdef lint
  goto yyerrlab;
#endif
yyerrlab:
  ++yynerrs;
yyinrecovery:
  if (yyerrflag < 3)
    {
      yyerrflag = 3;
      for (;;)
	{
	  if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
	      yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
	    {
#if YYDEBUG
	      if (yydebug)
		printf ("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
	      if (yyssp >= yyss + yystacksize - 1)
		{
		  goto yyoverflow;
		}
	      *++yyssp = yystate = yytable[yyn];
	      *++yyvsp = yylval;
	      goto yyloop;
	    }
	  else
	    {
#if YYDEBUG
	      if (yydebug)
		printf ("%sdebug: error recovery discarding state %d\n",
			YYPREFIX, *yyssp);
#endif
	      if (yyssp <= yyss)
		goto yyabort;
	      --yyssp;
	      --yyvsp;
	    }
	}
    }
  else
    {
      if (yychar == 0)
	goto yyabort;
#if YYDEBUG
      if (yydebug)
	{
	  yys = 0;
	  if (yychar <= YYMAXTOKEN)
	    yys = yyname[yychar];
	  if (!yys)
	    yys = "illegal-symbol";
	  printf ("%sdebug: state %d, error recovery discards token %d (%s)\n",
		  YYPREFIX, yystate, yychar, yys);
	}
#endif
      yychar = (-1);
      goto yyloop;
    }
yyreduce:
#if YYDEBUG
  if (yydebug)
    printf ("%sdebug: state %d, reducing by rule %d (%s)\n",
	    YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
  yym = yylen[yyn];
  yyval = yyvsp[1 - yym];
  switch (yyn)
    {
    case 1:
#line 110 "calcy.y"
      {
	flushos ();
	stack_flush (s);
	return 0;
      }
      break;
    case 2:
#line 115 "calcy.y"
      {
	flushos ();
	stack_flush (s);
	return 0;
      }
      break;
    case 3:
#line 120 "calcy.y"
      {
	flushos ();
	stack_flush (s);
	yyerrok;
	return 1;
      }
      break;
    case 4:
#line 127 "calcy.y"
      {
	flushos ();
	stack_flush (s);
	yyerrok;
	return 1;
      }
      break;
    case 5:
#line 134 "calcy.y"
      {
	flushos ();
	stack_flush (s);
	return 1;
      }
      break;
    case 6:
#line 143 "calcy.y"
      {

      }
      break;
    case 7:
#line 148 "calcy.y"
      {

      }
      break;
    case 8:
#line 153 "calcy.y"
      {

      }
      break;
    case 9:
#line 158 "calcy.y"
      {

      }
      break;
    case 10:
#line 164 "calcy.y"
      {
	obj o = stack_pop (s);
	enterif (o.rec.d);
      }
      break;
    case 11:
#line 169 "calcy.y"
      {
	enterelse ();
      }
      break;
    case 12:
#line 174 "calcy.y"
      {

      }
      break;
    case 13:
#line 181 "calcy.y"
      {

      }
      break;
    case 14:
#line 186 "calcy.y"
      {

      }
      break;
    case 15:
#line 191 "calcy.y"
      {
	obj o1, o2;
	o2 = stack_pop (s);
	o1 = stack_pop (s);
	enterloop (yyvsp[-4], obj2double (o1), obj2double (o2), 1.0);
      }
      break;
    case 16:
#line 198 "calcy.y"
      {
	obj o1, o2, o3;
	o3 = stack_pop (s);
	o2 = stack_pop (s);
	o1 = stack_pop (s);
	enterloop (yyvsp[-6], obj2double (o1), obj2double (o2), obj2double (o3));
      }
      break;
    case 17:
#line 207 "calcy.y"
      {
	nextloop (0);
      }
      break;
    case 18:
#line 212 "calcy.y"
      {
	nextloop (yyvsp[0]);
      }
      break;
    case 19:
#line 219 "calcy.y"
      {
	addroutine (yyvsp[0], 0, listid);
      }
      break;
    case 20:
#line 223 "calcy.y"
      {
	addroutine (yyvsp[-2], 0, listid);
      }
      break;
    case 21:
#line 227 "calcy.y"
      {
	listid[0] = yyvsp[-1];
	addroutine (yyvsp[-3], 1, listid);
      }
      break;
    case 22:
#line 232 "calcy.y"
      {
	addroutine (yyvsp[-3], idnum, listid);
      }
      break;
    case 23:
#line 236 "calcy.y"
      {
	addroutine (yyvsp[-2], 0, listid);
      }
      break;
    case 24:
#line 240 "calcy.y"
      {
	listid[0] = yyvsp[-1];
	addroutine (yyvsp[-3], 1, listid);
      }
      break;
    case 25:
#line 245 "calcy.y"
      {
	addroutine (yyvsp[-3], idnum, listid);
      }
      break;
    case 26:
#line 249 "calcy.y"
      {
	addreturn ();
      }
      break;
    case 27:
#line 254 "calcy.y"
      {
	addreturn ();
      }
      break;
    case 28:
#line 259 "calcy.y"
      {
	obj o;
	for (i = yyvsp[-1] - 1; i >= 0; i--)
	  {
	    o = stack_pop (s);
	    arglist[i] = o;
	  }
	callroutine2 (yyvsp[-3], arglist, yyvsp[-1]);
      }
      break;
    case 29:
#line 268 "calcy.y"
      {
	obj o = stack_pop (s);
	arglist[0] = o;
	callroutine2 (yyvsp[-3], arglist, 1);
      }
      break;
    case 30:
#line 274 "calcy.y"
      {
	callroutine2 (yyvsp[-2], arglist, 0);
      }
      break;
    case 31:
#line 279 "calcy.y"
      {
	callroutine2 (yyvsp[0], arglist, 0);
      }
      break;
    case 32:
#line 284 "calcy.y"
      {

      }
      break;
    case 33:
#line 289 "calcy.y"
      {

      }
      break;
    case 34:
#line 294 "calcy.y"
      {

      }
      break;
    case 35:
#line 299 "calcy.y"
      {

      }
      break;
    case 36:
#line 304 "calcy.y"
      {

      }
      break;
    case 37:
#line 310 "calcy.y"
      {
	obj o;
	if (!isinmacro ())
	  {
	    o = stack_pop (s);
	    switch (o.type)
	      {
	      case STRING_CONSTANT:
		settext (o.rec.s);
		break;
	      case FLOATING_CONSTANT:
		setval (o.rec.d);
		break;
	      case INTEGER_CONSTANT:
		setval (o.rec.i);
		break;
	      }
	  }
      }
      break;
    case 38:
#line 323 "calcy.y"
      {
	obj o = stack_pop (s);
	setidval3 (yyvsp[-3], o);
      }
      break;
    case 39:
#line 338 "calcy.y"
      {
	obj o = stack_pop (s);
	switch (o.type)
	  {
	  case STRING_CONSTANT:
	    setobjectstring (yyvsp[-3], o.rec.s);
	    break;
	  case FLOATING_CONSTANT:
	    setobjectval (yyvsp[-3], o.rec.d);
	    break;
	  case INTEGER_CONSTANT:
	    setobjectval (yyvsp[-3], o.rec.i);
	    break;
	  }
      }
      break;
    case 40:
#line 347 "calcy.y"
      {
	obj o = stack_pop (s);
	switch (o.type)
	  {
	  case STRING_CONSTANT:
	    setobjectstring (yyvsp[-3], o.rec.s);
	    break;
	  case FLOATING_CONSTANT:
	    setobjectval (yyvsp[-3], o.rec.d);
	    break;
	  case INTEGER_CONSTANT:
	    setobjectval (yyvsp[-3], o.rec.i);
	    break;
	  }
      }
      break;
    case 41:
#line 356 "calcy.y"
      {
      }
      break;
    case 42:
#line 360 "calcy.y"
      {
	obj o = stack_pop (s);
	printobj (o);
      }
      break;
    case 43:
#line 366 "calcy.y"
      {
	obj o = stack_pop (s);
	execsystem (obj2string (o));
      }
      break;
    case 44:
#line 370 "calcy.y"
      {
      }
      break;
    case 45:
#line 392 "calcy.y"
      {
	yyval = 2;
      }
      break;
    case 46:
#line 397 "calcy.y"
      {
	yyval = 2;
      }
      break;
    case 47:
#line 401 "calcy.y"
      {
	yyval = yyvsp[-2] + 1;

      }
      break;
    case 48:
#line 406 "calcy.y"
      {
	yyval = yyvsp[-2] + 1;
      }
      break;
    case 49:
#line 410 "calcy.y"
      {
	obj o;
	yyval = 1 + yyvsp[0];
	i = 0;
	while (getrangeval (i, &tmp))
	  {
	    o.rec.d = tmp;
	    o.type = FLOATING_CONSTANT;
	    s = stack_push (s, o);
	    yyval = yyval + 1;
	    i++;
	  }
      }
      break;
    case 50:
#line 423 "calcy.y"
      {
	obj o;
	yyval = 1 + yyvsp[0];
	i = 0;
	while (getrangeval (i, &tmp))
	  {
	    o.rec.d = tmp;
	    o.type = FLOATING_CONSTANT;
	    s = stack_push (s, o);
	    yyval = yyval + 1;
	    i++;
	  }
      }
      break;
    case 51:
#line 437 "calcy.y"
      {
	obj o;
	yyval = yyvsp[-2] + yyvsp[0];
	i = 0;
	while (getrangeval (i, &tmp))
	  {
	    o.rec.d = tmp;
	    o.type = FLOATING_CONSTANT;
	    s = stack_push (s, o);
	    yyval = yyval + 1;
	    i++;
	  }
      }
      break;
    case 52:
#line 451 "calcy.y"
      {
	obj o;
	yyval = yyvsp[-2] + yyvsp[0];
	i = 0;
	while (getrangeval (i, &tmp))
	  {
	    o.rec.d = tmp;
	    o.type = FLOATING_CONSTANT;
	    s = stack_push (s, o);
	    yyval = yyval + 1;
	    i++;
	  }
      }
      break;
    case 53:
#line 465 "calcy.y"
      {
	obj o;
	yyval = 0;
	i = 0;
	while (getrangeval (i, &tmp))
	  {
	    o.rec.d = tmp;
	    o.type = FLOATING_CONSTANT;
	    s = stack_push (s, o);
	    yyval = yyval + 1;
	    i++;
	  }
      }
      break;
    case 54:
#line 479 "calcy.y"
      {
	makelt (s);
      }
      break;
    case 55:
#line 484 "calcy.y"
      {
	makele (s);
      }
      break;
    case 56:
#line 489 "calcy.y"
      {
	makegt (s);
      }
      break;
    case 57:
#line 494 "calcy.y"
      {
	makege (s);
      }
      break;
    case 58:
#line 499 "calcy.y"
      {
	makeeq (s);
      }
      break;
    case 59:
#line 504 "calcy.y"
      {
	makene (s);
      }
      break;
    case 60:
#line 509 "calcy.y"
      {
	makeand (s);
      }
      break;
    case 61:
#line 514 "calcy.y"
      {
	makeor (s);
      }
      break;
    case 62:
#line 519 "calcy.y"
      {
	makemult (s);
      }
      break;
    case 63:
#line 524 "calcy.y"
      {
	makediv (s);
      }
      break;
    case 64:
#line 529 "calcy.y"
      {
	makesum (s);
      }
      break;
    case 65:
#line 534 "calcy.y"
      {
      }
      break;
    case 66:
#line 538 "calcy.y"
      {
	makediff (s);
      }
      break;
    case 67:
#line 543 "calcy.y"
      {
	makeinv (s);
      }
      break;
    case 68:
#line 548 "calcy.y"
      {
      }
      break;
    case 69:
#line 552 "calcy.y"
      {
	memberfct (s, yyvsp[-5], yyvsp[-3], yyvsp[-1]);
      }
      break;
    case 70:
#line 557 "calcy.y"
      {
	memberfct (s, yyvsp[-5], yyvsp[-3], 1);
      }
      break;
    case 71:
#line 562 "calcy.y"
      {
	memberfct (s, yyvsp[-4], yyvsp[-2], 0);
      }
      break;
    case 72:
#line 567 "calcy.y"
      {
	memberfct (s, yyvsp[-2], yyvsp[0], 0);
      }
      break;
    case 73:
#line 572 "calcy.y"
      {
	makefct (s, yyvsp[-2], 0);
      }
      break;
    case 75:
#line 577 "calcy.y"
      {
	makefct (s, yyvsp[-3], 1);
      }
      break;
    case 76:
#line 581 "calcy.y"
      {
	makefct (s, yyvsp[-3], yyvsp[-1]);
      }
      break;
    case 77:
#line 617 "calcy.y"
      {
	obj o;
	o = getidval3 (yyvsp[0]);
	s = stack_push (s, o);
	yyval = yyvsp[0];
      }
      break;
    case 78:
#line 624 "calcy.y"
      {
      }
      break;
    case 79:
#line 628 "calcy.y"
      {
      }
      break;
    case 80:
#line 632 "calcy.y"
      {
      }
      break;
    case 81:
#line 637 "calcy.y"
      {
	obj o;
	tmp = getint ();

	o.type = FLOATING_CONSTANT;
	o.rec.d = tmp;
	s = stack_push (s, o);
      }
      break;
    case 82:
#line 647 "calcy.y"
      {
	obj o;
	tmp = getfloat ();
	o.type = FLOATING_CONSTANT;
	o.rec.d = tmp;
	s = stack_push (s, o);
      }
      break;
    case 83:
#line 655 "calcy.y"
      {
	obj o;
	tmp = getobjectval (yyvsp[0]);
	o.type = FLOATING_CONSTANT;
	o.rec.d = tmp;
	s = stack_push (s, o);
	yyval = yyvsp[0];

      }
      break;
    case 84:
#line 667 "calcy.y"
      {
	putrange (NULL);
      }
      break;
    case 85:
#line 672 "calcy.y"
      {
	obj o;
	if (clistext ())
	  {
	    yyval = clputtext ();
	    o.type = STRING_CONSTANT;
	    o.rec.s = getstackstr (yyval);
	    s = stack_push (s, o);
	  }
	else
	  {
	    o.type = FLOATING_CONSTANT;
	    o.rec.d = getclval ();
	    s = stack_push (s, o);
	  }

	yyval = putcl2 (0);
      }
      break;
    case 86:
#line 690 "calcy.y"
      {
	obj o;
	if (wsclistext ())
	  {
	    yyval = wsclputtext ();
	    o.type = STRING_CONSTANT;
	    o.rec.s = getstackstr (yyval);
	    s = stack_push (s, o);
	  }
	else
	  {
	    o.type = FLOATING_CONSTANT;
	    o.rec.d = wsgetclval ();
	    s = stack_push (s, o);
	  }
	yyval = putcl2 (1);

      }
      break;
    case 87:
#line 708 "calcy.y"
      {
	obj o;
	yyval = putstring ();
	o.type = STRING_CONSTANT;
	o.rec.s = getstackstr (yyval);
	s = stack_push (s, o);
      }
      break;
    case 88:
#line 716 "calcy.y"
      {
	obj o;
	yyval = putidstring ();
	o.type = STRING_CONSTANT;
	o.rec.s = getstackstr (yyval);
	s = stack_push (s, o);

      }
      break;
    case 89:
#line 727 "calcy.y"
      {
	idnum = 0;
	listid[0] = yyvsp[-2];
	idnum++;
	listid[1] = yyvsp[0];
	idnum++;
      }
      break;
    case 90:
#line 734 "calcy.y"
      {
	listid[idnum] = yyvsp[0];
	idnum++;

      }
      break;
    case 91:
#line 741 "calcy.y"
      {
	yyval = getidpos ();
      }
      break;
    case 92:
#line 747 "calcy.y"
      {
	yyval = -1;
      }
      break;
    case 93:
#line 752 "calcy.y"
      {
	yyval = -4;
	yydebug = 1;
	setdebug ();
      }
      break;
    case 94:
#line 757 "calcy.y"
      {
	initobject (yyvsp[-3], yyvsp[0]);
      }
      break;
    case 95:
#line 763 "calcy.y"
      {
	yyval = yyvsp[0];
      }
      break;
    case 96:
#line 768 "calcy.y"
      {
	yyval = dereference (yyvsp[-2], yyvsp[0]);
      }
      break;
    case 97:
#line 774 "calcy.y"
      {
	obj o = stack_pop (s);
	switch (o.type)
	  {
	  case FLOATING_CONSTANT:
	    yyval = putwkb (o.rec.d);
	    break;
	  case STRING_CONSTANT:
	    yyval = putwkb2 (o.rec.s);
	    break;
	  }
      }
      break;
    case 98:
#line 782 "calcy.y"
      {
	obj o = stack_pop (s);
	switch (o.type)
	  {
	  case FLOATING_CONSTANT:
	    yyval = putwks (o.rec.d);
	    break;
	  case STRING_CONSTANT:
	    yyval = putwks2 (o.rec.s);
	    break;
	  }
      }
      break;
    case 99:
#line 790 "calcy.y"
      {
	yyval = putwks3 ();
      }
      break;
    case 100:
#line 795 "calcy.y"
      {
	yyval = putobj (CHARTOBJECTS);
      }
      break;
    case 101:
#line 800 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putcht (o.rec.d);
      }
      break;
    case 102:
#line 805 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putserie (o.rec.d);
      }
      break;
    case 103:
#line 810 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putaxes (o.rec.d);
      }
      break;
    case 104:
#line 815 "calcy.y"
      {
	yyval = putobj (HASMAJORGRIDLINES);
      }
      break;
    case 105:
#line 820 "calcy.y"
      {
	yyval = putobj (HASTITLE);
      }
      break;
    case 106:
#line 825 "calcy.y"
      {
	yyval = putobj (CHARTTITLE);
      }
      break;
    case 107:
#line 830 "calcy.y"
      {
	yyval = putobj (AXISTITLE);
      }
      break;
    case 108:
#line 835 "calcy.y"
      {
	yyval = putobj (TEXT);
      }
      break;
    case 109:
#line 840 "calcy.y"
      {
	yyval = putcht (-1);
      }
      break;
    case 110:
#line 845 "calcy.y"
      {
	yyval = putwks (-1);
      }
      break;
    case 111:
#line 850 "calcy.y"
      {
	obj o1, o2;
	o2 = stack_pop (s);
	o1 = stack_pop (s);
	yyval = putcl (o1.rec.d, o2.rec.d);
      }
      break;
    case 112:
#line 857 "calcy.y"
      {
	yyval = putform ();
      }
      break;
    case 113:
#line 862 "calcy.y"
      {
	yyval = putnumberformat ();
      }
      break;
    case 114:
#line 867 "calcy.y"
      {
	yyval = putobj (LINESTYLE);
      }
      break;
    case 115:
#line 872 "calcy.y"
      {
	yyval = putbord (getidval2 (yyvsp[-1]));
      }
      break;
    case 116:
#line 877 "calcy.y"
      {
	yyval = putbord (0.0);
      }
      break;
    case 117:
#line 882 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putrange (o.rec.s);
      }
      break;
    case 118:
#line 887 "calcy.y"
      {
	yyval = putobj (SELECTION);
      }
      break;
    case 119:
#line 892 "calcy.y"
      {
	yyval = putobj (SOURCE);
      }
      break;
    case 120:
#line 897 "calcy.y"
      {
	yyval = putobj (NAME);
      }
      break;
    case 121:
#line 902 "calcy.y"
      {
	yyval = putobj (VALUES);
      }
      break;
    case 122:
#line 907 "calcy.y"
      {
	yyval = putobj (CHARTTYPE);
      }
      break;
    case 123:
#line 912 "calcy.y"
      {
	yyval = putobj (FONT);
      }
      break;
    case 124:
#line 917 "calcy.y"
      {
	yyval = putobj (BOLD);
      }
      break;
    case 125:
#line 922 "calcy.y"
      {
	yyval = putobj (SIZE);
      }
      break;
    case 126:
#line 927 "calcy.y"
      {
	yyval = putobj (ITALIC);
      }
      break;
    case 127:
#line 932 "calcy.y"
      {
	yyval = putobj (INTERIOR);
      }
      break;
    case 128:
#line 937 "calcy.y"
      {
	yyval = putobj (COLORINDEX);
      }
      break;
    case 129:
#line 942 "calcy.y"
      {
	yyval = putobj (HORIZONTALALIGNMENT);
      }
      break;
    case 130:
#line 947 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putcolumn (o.rec.s);
      }
      break;
    case 131:
#line 952 "calcy.y"
      {
	yyval = putobj (COLUMNWIDTH);
      }
      break;
    case 132:
#line 957 "calcy.y"
      {
	obj o = stack_pop (s);
	yyval = putrow (o.rec.s);
      }
      break;
    case 133:
#line 962 "calcy.y"
      {
	yyval = putobj (ROWHEIGHT);
      }
      break;
    case 134:
#line 967 "calcy.y"
      {
	yyval = putobj (SHAPES);
      }
      break;
    case 135:
#line 974 "calcy.y"
      {
	yyval = ACTIVATE;
      }
      break;
    case 136:
#line 976 "calcy.y"
      {
	yyval = ADD;
      }
      break;
    case 137:
#line 978 "calcy.y"
      {
	yyval = ADDLINE;
      }
      break;
    case 138:
#line 980 "calcy.y"
      {
	yyval = ADDSHAPE;
      }
      break;
    case 139:
#line 982 "calcy.y"
      {
	yyval = CREATE;
      }
      break;
    case 140:
#line 984 "calcy.y"
      {
	yyval = PRINTOUT;
      }
      break;
    case 141:
#line 986 "calcy.y"
      {
	yyval = SELECT;
      }
      break;
    case 142:
#line 988 "calcy.y"
      {
	yyval = SETSOURCEDATA;
      }
      break;
    case 143:
#line 992 "calcy.y"
      {
	yyval = absMIN;
      }
      break;
    case 144:
#line 994 "calcy.y"
      {
	yyval = absMAX;
      }
      break;
    case 145:
#line 996 "calcy.y"
      {
	yyval = MAXMEAN;
      }
      break;
    case 146:
#line 998 "calcy.y"
      {
	yyval = SUM;
      }
      break;
    case 147:
#line 1000 "calcy.y"
      {
	yyval = GPF;
      }
      break;
    case 148:
#line 1002 "calcy.y"
      {
	yyval = GPD;
      }
      break;
    case 149:
#line 1004 "calcy.y"
      {
	yyval = EPT;
      }
      break;
    case 150:
#line 1006 "calcy.y"
      {
	yyval = ACOS;
      }
      break;
    case 151:
#line 1008 "calcy.y"
      {
	yyval = ASIN;
      }
      break;
    case 152:
#line 1010 "calcy.y"
      {
	yyval = ATAN2;
      }
      break;
    case 153:
#line 1012 "calcy.y"
      {
	yyval = ATAN;
      }
      break;
    case 154:
#line 1014 "calcy.y"
      {
	yyval = CEIL;
      }
      break;
    case 155:
#line 1016 "calcy.y"
      {
	yyval = COS;
      }
      break;
    case 156:
#line 1018 "calcy.y"
      {
	yyval = COSH;
      }
      break;
    case 157:
#line 1020 "calcy.y"
      {
	yyval = EXP;
      }
      break;
    case 158:
#line 1022 "calcy.y"
      {
	yyval = FABS;
      }
      break;
    case 159:
#line 1024 "calcy.y"
      {
	yyval = FLOOR;
      }
      break;
    case 160:
#line 1026 "calcy.y"
      {
	yyval = FMOD;
      }
      break;
    case 161:
#line 1028 "calcy.y"
      {
	yyval = FREXP;
      }
      break;
    case 162:
#line 1030 "calcy.y"
      {
	yyval = LDEXP;
      }
      break;
    case 163:
#line 1032 "calcy.y"
      {
	yyval = LOG;
      }
      break;
    case 164:
#line 1034 "calcy.y"
      {
	yyval = LOG10;
      }
      break;
    case 165:
#line 1036 "calcy.y"
      {
	yyval = MODF;
      }
      break;
    case 166:
#line 1038 "calcy.y"
      {
	yyval = ORDER;
      }
      break;
    case 167:
#line 1040 "calcy.y"
      {
	yyval = POW;
      }
      break;
    case 168:
#line 1042 "calcy.y"
      {
	yyval = SEND;
      }
      break;
    case 169:
#line 1044 "calcy.y"
      {
	yyval = SIN;
      }
      break;
    case 170:
#line 1046 "calcy.y"
      {
	yyval = SINH;
      }
      break;
    case 171:
#line 1048 "calcy.y"
      {
	yyval = SPAWN;
      }
      break;
    case 172:
#line 1050 "calcy.y"
      {
	yyval = SQRT;
      }
      break;
    case 173:
#line 1052 "calcy.y"
      {
	yyval = RECEIVE;
      }
      break;
    case 174:
#line 1054 "calcy.y"
      {
	yyval = TAN;
      }
      break;
    case 175:
#line 1056 "calcy.y"
      {
	yyval = TANH;
      }
      break;
    case 176:
#line 1058 "calcy.y"
      {
	yyval = CONCATENATE;
      }
      break;
#line 2479 "y.tab.c"
    }
  yyssp -= yym;
  yystate = *yyssp;
  yyvsp -= yym;
  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
      if (yydebug)
	printf ("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
      yystate = YYFINAL;
      *++yyssp = YYFINAL;
      *++yyvsp = yyval;
      if (yychar < 0)
	{
	  if ((yychar = yylex ()) < 0)
	    yychar = 0;
#if YYDEBUG
	  if (yydebug)
	    {
	      yys = 0;
	      if (yychar <= YYMAXTOKEN)
		yys = yyname[yychar];
	      if (!yys)
		yys = "illegal-symbol";
	      printf ("%sdebug: state %d, reading %d (%s)\n",
		      YYPREFIX, YYFINAL, yychar, yys);
	    }
#endif
	}
      if (yychar == 0)
	goto yyaccept;
      goto yyloop;
    }
  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
    yystate = yytable[yyn];
  else
    yystate = yydgoto[yym];
#if YYDEBUG
  if (yydebug)
    printf ("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
  if (yyssp >= yyss + yystacksize - 1)
    {
      goto yyoverflow;
    }
  *++yyssp = yystate;
  *++yyvsp = yyval;
  goto yyloop;
yyoverflow:
  yyerror ("yacc stack overflow");
yyabort:
  return (1);
yyaccept:
  return (0);
}
